'use strict';

var text = { },
    strings = { };

try {
    var iso6391 = (window.navigator.userLanguage || window.navigator.language);
    var code = iso6391.split('-')[0];
    if (code == 'zh' || code == 'pt') {
        text.languageCode = iso6391;
    } else if (code == 'es') {
        if (strings[iso6391]) {
            text.languageCode = iso6391;
        } else {
            text.languageCode = 'es-US';
        }
    } else {
        text.languageCode = code;
    }
} catch (e) {
    text.languageCode = 'en';
}

text.get = function(key) {
    var localized = strings[text.languageCode] || strings['en'];
    return localized[key] || strings['en'][key] || key;
};

strings["en"] = {
    "sign_in": "Sign in",
    "sign_out": "Sign out",
    "options": "Settings",
    "title_placeholder": "Title",
    "message_placeholder": "Type a message, press enter to send",
    "message_placeholder_link": "Add a message, press enter to send",
    "message_placeholder_files": "Type a message or drop a file",
    "url_placeholder": "Link url",
    "devices_placeholder": "Select a device",
    "recipient_placeholder": "To",
    "thanks_for_installing_title": "Thanks for installing Pushbullet",
    "thanks_for_installing_message": "Click here to get signed in",
    "updated_notif_title": "Pushbullet has updated!",
    "updated_notif_message": "Click here to see what's new",
    "dismiss": "Dismiss",
    "reply": "Reply",
    "mute": "Mute",
    "mute_app": "Mute {1} notifications",
    "muted_app": "Muted {1}",
    "unmute_app": "Unmute {1}",
    "mirror_context_message": "{1} via Pushbullet at {2}",
    "push_context_message": "{1} at {2}",
    "from": "From {1}",
    "go_to_link": "Go to link",
    "snooze": "Snooze 1hr",
    "unsnooze": "Unsnooze",
    "snoozing_desc": "Snoozing stops Pushbullet from showing your notifications for one hour.",
    "snoozed_until": "Snoozed until {1}.",
    "all_of_my_devices": "All of my devices",
    "add_a_friend": "Add a friend",
    "add_a_device": "Add a device",
    "panel_sign_up": "Sign up on Pushbullet.com →",
    "panel_cant_sign_in": "Can't get signed in? Try temporarily disabling Adblock. If that doesn't help, Pushbullet requires third-party cookies to be enabled to sign in. You can disable them again after getting signed-in.",
    "panel_third_party_cookies": "Click here for how to change this setting.",
    "general": "General",
    "notifications": "Notifications",
    "advanced": "Advanced",
    "how_to_unmute_app": "I muted an app, how do I unmute it?",
    "how_to_unmute_app_answer": "Open the Pushbullet Android app, pull out the drawer from the left, then tap 'Mirroring'. Here, tap 'Only for some apps', then re-enable the app.",
    "alert_desktop_app_notifications": "The Pushbullet desktop app is managing notifications.",
    "option_background_permission": "Keep Pushbullet running when my browser is closed",
    "option_background_permission_desc": "This will enable you to see your notifications without having to keep a browser window open.",
    "option_use_dark_icon": "Use dark icon",
    "option_use_dark_icon_desc": "This will make our toolbar icon a dark gray.",
    "option_notification_duration": "Hide notifications automatically after",
    "option_show_mirrors": "Show notifications on my computer",
    "option_show_mirrors_desc": "Unchecking this will stop us from showing notifications (you can still see a count in our toolbar icon).",
    "option_only_show_titles": "Only show notification titles",
    "option_only_show_titles_desc": "This will make Pushbullet only show the title of notifications, keeping the message private.",
    "option_play_sound": "Play a sound when a notification arrives",
    "option_play_sound_desc": "This will make Pushbullet play a short sound when a notification arrives, alerting you to it.",
    "option_open_my_pushes_automatically": "Open things I push to this browser automatically",
    "option_open_my_pushes_automatically_desc": "This will make Pushbullet open anything you push to this browser automatically in a new tab.",
    "option_show_context_menu": "Show Pushbullet in my browser context menu",
    "option_show_context_menu_desc": "Show Pushbullet in the list of right-click menu options.",
    "option_allow_instant_push": "Enable instant pushing to",
    "option_allow_instant_push_desc": "Push the current tab to the chosen device via keyboard shortcut.",
    "option_instant_push_shortcuts": "Click here to set (currently {1}).",
    "option_instant_push_shortcuts_not_set": "not set",
    "pushed_successfully": "Pushed successfully",
    "push_failed": "Sorry, we couldn't push that",
    "num_new_messages": "{1} new messages",
    "unsubscribe_from_channel": "Unfollow {1}",
    "unsubscribed_from_channel": "No longer following {1}",
    "undo": "Undo",
    "done": "Done",
    "type_file": "File",
    "type_link": "Link",
    "push_label": "Push",
    "sms": "SMS",
    "send": "Send",
    "sms_disclaimer": "Phone must be powered on and have an internet connection for the texts to send.",
    "changelog_tab": "What's New",
    "no_notifications": "No notifications right now",
    "option_clipboard_permission": "Universal copy & paste",
    "option_clipboard_permission_desc": "Copy text on one device, then paste it on any other that also has this setting enabled.",
    "option_show_notification_count": "Show notification count on toolbar icon",
    "option_show_notification_count_desc": "See your notification count at a glance in your toolbar.",
    "retry": "Retry",
    "clear": "Clear",
    "send_failed": "Send failed",
    "devices": "Devices",
    "friends": "Friends",
    "channels": "Channels",
    "no_pushes": "No recent history",
    "me": "Me",
    "add_link_tooltip": "Link current page",
    "remove_link_tooltip": "Un-link current page",
    "see_full_history": "See full history",
    "cancel": "Cancel",
    "device": "Device",
    "sms_recipient_placeholder": "Contact or phone number",
    "file_too_big": "File too big",
    "sending": "Sending...",
    "now": "Now",
    "phone": "Phone",
    "new_sms_thread": "New text message",
    "encryption_password_needed_title": "Encrypted data received",
    "encryption_password_needed_body": "Click here to enter your password",
    "decryption_failed_title": "Decryption failed",
    "decryption_failed_body": "Please confirm your password matches on all devices",
    "end_to_end_password_label": "End-to-end encryption password",
    "end_to_end_password_desc": "If you choose to enter a password, this password will need to be entered on each of your devices.",
    "save": "Save",
    "option_automatically_attach_link": "Automatically attach the current tab to messages to a device",
    "option_automatically_attach_link_desc": "This makes sending links to devices faster.",
    "learn_more": "Learn more",
    "pushbullet_pro_required": "Pushbullet Pro Required",
    "pushbullet_pro_feature": "Pushbullet Pro is required to enable this feature.",
    "reply_limit_warning": "You're getting close to the free message limit for this month.",
    "reply_limit_reached": "You've reached the free message limit for this month.",
    "reply_limit_upgrade": "Upgrade to Pushbullet Pro to send unlimited messages."
};

strings["el"] = {
    "mute": "Σίγαση", 
    "thanks_for_installing_message": "Κάντε κλικ εδώ για να συνδεθείτε", 
    "option_open_my_pushes_automatically_desc": "Αυτό θα κάνει το Pushbullet ν' ανοίγει αυτόματα σε νέα καρτέλα οτιδήποτε έχει προωθηθεί στον περιηγητή.", 
    "unsubscribed_from_channel": "Μη παρακολούθηση πλέον του {1}", 
    "option_show_context_menu": "Εμφάνιση του Pushbullet στο μενού περιβάλλοντος", 
    "option_use_dark_icon_desc": "Αυτό θα κάνει το εικονίδιο της γραμμής εργαλείων σκούρο γκρι.", 
    "alert_desktop_app_notifications": "Η εφαρμογή Pushbullet για υπολογιστές διαχειρίζεται ειδοποιήσεις.", 
    "sms_recipient_placeholder": "Επαφή ή αριθμό τηλεφώνου", 
    "message_placeholder_link": "Προσθέστε ένα μήνυμα, πατήστε enter για αποστολή", 
    "unsnooze": "Ακύρωση αναβολής", 
    "encryption_password_needed_body": "Πατήστε εδώ, για να εισάγετε τον κωδικό σας", 
    "send": "Αποστολή", 
    "pushbullet_pro_feature": "", 
    "save": "Αποθήκευση", 
    "option_instant_push_shortcuts_not_set": "δεν έχει οριστεί", 
    "send_failed": "Αποτυχία αποστολής", 
    "muted_app": "Σίγαση {1}", 
    "now": "Τώρα", 
    "no_notifications": "Καμία ειδοποίηση αυτή τη στιγμή", 
    "advanced": "Για προχωρημένους", 
    "channels": "Κανάλια", 
    "option_automatically_attach_link": "Αυτόματη επισύναψη της τρέχουσας καρτέλας σε μηνύματα μιας συσκευής", 
    "changelog_tab": "Τι νέο υπάρχει", 
    "snoozing_desc": "Η αναβολή αποτρέπει το Pushbullet από την εμφάνιση των ειδοποιήσεών σας για μία ώρα.", 
    "thanks_for_installing_title": "Ευχαριστούμε που εγκαταστήσατε το Pushbullet", 
    "how_to_unmute_app": "Έχω σε σίγαση μια εφαρμογή, πως την ενεργοποιώ;", 
    "title_placeholder": "Τίτλος", 
    "message_placeholder": "Πληκτρολογήστε το μήνυμα, πατήστε enter για αποστολή", 
    "updated_notif_message": "Κάντε κλικ εδώ για να δείτε τι νέο υπάρχει", 
    "unmute_app": "Κατάργηση Σίγασης {1}", 
    "type_file": "Αρχείο", 
    "panel_sign_up": "Εγγραφείτε στο Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Εισαγωγή υπερσύνδεσης", 
    "recipient_placeholder": "Πρός", 
    "retry": "\"Επανάληψη\"", 
    "option_play_sound": "Αναπαραγωγή ήχου όταν έρθει μια ειδοποίηση", 
    "sms": "SMS", 
    "option_only_show_titles": "Εμφάνιση Μόνο τίτλων ειδοποιήσεων", 
    "sms_disclaimer": "Το τηλέφωνο πρέπει να είναι ενεργοποιημένο και να διαθέτει σύνδεση στο διαδίκτυο για την αποστολή μηνυμάτων.", 
    "reply": "Απάντηση", 
    "see_full_history": "Δείτε το πλήρες ιστορικό", 
    "type_link": "Σύνδεσμος", 
    "undo": "Αναίρεση", 
    "learn_more": "Μάθετε περισσότερα", 
    "option_show_mirrors_desc": "Αποεπιλέγοντας αυτό θα μας αποτρέψει από το να εμφανίζουμε ειδοποιήσεις (θα εξακολουθείτε να βλέπετε το πλήθος τους στο εικονίδιο της γραμμής εργαλείων).", 
    "push_label": "Προώθηση", 
    "option_play_sound_desc": "Αυτό θα κάνει το Pushbullet ν' αναπαράγει έναν σύντομο ήχου όταν έρχεται μια ειδοποίηση, προειδοποιόντας σας γι' αυτήν.", 
    "devices_placeholder": "Επιλογή συσκευής", 
    "sending": "Αποστολή...", 
    "option_background_permission": "Να συνεχιστεί η εκτέλεση του Pushbullet όταν είναι κλειστό το πρόγραμμα περιήγησής μου", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Η αποκρυπτογράφηση απέτυχε", 
    "push_context_message": "{1} στο {2}", 
    "options": "Ρυθμίσεις", 
    "option_background_permission_desc": "Αυτό θα σας επιτρέψει να βλέπετε τις ειδοποιήσεις σας χωρίς να χρειάζεται να κρατάτε ανοιχτό κανένα παράθυρο στο πρόγραμμα περιήγησής σας.", 
    "mirror_context_message": "{1} μέσω Pushbullet σε {2}", 
    "encryption_password_needed_title": "Κρυπτογραφημένα δεδομένα ελήφθησαν", 
    "option_automatically_attach_link_desc": "Αυτό κάνει την αποστολή συνδέσμων στις συσκευές γρηγορότερη.", 
    "how_to_unmute_app_answer": "Ανοίξτε την android εφαρμογή Pushbullet, ανοίξτε το συρτάρι από τα αριστερά και πατήστε Κατοπτρισμός. Εκεί, πατήστε 'μόνο για ορισμένες εφαρμογές', και ξανα-ενεργοποιήστε την εφαρμογή.", 
    "device": "Συσκευή", 
    "done": "Έγινε", 
    "cancel": "Ακύρωση", 
    "snoozed_until": "Αναβολή μέχρι {1}.", 
    "sign_out": "Αποσύνδεση", 
    "from": "Από {1}", 
    "panel_cant_sign_in": "Δεν μπορείτε να συνδεθείτε; Δοκιμάστε να απενεργοποιήσετε προσωρινά το Adblock. Αν αυτό δεν βοηθήσει, το Pushbullet απαιτεί cookies τρίτων για να συνδεθείτε. Αφότου συνδεθείτε, μπορείτε να τα απενεργοποιήσετε και πάλι.", 
    "option_allow_instant_push_desc": "Προώθηση της τρέχουσας καρτέλας στην επιλεγμένη συσκευή με συντόμευση πληκτρολογίου.", 
    "option_show_notification_count": "Δείτε το πλήθος των ειδοποιήσεων σας στο εικονίδιο της γραμμής εργαλείων", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Εμφάνιση του Pushbullet στις επιλογές του \"δεξί-κλικ\" μενού.", 
    "panel_third_party_cookies": "Πατήστε εδώ για το πώς να αλλάξετε αυτή τη ρύθμιση.", 
    "option_show_mirrors": "Εμφάνιση ειδοποιήσεων στον υπολογιστή μου.", 
    "notifications": "Ειδοποιήσεις", 
    "option_use_dark_icon": "Χρήση σκούρου εικονιδίου", 
    "add_a_friend": "Προσθήκη φίλου", 
    "option_allow_instant_push": "Ενεργοποίηση άμεσων προωθήσεων στο", 
    "option_instant_push_shortcuts": "Πατήστε εδώ για να ορίσετε (τρέχων {1}).", 
    "option_open_my_pushes_automatically": "Αυτόματο άνοιγμα αντικειμένων που προωθώ σε αυτόν τον περιηγητή.", 
    "me": "Εγώ", 
    "file_too_big": "Υπερμεγέθες αρχείο", 
    "option_clipboard_permission": "Καθολική αντιγραφή & επικόλληση", 
    "pushed_successfully": "Προωθήθηκε επιτυχώς", 
    "devices": "Συσκευές", 
    "option_show_notification_count_desc": "Δείτε το πλήθος των ειδοποιήσεων σας με μια ματιά στη γραμμή εργαλείων σας.", 
    "add_a_device": "Προσθήκη συσκευής", 
    "end_to_end_password_desc": "Αν επιλέξετε να εισάγετε έναν κωδικό, αυτός ο κωδικός θα πρέπει να εισαχθεί σε κάθε μία από τις συσκευές σας.", 
    "general": "Γενικά", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Πληκτρολογήστε ένα μήνυμα ή προσθέστε αρχείο", 
    "option_clipboard_permission_desc": "Αντιγράψετε κείμενο σε μία συσκευή και, στη συνέχεια, επικολλήστε το σε οποιαδήποτε άλλη που έχει επίσης ενεργοποιημένη αυτήν τη ρύθμιση.", 
    "no_pushes": "Κανένα ιστορικό", 
    "push_failed": "Συγγνώμη, δεν καταφέραμε να το προωθήσουμε", 
    "option_notification_duration": "Απόκρυψη ειδοποιήσεων αυτόµατα µετά από", 
    "new_sms_thread": "Νέο μήνυμα κειμένου", 
    "dismiss": "Απόρριψη", 
    "decryption_failed_body": "Παρακαλώ επιβεβαιώστε την ταύτιση του κωδικού σας σε όλες τις συσκευές", 
    "sign_in": "Σύνδεση", 
    "go_to_link": "Πηγαίνετε στη διεύθυνση", 
    "snooze": "Αναβολή για 1 ώρα", 
    "friends": "Φίλοι", 
    "num_new_messages": "{1} νέα μηνύματα", 
    "remove_link_tooltip": "Απο-σύνδεση τρέχουσας ιστοσελίδας", 
    "phone": "Τηλέφωνο", 
    "mute_app": "Σίγαση {1} ειδοποιήσεων", 
    "clear": "Εκκαθάριση", 
    "end_to_end_password_label": "Κωιδικός κρυπτογράφησης από άκρο σε άκρο", 
    "add_link_tooltip": "Σύνδεση τρέχουσας σελίδας", 
    "option_only_show_titles_desc": "Αυτό θα κάνει το Pushbullet να εμφανίζει μονο τον τίτλο των κοινοποιήσεων, κρατώντας το μήνυμα προσωπικό.", 
    "all_of_my_devices": "Όλες μου οι συσκευές", 
    "unsubscribe_from_channel": "Απο-παρακολούθηση {1}", 
    "updated_notif_title": "Το Pushbullet έχει ενημερωθεί!"
}; 
strings["ar"] = {
    "mute": "كتم الصوت", 
    "thanks_for_installing_message": "انقر هنا للتسجيل الدخول", 
    "option_open_my_pushes_automatically_desc": "وهذا سيجعل Pushbullet يفتح أي شيء أرسلته إلى هذا المستعرض تلقائياً في نافذة تصفح جديدة.", 
    "unsubscribed_from_channel": "لا تتابعه اطلاقا {1}", 
    "option_show_context_menu": "إظهار Pushbullet في قائمة المتصفحات", 
    "option_use_dark_icon_desc": "هذا سيجعل رمز شريط الأدوات رمادي اللون.", 
    "alert_desktop_app_notifications": "تطبيق Pushbullet على سطح المكتب يقوم بإدارة الإشعارات.", 
    "sms_recipient_placeholder": "جهة اتصال أو رقم هاتف", 
    "message_placeholder_link": "اضافة رسالة, أضغط ادخال للارسال", 
    "unsnooze": "تنشيط", 
    "encryption_password_needed_body": "أضغط هنا لادخال كلمة مرورك", 
    "send": "أرسل", 
    "pushbullet_pro_feature": "عضوية التميز لـ Pushbullet تتطلب تفعيل المميزات.", 
    "save": "حفظ", 
    "option_instant_push_shortcuts_not_set": "لم تتم إعادة الضبط", 
    "send_failed": "فشل الإرسال", 
    "muted_app": "{1} صامت", 
    "now": "الان", 
    "no_notifications": "حاليا لا توجد إشعارات", 
    "advanced": "متقدم", 
    "channels": "القنوات", 
    "option_automatically_attach_link": "يحول الرسائل تلقائياً إلى جهازك من ضغطه واحدة", 
    "changelog_tab": "ما هو الجديد", 
    "snoozing_desc": "( Pushbullet ) كان في حالة غفوة , ولم تتمكن من مشاهدة الاشعارات.", 
    "thanks_for_installing_title": "تم تحميل التطبيق و شكراً", 
    "how_to_unmute_app": "كتمت التطبيق, كيف الغي الكتم عنه؟", 
    "title_placeholder": "العنوان", 
    "message_placeholder": "اكتب رسالة, أضغط ادخال للإرسال", 
    "updated_notif_message": "أضغط هنا لمشاهدة جديدنا", 
    "unmute_app": "إلغاء كتم الصوت {1}", 
    "type_file": "ملف", 
    "panel_sign_up": "سجل في ( pushbullet )", 
    "pushbullet_pro_required": "يتطلب اشتراك التميز", 
    "url_placeholder": "رابط url", 
    "recipient_placeholder": "إلى", 
    "retry": "إعادة المحاولة", 
    "option_play_sound": "التنبيه عند وصول اشعار جديد", 
    "sms": "الرسائل النصية \"SMS\"", 
    "option_only_show_titles": "إظهار عناوين الإشعارات فقط.", 
    "sms_disclaimer": "يجب أن يكون الهاتف شغال و يتوفر فيه اتصال بالانترنت للمراسلة.", 
    "reply": "إعادة الرد", 
    "see_full_history": "شاهد كل سجلك السابق", 
    "type_link": "رابط", 
    "undo": "تراجع", 
    "learn_more": "أعرف أكثر", 
    "option_show_mirrors_desc": "يؤدي إلى إيقاف الاشعارات.", 
    "push_label": "أرسل", 
    "option_play_sound_desc": "هذا سيجعل Pushbullet ينبهك بالصوت عند وصول الإشعار.", 
    "devices_placeholder": "تحديد جهاز", 
    "sending": "جاري الارسال ...", 
    "option_background_permission": "الحفاظ على تشغيل Pushbullet عند إغلاق المتصفح الخاص بي", 
    "reply_limit_reached": "لقد وصلت لحد الرسائل هذا الشهر.", 
    "decryption_failed_title": "فشل في فك التشفير", 
    "push_context_message": "{1} في {2}", 
    "options": "الإعدادات", 
    "option_background_permission_desc": "هذا سوف يتيح لك مشاهدة إشعاراتك دون الحاجة إلى إبقاء نافذة المتصفح مفتوحة.", 
    "mirror_context_message": "{1} بواسطة Pushbullet في {2}", 
    "encryption_password_needed_title": "تم تلقي البيانات المشفرة", 
    "option_automatically_attach_link_desc": "وهذا يجعل التواصل بين الأجهزه أسرع.", 
    "how_to_unmute_app_answer": "افتح التطبيق, اسحب من اليسار ثم أضغط هنا 'فقط لبعض التطبيقات\" ثم اعد تفعيل التطبيق.", 
    "device": "جهاز", 
    "done": "انتهى", 
    "cancel": "إلغاء الأمر", 
    "snoozed_until": "اخذ غفوة حتى {1}", 
    "sign_out": "تسجيل الخروج", 
    "from": "من {1}", 
    "panel_cant_sign_in": "لا يمكن تسجيل الدخول؟ حاول مؤقتا تعطيل حظر الاعلانات. اذا لم ينفع هذا الاجراء. فربماعليك تفعيل الكوكيز. تستطيع تعطيلها مرة اخرى بعد تسجيل الدخول.", 
    "option_allow_instant_push_desc": "ارسال علامة التبويب الحالية للجهاز الذي تم اختياره عن طريق اختصار لوحة المفاتيح.", 
    "option_show_notification_count": "إظهار عدد الإشعارات على رمز شريط الأدوات", 
    "reply_limit_warning": "رسائل محدودة لهذا الشهر.", 
    "option_show_context_menu_desc": "إظهار Pushbullet في قائمة خيارات زر الفأرة الأيمن.", 
    "panel_third_party_cookies": "لتغيير الاعدادات اضغط هنا", 
    "option_show_mirrors": "السماح بعرض الاشعارات على جهازي", 
    "notifications": "الاشعارات", 
    "option_use_dark_icon": "رموز داكنة", 
    "add_a_friend": "إضافة صديق", 
    "option_allow_instant_push": "تفعيل الارسال الفوري إلى", 
    "option_instant_push_shortcuts": "أضغط هنا لإعادة الضبط.", 
    "option_open_my_pushes_automatically": "الفتح بواسطة هذا المتصف دائماً", 
    "me": "أنا", 
    "file_too_big": "الملف كبير جداً", 
    "option_clipboard_permission": "نسخ و لصق عام", 
    "pushed_successfully": "تم الارسال بنجاح", 
    "devices": "الأجهزة", 
    "option_show_notification_count_desc": "تفقّد عدد الإشعارات بنظرة على شريط الأدوات.", 
    "add_a_device": "إضافة جهاز", 
    "end_to_end_password_desc": "إذا قمت بوضع كلمة مرور, سوف تستخدم نفسها في كل الأجهزة.", 
    "general": "عام", 
    "reply_limit_upgrade": "اشترك الآن, لرسائل غير محدودة.", 
    "message_placeholder_files": "اكتب رسالة أو حمل ملف", 
    "option_clipboard_permission_desc": "انسخ النص في جهازٍ ما ، ثم إلصقه في أي جهاز آخر لديه هذه الميزة وهي مفعلة.", 
    "no_pushes": "لا التاريخ الحديث", 
    "push_failed": "عذرا، لم نتمكن من إرسال ذلك", 
    "option_notification_duration": "إخفاء الإشعارات تلقائياً بعد", 
    "new_sms_thread": "نص جديد", 
    "dismiss": "مرفوض", 
    "decryption_failed_body": "رجاءً تأكد من تطابق كلمة مرورك في كل الاجهزة", 
    "sign_in": "تسجيل الدخول", 
    "go_to_link": "انتقل للرابط", 
    "snooze": "غفوة لمدة ساعة", 
    "friends": "أصدقاء", 
    "num_new_messages": "{1} الرسائل الجديدة", 
    "remove_link_tooltip": "إلغاء ربط هذه الصفحة", 
    "phone": "الهاتف", 
    "mute_app": "كتم الإشعارات {1}", 
    "clear": "واضح", 
    "end_to_end_password_label": "ينتهي من فك التشفير الأول و الثاني معاً", 
    "add_link_tooltip": "ربط إلى الصفحة الحالية", 
    "option_only_show_titles_desc": "وهذا سيجعل Pushbullet فقط يظهر عنوان الإشعار ، محتفظا بخصوصية رسائلك.", 
    "all_of_my_devices": "جميع أجهزتي", 
    "unsubscribe_from_channel": "عدم متابعة {1}", 
    "updated_notif_title": "تم تحديث التطبيق!"
}; 
strings["nl"] = {
    "mute": "Dempen", 
    "thanks_for_installing_message": "Klik hier om in te loggen", 
    "option_open_my_pushes_automatically_desc": "Hiermee wordt alles wat je naar deze browser pusht automatisch in een nieuw tabblad geopend.", 
    "unsubscribed_from_channel": "Je volgt {1} niet meer", 
    "option_show_context_menu": "Pushbullet in het contextmenu weergeven", 
    "option_use_dark_icon_desc": "Donkergrijs werkbalkpictogram weergeven.", 
    "alert_desktop_app_notifications": "De Pushbullet-desktopapp beheert de meldingen. Als je meldingen uitschakelt in de desktopapp, worden meldingen weer door de extensie beheerd.", 
    "sms_recipient_placeholder": "Contactpersoon of telefoonnummer", 
    "message_placeholder_link": "Voeg een bericht toe, druk op Enter om te verzenden", 
    "unsnooze": "Snoozen opheffen", 
    "encryption_password_needed_body": "Klik hier om je wachtwoord in te vullen.", 
    "send": "Verzenden", 
    "pushbullet_pro_feature": "Je hebt Pushbullet Pro nodig voor deze functie.", 
    "save": "Opslaan", 
    "option_instant_push_shortcuts_not_set": "niet ingesteld", 
    "send_failed": "Verzenden mislukt", 
    "muted_app": "{1} gedempt", 
    "now": "Zojuist", 
    "no_notifications": "Er zijn momenteel geen meldingen", 
    "advanced": "Geavanceerd", 
    "channels": "Kanalen", 
    "option_automatically_attach_link": "Het huidige tabblad automatisch toevoegen aan berichten naar een apparaat", 
    "changelog_tab": "Wat is er nieuw", 
    "snoozing_desc": "Door te snoozen worden er een uur lang geen meldingen weergegeven.", 
    "thanks_for_installing_title": "Bedankt voor het installeren van Pushbullet", 
    "how_to_unmute_app": "Ik heb een app gedempt. Hoe maak ik dit ongedaan?", 
    "title_placeholder": "Titel", 
    "message_placeholder": "Typ een bericht, druk op Enter om te verzenden", 
    "updated_notif_message": "Klik hier om te zien wat er is gewijzigd", 
    "unmute_app": "Dempen van {1} opheffen", 
    "type_file": "Bestand", 
    "panel_sign_up": "Registreren op Pushbullet.com →", 
    "pushbullet_pro_required": "Pushbullet Pro vereist", 
    "url_placeholder": "Link-URL", 
    "recipient_placeholder": "Aan", 
    "retry": "Opnieuw proberen", 
    "option_play_sound": "Geluid afspelen bij nieuwe meldingen", 
    "sms": "Sms", 
    "option_only_show_titles": "Alleen titels van meldingen weergeven", 
    "sms_disclaimer": "Telefoon moet aan staan en verbonden zijn met internet om sms-berichten te verzenden.", 
    "reply": "Beantwoorden", 
    "see_full_history": "Volledige geschiedenis bekijken", 
    "type_link": "Link", 
    "undo": "Ongedaan maken", 
    "learn_more": "Meer informatie", 
    "option_show_mirrors_desc": "Vink dit uit om geen meldingen meer te zien (je ziet nog wel het aantal meldingen op het werkbalkpictogram).", 
    "push_label": "Pushen", 
    "option_play_sound_desc": "Hiermee wordt een geluid afgespeeld als je een nieuwe melding ontvangt.", 
    "devices_placeholder": "Kies een apparaat", 
    "sending": "Verzenden...", 
    "option_background_permission": "Pushbullet actief houden als ik mijn browser sluit", 
    "reply_limit_reached": "Je hebt de limiet van gratis berichten voor deze maand bereikt.", 
    "decryption_failed_title": "Ontsleutelen mislukt", 
    "push_context_message": "{1} om {2}", 
    "options": "Instellingen", 
    "option_background_permission_desc": "Hiermee kun je meldingen zien zonder je browser open te hoeven houden.", 
    "mirror_context_message": "{1} via Pushbullet om {2}", 
    "encryption_password_needed_title": "Versleutelde gegevens ontvangen", 
    "option_automatically_attach_link_desc": "Zo kun je sneller links naar apparaten verzenden.", 
    "how_to_unmute_app_answer": "Open het menu in de Android-app en tik op \"Meldingen synchroniseren\". Tik vervolgens op \"Alleen voor bepaalde apps\" en schakel de app opnieuw in.", 
    "device": "Apparaat", 
    "done": "Gereed", 
    "cancel": "Annuleren", 
    "snoozed_until": "Gesnoozed tot {1}.", 
    "sign_out": "Uitloggen", 
    "from": "Van {1}", 
    "panel_cant_sign_in": "Lukt inloggen niet? Probeer AdBlock tijdelijk uit te schakelen. Om in te loggen op Pushbullet moeten cookies van derden zijn ingeschakeld. Je kunt ze na het inloggen weer uitschakelen.", 
    "option_allow_instant_push_desc": "Het huidige tabblad naar het geselecteerde apparaat pushen met een sneltoets.", 
    "option_show_notification_count": "Aantal meldingen op werkbalkpictogram weergeven", 
    "reply_limit_warning": "Je hebt bijna de limiet van gratis berichten voor deze maand bereikt.", 
    "option_show_context_menu_desc": "Pushbullet in het rechtermuisklikmenu weergeven.", 
    "panel_third_party_cookies": "Bekijk hier hoe je deze instelling kunt wijzigen.", 
    "option_show_mirrors": "Meldingen weergeven op mijn computer.", 
    "notifications": "Meldingen", 
    "option_use_dark_icon": "Donker pictogram gebruiken", 
    "add_a_friend": "Vriend toevoegen", 
    "option_allow_instant_push": "Direct pushen naar", 
    "option_instant_push_shortcuts": "Klik hier om in te stellen (momenteel {1}).", 
    "option_open_my_pushes_automatically": "DIngen die ik push naar deze browser automatisch openen", 
    "me": "Mij", 
    "file_too_big": "Bestand te groot", 
    "option_clipboard_permission": "Klembord synchroniseren", 
    "pushed_successfully": "Succesvol gepusht", 
    "devices": "Apparaten", 
    "option_show_notification_count_desc": "Zie in één oogopslag het aantal meldingen op de werkbalk.", 
    "add_a_device": "Apparaat toevoegen", 
    "end_to_end_password_desc": "Als je een wachtwoord instelt, moet je dat wachtwoord op al je apparaten invullen.", 
    "general": "Algemeen", 
    "reply_limit_upgrade": "Upgrade naar Pushbullet Pro om onbeperkt berichten te verzenden.", 
    "message_placeholder_files": "Typ een bericht of sleep een bestand hierheen", 
    "option_clipboard_permission_desc": "Kopieer tekst op dit apparaat en plak het vervolgens op apparaten waar deze functie ook is ingeschakeld.", 
    "no_pushes": "Geen recente geschiedenis", 
    "push_failed": "Sorry, dat kunnen we niet pushen", 
    "option_notification_duration": "Meldingen automatisch verbergen na", 
    "new_sms_thread": "Nieuw sms-bericht", 
    "dismiss": "Sluiten", 
    "decryption_failed_body": "Controleer of je wachtwoord op al je apparaten hetzelfde is.", 
    "sign_in": "Inloggen", 
    "go_to_link": "Link openen", 
    "snooze": "1 uur snoozen", 
    "friends": "Vrienden", 
    "num_new_messages": "{1} nieuwe berichten", 
    "remove_link_tooltip": "Link naar huidige pagina verwijderen", 
    "phone": "Telefoon", 
    "mute_app": "Meldingen van {1} dempen", 
    "clear": "Wissen", 
    "end_to_end_password_label": "Wachtwoord end-to-endversleuteling", 
    "add_link_tooltip": "Link naar huidige pagina toevoegen", 
    "option_only_show_titles_desc": "Pushbullet zal alleen de titel van meldingen weergeven. De inhoud blijft verborgen.", 
    "all_of_my_devices": "Al mijn apparaten", 
    "unsubscribe_from_channel": "{1} ontvolgen", 
    "updated_notif_title": "Pushbullet is bijgewerkt!"
}; 
strings["he"] = {
    "mute": "השתק", 
    "thanks_for_installing_message": "לחצו כדי להתחבר למערכת", 
    "option_open_my_pushes_automatically_desc": "פעולה זו תגרום ל-Pushbullet לפתוח אוטומטית כל מה שאתם דוחפים (Push) בדפדפן זה בלשונית חדשה.", 
    "unsubscribed_from_channel": "לא עוקב יותר אחר {1}", 
    "option_show_context_menu": "הצג את Pushbullet בתפריט ההקשר (context menu)", 
    "option_use_dark_icon_desc": "פעולה זו תשנה את צבע הסמל שלנו בסרגל הכלים לאפור כהה.", 
    "alert_desktop_app_notifications": "אפליקציית שולחן העבודה של Pushbullet מנהלת התראות. השבתת התראות בהגדרות אפליקציית שולחן העבודה תחזיר את השליטה לתוסף הדפדפן.", 
    "sms_recipient_placeholder": "איש קשר או מספר טלפון", 
    "message_placeholder_link": "הוסיפו הודעה, לחצו על האנטר לשליחה", 
    "unsnooze": "בטל השהייה", 
    "encryption_password_needed_body": "", 
    "send": "שליחה", 
    "pushbullet_pro_feature": "", 
    "save": "שמור", 
    "option_instant_push_shortcuts_not_set": "", 
    "send_failed": "שליחה נכשלה", 
    "muted_app": "{1} הושתק", 
    "now": "עכשיו", 
    "no_notifications": "", 
    "advanced": "מתקדם", 
    "channels": "ערוצים", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "מה חדש", 
    "snoozing_desc": "ההשהייה עוצרת את Pushbullet מלהציג התראות לשעה אחת.", 
    "thanks_for_installing_title": "תודה שהתקנתם את Pushbullet", 
    "how_to_unmute_app": "השתקתי אפליקציה, כיצד אני מבטל את ההשתקה?", 
    "title_placeholder": "כותרת", 
    "message_placeholder": "הקלידו הודעה, לחצו על האנטר לשליחה", 
    "updated_notif_message": "לחצו כאן כדי לראות מה חדש", 
    "unmute_app": "בטל השתקה עבור {1}", 
    "type_file": "קובץ", 
    "panel_sign_up": "הירשם באתר Pushbullet.com ←", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "", 
    "recipient_placeholder": "אל", 
    "retry": "נסה שנית", 
    "option_play_sound": "השמע צליל בעת קבלת התראה.", 
    "sms": "סמס", 
    "option_only_show_titles": "הצג כותרות התראות בלבד.", 
    "sms_disclaimer": "", 
    "reply": "השב", 
    "see_full_history": "צפייה בהיסטוריה מלאה", 
    "type_link": "קישור", 
    "undo": "בטל", 
    "learn_more": "ללמוד עוד", 
    "option_show_mirrors_desc": "", 
    "push_label": "דחוף", 
    "option_play_sound_desc": "פעולה זו תגרום ל-Pushbullet להשמיע צליל קצר בעת קבלת התראה.", 
    "devices_placeholder": "בחירת מכשיר", 
    "sending": "שולח...", 
    "option_background_permission": "אפשר ל-Pushbullet לעבוד גם כשהדפדפן שלי סגור", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "", 
    "push_context_message": "{1} ב-{2}", 
    "options": "הגדרות", 
    "option_background_permission_desc": "אופציה זו תאפשר לך לראות את ההתראות שלך גם בלי הצורך להשאיר את הדפדפן שלך פתוח.", 
    "mirror_context_message": "{1} דרך Pushbullet ב-{2}", 
    "encryption_password_needed_title": "", 
    "option_automatically_attach_link_desc": "", 
    "how_to_unmute_app_answer": "", 
    "device": "מכשיר", 
    "done": "בוצע", 
    "cancel": "ביטול", 
    "snoozed_until": "מושהה עד {1}.", 
    "sign_out": "יציאה מהמערכת", 
    "from": "מאת {1}", 
    "panel_cant_sign_in": "לא מצליח להתחבר? נסה זמנית להשבית את Adblock. אם זה לא עוזר, Pushbullet דורשת שעוגיות צד שלישי יהיו פעילות להתחברות. תוכל להשביתם שוב לאחר שתתחבר.", 
    "option_allow_instant_push_desc": "", 
    "option_show_notification_count": "הצג את ספירת ההודעות על סמל סרגל הכלים", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "הצגת Pushbullet ברשימת התפריט בנפתח במקש ימני.", 
    "panel_third_party_cookies": "לחצו כאן כדי להבין איך לשנות הגדרה זו.", 
    "option_show_mirrors": "הצג התראות במחשב שלי.", 
    "notifications": "התראות", 
    "option_use_dark_icon": "השתמש בסמל כהה", 
    "add_a_friend": "הוסף חבר/ה", 
    "option_allow_instant_push": "", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "פתח אוטומטית כל מה שאני דוחף (Push) בדפדפן זה.", 
    "me": "אני", 
    "file_too_big": "קובץ גדול מדי", 
    "option_clipboard_permission": "העתק והדבק אוניברסלי", 
    "pushed_successfully": "נדחף בהצלחה", 
    "devices": "מכשירים", 
    "option_show_notification_count_desc": "הראה את ספירת ההודעות במבט בסרגל הכלים.", 
    "add_a_device": "הוסף מכשיר", 
    "end_to_end_password_desc": "", 
    "general": "כללי", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "הקלידו הודעה או תגררו קובץ", 
    "option_clipboard_permission_desc": "תעתיק את הטקסט מהמכשיר הראשון, ואז תדביק אותו על כל מכשיר אחר שההגדרה הזאת דלוקה בו.", 
    "no_pushes": "אין היסטוריה אחרונה", 
    "push_failed": "מצטערים, איננו יכולים לדחוף זאת", 
    "option_notification_duration": "הסתר התראות מיד לאחר", 
    "new_sms_thread": "הודעת טקסט חדשה", 
    "dismiss": "התעלם", 
    "decryption_failed_body": "", 
    "sign_in": "התחברות למערכת", 
    "go_to_link": "פתח קישור", 
    "snooze": "השהה לשעה", 
    "friends": "חברים", 
    "num_new_messages": "{1} הודעות חדשות", 
    "remove_link_tooltip": "", 
    "phone": "טלפון", 
    "mute_app": "השתק {1} התראות", 
    "clear": "נקה", 
    "end_to_end_password_label": "", 
    "add_link_tooltip": "קישור לעמוד הנוכחי", 
    "option_only_show_titles_desc": "", 
    "all_of_my_devices": "כל המכשירים שלי", 
    "unsubscribe_from_channel": "הפסק לעקוב אחר {1}", 
    "updated_notif_title": "Pushbullet עודכן!"
}; 
strings["sv"] = {
    "mute": "Tysta", 
    "thanks_for_installing_message": "Klicka här för att logga in", 
    "option_open_my_pushes_automatically_desc": "Detta gör att Pushbullet öppnar något du pushar till denna webbläsare automatiskt i en ny flik.", 
    "unsubscribed_from_channel": "Följer inte längre {1}", 
    "option_show_context_menu": "Visa Pushbullet i högerklicks-menyn", 
    "option_use_dark_icon_desc": "Detta gör vår verktygsfältsikon mörkgrå.", 
    "alert_desktop_app_notifications": "Pushbullets dator applikation hanterar notifikationen. Avstängning av notifikationer i dator applikationens inställningar kommer ge kontrollen till tillägget.", 
    "sms_recipient_placeholder": "Kontakt eller telefonnummer", 
    "message_placeholder_link": "Lägga till ett meddelande, tryck enter för att skicka", 
    "unsnooze": "Avsnooza", 
    "encryption_password_needed_body": "Klicka här för att ange ditt lösenord", 
    "send": "Skicka", 
    "pushbullet_pro_feature": "", 
    "save": "Spara", 
    "option_instant_push_shortcuts_not_set": "", 
    "send_failed": "Skicka misslyckades", 
    "muted_app": "Tystat {1}", 
    "now": "Nu", 
    "no_notifications": "Inga notifikationer just nu", 
    "advanced": "Avancerat", 
    "channels": "Kanaler", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "Nytt", 
    "snoozing_desc": "Snooze hindrar Pushbullet från att visar dina meddelanden i en timme.", 
    "thanks_for_installing_title": "Tack för att du installerat Pushbullet", 
    "how_to_unmute_app": "Jag tystade en app, hur jag sätter jag på den igen?", 
    "title_placeholder": "Titel", 
    "message_placeholder": "Skriv ett meddelande, tryck enter för att skicka", 
    "updated_notif_message": "Klicka här för att se vad som är nytt", 
    "unmute_app": "Slå på {1}", 
    "type_file": "Fil", 
    "panel_sign_up": "Anmäl dig på Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Länk-url", 
    "recipient_placeholder": "Till", 
    "retry": "Försök igen", 
    "option_play_sound": "Spela upp ett ljud när ett meddelande anländer", 
    "sms": "SMS", 
    "option_only_show_titles": "Visa endast meddelandetitlar", 
    "sms_disclaimer": "Telefonen måste vara påslagen och ha en internetanslutning för att skicka SMS.", 
    "reply": "Svara", 
    "see_full_history": "Se full historia", 
    "type_link": "Länk", 
    "undo": "Ångra", 
    "learn_more": "Lär dig mer", 
    "option_show_mirrors_desc": "Avmarkering kommer att hindra oss från visa notiser (du kan fortfarande se antalet i vår verktygsfältsikon).", 
    "push_label": "Push", 
    "option_play_sound_desc": "Detta kommer att göra att Pushbullet spelar ett kort ljud när ett meddelande anländer.", 
    "devices_placeholder": "Välj en enhet", 
    "sending": "Skickar...", 
    "option_background_permission": "Håll Pushbullet igång när webbläsaren stängs", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Dekrypteringen misslyckades", 
    "push_context_message": "{1} klockan {2}", 
    "options": "Inställningar", 
    "option_background_permission_desc": "Detta gör att du kan se dina meddelanden utan att behöva hålla ett webbläsarfönster öppet.", 
    "mirror_context_message": "{1} via Pushbullet klockan {2}", 
    "encryption_password_needed_title": "Krypterad data togs emot", 
    "option_automatically_attach_link_desc": "", 
    "how_to_unmute_app_answer": "Öppna Pushbullets Android app, dra ut sidomenyn från vänster och tryck sedan på \"Spegling\". Här, tryck på \"Endast för vissa appar\" och återaktivera sen appen.", 
    "device": "Enhet", 
    "done": "Färdigt", 
    "cancel": "Avbryt", 
    "snoozed_until": "Snoozat till {1}.", 
    "sign_out": "Logga ut", 
    "from": "Från {1}", 
    "panel_cant_sign_in": "Kan du inte logga in? Försök att temporärt inaktivera AdBlock. Om det inte fungerar, Pushbullet behöver tredjeparts-cookies aktiverade för att de ska kunna logga in. Du kan inaktivera dem igen efter att du har loggat in.", 
    "option_allow_instant_push_desc": "", 
    "option_show_notification_count": "Visa meddelanderäknare i verktygsfältsikonen", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Visa Pushbullet i listan över högerklicks menyalternativ.", 
    "panel_third_party_cookies": "Klicka här för hur du ändrar denna inställning.", 
    "option_show_mirrors": "Visa notiser på min dator.", 
    "notifications": "Meddelanden", 
    "option_use_dark_icon": "Använd mörk ikon", 
    "add_a_friend": "+ Lägg till en vän", 
    "option_allow_instant_push": "", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "Öppna saker jag pushar till denna webbläsare automatiskt.", 
    "me": "Mig", 
    "file_too_big": "Filen är för stor", 
    "option_clipboard_permission": "Kopiera & klistra in", 
    "pushed_successfully": "Pushen lyckades", 
    "devices": "Enheter", 
    "option_show_notification_count_desc": "Se dina notifieringar på ett ögonblick i verktygsfältet.", 
    "add_a_device": "+ Lägg till en enhet", 
    "end_to_end_password_desc": "Om du väljer att ange ett lösenord, måste detta lösenord anges på alla dina enheter.", 
    "general": "Allmänt", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Skriv ett meddelande eller släpp en fil", 
    "option_clipboard_permission_desc": "Kopiera text från en enhet och klistra in den på en annan enhet som har denna funktionen aktiverad.", 
    "no_pushes": "Ingen ny historia", 
    "push_failed": "Tyvärr kunde vi inte pusha det där", 
    "option_notification_duration": "Dölja meddelanden automatiskt efter", 
    "new_sms_thread": "Nytt SMS", 
    "dismiss": "Avfärda", 
    "decryption_failed_body": "Vänligen bekräfta att lösenordet matchar på alla enheter", 
    "sign_in": "Logga in", 
    "go_to_link": "Gå till länk", 
    "snooze": "Snooze 1 timme", 
    "friends": "Vänner", 
    "num_new_messages": "{1} nya meddelanden", 
    "remove_link_tooltip": "Avlänka nuvarande sida", 
    "phone": "Telefon", 
    "mute_app": "Tysta {1} meddelanden", 
    "clear": "Töm", 
    "end_to_end_password_label": "End-to-end-krypteringslösenord", 
    "add_link_tooltip": "Länka nuvarande sida", 
    "option_only_show_titles_desc": "Detta gör att Pushbullet bara visar titeln på notifieringarna och håller meddelandet privat.", 
    "all_of_my_devices": "Alla mina enheter", 
    "unsubscribe_from_channel": "Sluta följa {1}", 
    "updated_notif_title": "Pushbullet har uppdaterats!"
}; 
strings["zh-TW"] = {
    "mute": "消音", 
    "thanks_for_installing_message": "點擊此處開始登入", 
    "option_open_my_pushes_automatically_desc": "當收到新訊息時，自動在新分頁開啓接收的圖片、連結或其他内容", 
    "unsubscribed_from_channel": "不再追蹤 {1}", 
    "option_show_context_menu": "在右鍵選單中加入 Pushbullet 選項", 
    "option_use_dark_icon_desc": "使工具列上的圖示變爲灰黑色調", 
    "alert_desktop_app_notifications": "Pushbullet 桌面端程式正負責管理通知訊息。停用桌面端程式之後則由瀏覽器套件控制。", 
    "sms_recipient_placeholder": "聯絡人或電話號碼", 
    "message_placeholder_link": "新增訊息，按下 Enter 傳送", 
    "unsnooze": "停止休眠", 
    "encryption_password_needed_body": "按一下此處輸入您的密碼", 
    "send": "傳送", 
    "pushbullet_pro_feature": "Pushbullet Pro 需要啟用此功能。", 
    "save": "保存", 
    "option_instant_push_shortcuts_not_set": "未設定", 
    "send_failed": "傳送失敗", 
    "muted_app": "{1} 的通知已消音", 
    "now": "現在", 
    "no_notifications": "目前沒有任何通知訊息", 
    "advanced": "進階設定", 
    "channels": "頻道", 
    "option_automatically_attach_link": "自動將目前分頁夾帶到訊息中", 
    "changelog_tab": "更新內容", 
    "snoozing_desc": "休眠後 Pushbullet 將暫停顯示同步通知一小時。", 
    "thanks_for_installing_title": "感謝您安裝 Pushbullet", 
    "how_to_unmute_app": "我關閉了一個 app 的通知，如何再度開啟？", 
    "title_placeholder": "標題", 
    "message_placeholder": "輸入訊息，按下 Enter 傳送", 
    "updated_notif_message": "按一下這裡看看有什麼新功能", 
    "unmute_app": "恢復 {1} 的通知", 
    "type_file": "檔案", 
    "panel_sign_up": "在 Pushbullet.com 上註冊 →", 
    "pushbullet_pro_required": "請升級至 Pro 版本", 
    "url_placeholder": "連結網址", 
    "recipient_placeholder": "傳送至", 
    "retry": "重試", 
    "option_play_sound": "收到通知時播放音效", 
    "sms": "簡訊", 
    "option_only_show_titles": "僅顯示訊息標題", 
    "sms_disclaimer": "手機必須保持開機並連線上網際網路才能傳送文字訊息。", 
    "reply": "回覆", 
    "see_full_history": "檢視完整紀錄", 
    "type_link": "連結", 
    "undo": "復原", 
    "learn_more": "了解更多", 
    "option_show_mirrors_desc": "取消勾選後將停止顯示通知 (您仍可以從工具列的圖示看到未讀通知計數)", 
    "push_label": "推送", 
    "option_play_sound_desc": "當 Pushbullet 接收到通知時播放音效", 
    "devices_placeholder": "選擇裝置", 
    "sending": "傳送中...", 
    "option_background_permission": "在瀏覽器關閉後繼續執行 Pushbullet", 
    "reply_limit_reached": "您已用盡本月的免費訊息則數", 
    "decryption_failed_title": "解密失敗", 
    "push_context_message": "{1} 在 {2}", 
    "options": "設定", 
    "option_background_permission_desc": "開啓後將使 Pushbullet 成爲背景應用程式，即使所有分頁關閉後依然可以正常接收通知", 
    "mirror_context_message": "{1} 透過 Pushbullet 傳到 {2}", 
    "encryption_password_needed_title": "接收到加密資料", 
    "option_automatically_attach_link_desc": "這會加快推送連結到裝置的速度", 
    "how_to_unmute_app_answer": "開啟 Android 裡的 Pushbullet，從左邊滑出選單後，點擊「通知同步」>「個別應用程式設定」，然後重新啟動應用程式。", 
    "device": "裝置", 
    "done": "完成", 
    "cancel": "取消", 
    "snoozed_until": "休眠至{1}", 
    "sign_out": "登出", 
    "from": "來自 {1}", 
    "panel_cant_sign_in": "無法登入嗎？請暫時停用 Adblock。若仍然無效，請檢查 cookies 設定，Pushbullet 需要開啟第三方 cookies 進行登入。您可以在登入後再次關閉。", 
    "option_allow_instant_push_desc": "用鍵盤快速鍵將目前分頁推送至指定的裝置", 
    "option_show_notification_count": "在工具列的圖示上顯示未讀計數", 
    "reply_limit_warning": "您即將用盡本月的免費訊息則數", 
    "option_show_context_menu_desc": "當您在選取的文字或圖片上點擊右鍵時，於選單中顯示 Pushbullet 的選項", 
    "panel_third_party_cookies": "點此瞭解如何修改此設置", 
    "option_show_mirrors": "在我的電腦上顯示通知", 
    "notifications": "通知", 
    "option_use_dark_icon": "使用黑色圖示", 
    "add_a_friend": "+ 添加聯絡人", 
    "option_allow_instant_push": "開啟及時推送", 
    "option_instant_push_shortcuts": "點擊此處以設置 (目前為{1})", 
    "option_open_my_pushes_automatically": "自動開啓傳送到瀏覽器的訊息", 
    "me": "我", 
    "file_too_big": "檔案過大", 
    "option_clipboard_permission": "跨裝置剪貼簿", 
    "pushed_successfully": "發送成功", 
    "devices": "裝置", 
    "option_show_notification_count_desc": "只需一瞥您的工具列便可知道有幾則通知。", 
    "add_a_device": "+ 新增裝置", 
    "end_to_end_password_desc": "如果您選擇輸入此密碼，此密碼將需要輸入到您每個設備上。", 
    "general": "一般", 
    "reply_limit_upgrade": "升級至 Pushbullet Pro 便可無止盡地傳輸訊息", 
    "message_placeholder_files": "輸入訊息或拖曳檔案至此", 
    "option_clipboard_permission_desc": "從一台裝置複製文字，然後在任何一台也啟用此設定的裝置貼上。", 
    "no_pushes": "沒有最近的歷史紀錄", 
    "push_failed": "抱歉，我們無法發送此項目", 
    "option_notification_duration": "通知顯示時間長度", 
    "new_sms_thread": "新簡訊", 
    "dismiss": "清除", 
    "decryption_failed_body": "請確認您的密碼符合在所有裝置上", 
    "sign_in": "登入", 
    "go_to_link": "開啟連結", 
    "snooze": "休眠一小時", 
    "friends": "朋友", 
    "num_new_messages": "{1} 則新訊息", 
    "remove_link_tooltip": "移除目前網頁連結", 
    "phone": "手機", 
    "mute_app": "停止同步來自 {1} 的通知", 
    "clear": "清除", 
    "end_to_end_password_label": "點對點加密密碼", 
    "add_link_tooltip": "插入目前網頁連結", 
    "option_only_show_titles_desc": "這將使Pushbullet僅顯示通知訊息的標題，內容保密", 
    "all_of_my_devices": "所有裝置", 
    "unsubscribe_from_channel": "取消追蹤 {1}", 
    "updated_notif_title": "Pushbullet 已更新！"
}; 
strings["it"] = {
    "mute": "Silenzia", 
    "thanks_for_installing_message": "Clicca qui per accedere", 
    "option_open_my_pushes_automatically_desc": "Questo farà in modo che Pushbullet apra tutto quello che viene inviato via push in una nuova scheda di questo browser in automatico.", 
    "unsubscribed_from_channel": "Hai smesso di seguire {1}", 
    "option_show_context_menu": "Mostra Pushbullet nel menu contestuale", 
    "option_use_dark_icon_desc": "Questo renderà scura l'icona della barra.", 
    "alert_desktop_app_notifications": "L'applicazione desktop Pushbullet sta gestendo le notifiche. Disabilitando le notifiche nelle impostazioni dell'app desktop il controllo ritornerà all'estensione.", 
    "sms_recipient_placeholder": "Contatto o numero di telefono", 
    "message_placeholder_link": "Aggiungi un messaggio, premi invio per spedirlo", 
    "unsnooze": "Riattiva notifiche", 
    "encryption_password_needed_body": "Clicca qui per inserire la password", 
    "send": "Invia", 
    "pushbullet_pro_feature": "", 
    "save": "Salva", 
    "option_instant_push_shortcuts_not_set": "non impostato", 
    "send_failed": "Invio non riuscito", 
    "muted_app": "Silenziate {1}", 
    "now": "Ora", 
    "no_notifications": "Nessuna notifica presente", 
    "advanced": "Avanzate", 
    "channels": "Canali", 
    "option_automatically_attach_link": "Allega automaticamente la scheda corrente ai messaggi inviati al dispositivo", 
    "changelog_tab": "Novità", 
    "snoozing_desc": "Le notifiche di Pushbullet verranno disattivate per un'ora.", 
    "thanks_for_installing_title": "Grazie per aver installato Pushbullet", 
    "how_to_unmute_app": "Ho disattivato un'app, come posso riattivarla?", 
    "title_placeholder": "Titolo", 
    "message_placeholder": "Scrivi un messaggio, premi invio per spedirlo", 
    "updated_notif_message": "Clicca qui per vedere le novità", 
    "unmute_app": "Attivate {1}", 
    "type_file": "File", 
    "panel_sign_up": "Registrati su Pushbullet.com →", 
    "pushbullet_pro_required": "Richiede Pushbullet Pro", 
    "url_placeholder": "Link url", 
    "recipient_placeholder": "A", 
    "retry": "Riprova", 
    "option_play_sound": "Riproduci un suono all'arrivo di una notifica", 
    "sms": "SMS", 
    "option_only_show_titles": "Mostra solo il titolo della notifica", 
    "sms_disclaimer": "Il telefono deve essere acceso ed avere una connessione ad internet per inviare messaggi.", 
    "reply": "Rispondi", 
    "see_full_history": "Vedi la cronologia completa", 
    "type_link": "Link", 
    "undo": "Annulla", 
    "learn_more": "Ulteriori informazioni", 
    "option_show_mirrors_desc": "Deselezionando questo ci impedirai di mostrarti notifiche (potrai ancora vedere il contatore nell'icona della barra).", 
    "push_label": "Push", 
    "option_play_sound_desc": "Questo farà in modo che Pushbullet emetta un breve suono all'arrivo di una notifica, avvisandoti.", 
    "devices_placeholder": "Seleziona un dispositivo", 
    "sending": "Invio...", 
    "option_background_permission": "Tieni attivo Pushbullet quando il mio browser è chiuso", 
    "reply_limit_reached": "Hai raggiunto il limite dei messaggi gratuiti per questo mese.", 
    "decryption_failed_title": "Decriptazione fallita", 
    "push_context_message": "{1} a {2}", 
    "options": "Impostazioni", 
    "option_background_permission_desc": "Questo ti permetterà di vedere le tue notifiche senza dover tenere aperta una finestra del browser.", 
    "mirror_context_message": "{1} tramite Pushbullet a {2}", 
    "encryption_password_needed_title": "Dati criptati ricevuti", 
    "option_automatically_attach_link_desc": "Questo rende l'invio dei link ai dispositivi più veloce.", 
    "how_to_unmute_app_answer": "Apri l'app Android di Pushbullet, fai scorrere da sinistra il menu a scomparsa, poi tocca 'Mirroring'. Qui tocca 'Solo per alcune app', poi riabilita l'app.", 
    "device": "Dispositivo", 
    "done": "Fatto", 
    "cancel": "Annulla", 
    "snoozed_until": "Notifiche disattivate fino alle {1}.", 
    "sign_out": "Esci", 
    "from": "Da {1}", 
    "panel_cant_sign_in": "Non riesci ad accedere? Prova a disabilitare temporaneamente Adblock. Se questo non aiuta, Pushbullet richiede i cookie di terze parti per essere abilitato ad accedere. È possibile disabilitarli nuovamente dopo aver avuto accesso.", 
    "option_allow_instant_push_desc": "Invia la scheda corrente al dispositivo selezionato tramite i tasti di scelta rapida.", 
    "option_show_notification_count": "Mostra il contatore delle notifiche sull'icona", 
    "reply_limit_warning": "Ti stai avvicinando al limite dei messaggi gratuiti per questo mese.", 
    "option_show_context_menu_desc": "Mostra Pushbullet nell'elenco delle opzioni del menu contestuale (tasto destro).", 
    "panel_third_party_cookies": "Clicca qui per sapere come modificare questa impostazione.", 
    "option_show_mirrors": "Mostra le notifiche sul computer.", 
    "notifications": "Notifiche", 
    "option_use_dark_icon": "Icona scura", 
    "add_a_friend": "+ Aggiungi un amico", 
    "option_allow_instant_push": "Abilita il push istantaneo verso", 
    "option_instant_push_shortcuts": "Clicca qui per impostare (attuale {1}).", 
    "option_open_my_pushes_automatically": "Apri automaticamente ciò che mando via push a questo browser.", 
    "me": "Io", 
    "file_too_big": "File troppo grande", 
    "option_clipboard_permission": "Copia & Incolla Universale", 
    "pushed_successfully": "Push inviato con successo", 
    "devices": "Dispositivi", 
    "option_show_notification_count_desc": "Guarda il contatore delle tue notifiche in un colpo d'occhio.", 
    "add_a_device": "+ Aggiungi un dispositivo", 
    "end_to_end_password_desc": "Se scegli di inserire una password, la stessa password dovrà essere inserita in ciascuno dei tuoi dispositivi.", 
    "general": "Generale", 
    "reply_limit_upgrade": "Passa a Pushbullet Pro per inviare messaggi illimitati.", 
    "message_placeholder_files": "Scrivi un messaggio o seleziona un file", 
    "option_clipboard_permission_desc": "Copia il testo su un dispositivo, poi incollalo su qualsiasi altro che ha anche questa impostazione abilitata.", 
    "no_pushes": "Nessuna cronologia recente", 
    "push_failed": "Siamo spiacenti, non siamo riusciti ad inviare il push", 
    "option_notification_duration": "Nascondi automaticamente le notifiche dopo", 
    "new_sms_thread": "Nuovo messaggio di testo", 
    "dismiss": "Rimuovi", 
    "decryption_failed_body": "Per favore conferma che la tua password corrisponde su tutti i dispositivi", 
    "sign_in": "Accedi", 
    "go_to_link": "Vai al link", 
    "snooze": "Disattiva per 1h", 
    "friends": "Amici", 
    "num_new_messages": "{1} nuovi messaggi", 
    "remove_link_tooltip": "Scollega la pagina corrente", 
    "phone": "Telefono", 
    "mute_app": "Silenzia {1} notifiche", 
    "clear": "Pulisci", 
    "end_to_end_password_label": "Password per crittografia end-to-end", 
    "add_link_tooltip": "Collega la pagina corrente", 
    "option_only_show_titles_desc": "Questo permetterà a Pushbullet di mostrare solo il titolo della notifica, mantenendo il messaggio privato.", 
    "all_of_my_devices": "Tutti i miei dispositivi", 
    "unsubscribe_from_channel": "Non seguire più {1}", 
    "updated_notif_title": "Pushbullet è stato aggiornato!"
}; 
strings["zh-HK"] = {
    "mute": "停止同步通知", 
    "thanks_for_installing_message": "點擊此處以登入", 
    "option_open_my_pushes_automatically_desc": "勾選后將使瀏覽器在新頁面中自動開啓接收的圖片，連結或其他内容", 
    "unsubscribed_from_channel": "不再追蹤{1}", 
    "option_show_context_menu": "在滑鼠右鍵菜單中添加Pushbullet", 
    "option_use_dark_icon_desc": "勾選后將使工具欄圖示變爲灰黑色調", 
    "alert_desktop_app_notifications": "Pushbullet 桌面端程式正負責管理通知訊息。停用桌面端程式之後則由瀏覽器套件控制。", 
    "sms_recipient_placeholder": "聯絡人或電話號碼", 
    "message_placeholder_link": "添加一條訊息，按輸入鍵發送", 
    "unsnooze": "停止休眠", 
    "encryption_password_needed_body": "按此輸入您的密碼", 
    "send": "傳送", 
    "pushbullet_pro_feature": "", 
    "save": "儲存", 
    "option_instant_push_shortcuts_not_set": "未設置", 
    "send_failed": "傳送失敗", 
    "muted_app": "{1} 的通知將不再同步至 PC", 
    "now": "現在", 
    "no_notifications": "目前沒有任何通知。", 
    "advanced": "進階", 
    "channels": "頻道", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "更新內容", 
    "snoozing_desc": "休眠后Pushbullet將暫停顯示同步通知1小時。", 
    "thanks_for_installing_title": "感謝您安裝 Pushbullet", 
    "how_to_unmute_app": "我關閉了一個app的通知，如何再度開啟？", 
    "title_placeholder": "標題", 
    "message_placeholder": "鍵入消息，按輸入鍵發送", 
    "updated_notif_message": "按一下這裡，看看有什麼新功能", 
    "unmute_app": "已恢復同步 {1} 的通知", 
    "type_file": "檔案", 
    "panel_sign_up": "在 Pushbullet.com 上註冊 →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "連結 url", 
    "recipient_placeholder": "發送至", 
    "retry": "重試", 
    "option_play_sound": "收到通知時播放提示音", 
    "sms": "短訊", 
    "option_only_show_titles": "僅顯示訊息標題", 
    "sms_disclaimer": "發送文字訊息時，電話必須保持開機並連接互聯網。", 
    "reply": "回覆", 
    "see_full_history": "檢視完整記錄", 
    "type_link": "連結", 
    "undo": "復原", 
    "learn_more": "瞭解更多資訊", 
    "option_show_mirrors_desc": "取消勾選這會停止顯示通知 (你仍可以從工具列上的圖示看到通知數)。", 
    "push_label": "推送", 
    "option_play_sound_desc": "勾選后將使Pushbullet接收到通知時播放提示音", 
    "devices_placeholder": "選擇裝置", 
    "sending": "正在發送...", 
    "option_background_permission": "在瀏覽器關閉后繼續運行Pushbullet", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "解密失敗", 
    "push_context_message": "{1}在{2}", 
    "options": "設定", 
    "option_background_permission_desc": "開啓后將使Pushbullet成爲後臺應用程式，即使所有標籤頁關閉后依然可以正常接收通知", 
    "mirror_context_message": "於 {2} 由 Pushbullet 從 {1} 推送", 
    "encryption_password_needed_title": "收到已加密的資料", 
    "option_automatically_attach_link_desc": "", 
    "how_to_unmute_app_answer": "打開 Pushbullet Android 應用程式，從左邊拉出抽屜選單，然後點擊 '鏡像'' 。點擊 '只為一些應用程式'，然後重新啟用應用程式。", 
    "device": "裝置", 
    "done": "完成", 
    "cancel": "取消", 
    "snoozed_until": "休眠至{1}", 
    "sign_out": "登出", 
    "from": "來自 {1}", 
    "panel_cant_sign_in": "無法登入？請您嘗試暫時停用Adblock。若沒有任何幫助，Pushbullet 需要開啟第三方Cookie進行登入，您可以在登入後再次關閉。", 
    "option_allow_instant_push_desc": "使用鍵盤快擬鍵將目前的分頁推送至選定裝置", 
    "option_show_notification_count": "在通知欄顯示圖示", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "勾選后將使你選擇文字或圖片右擊時，菜單中顯示Pushbullet", 
    "panel_third_party_cookies": "點此瞭解如何修改此設置", 
    "option_show_mirrors": "在我的電腦上顯示通知。", 
    "notifications": "通知", 
    "option_use_dark_icon": "使用黑色圖示", 
    "add_a_friend": "添加好友", 
    "option_allow_instant_push": "開啟即時推送至", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "自動開啓傳送到瀏覽器的訊息", 
    "me": "我", 
    "file_too_big": "檔案過大", 
    "option_clipboard_permission": "多裝置複製 & 貼上", 
    "pushed_successfully": "發送成功", 
    "devices": "裝置", 
    "option_show_notification_count_desc": "看看您的工具列便可知道有幾則通知。", 
    "add_a_device": "添加設備", 
    "end_to_end_password_desc": "如果你選擇輸入密碼，此密碼將需要輸入在您每個設備上。", 
    "general": "一般", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "輸入訊息或拉入檔案", 
    "option_clipboard_permission_desc": "從一台裝置上複製文字，然後能貼到任何一台也啟用了此設定的裝置上。", 
    "no_pushes": "沒有最近的歷史紀錄", 
    "push_failed": "抱歉，我們無法發送此項目", 
    "option_notification_duration": "通知顯示時間長度", 
    "new_sms_thread": "新文字訊息", 
    "dismiss": "忽略", 
    "decryption_failed_body": "請確認您的密碼在所有設備上都正確", 
    "sign_in": "登入", 
    "go_to_link": "轉到連結", 
    "snooze": "休眠1小時", 
    "friends": "朋友", 
    "num_new_messages": "{1}則新訊息", 
    "remove_link_tooltip": "取消連結當前頁面", 
    "phone": "電話", 
    "mute_app": "停止同步來自 {1} 的通知", 
    "clear": "清除", 
    "end_to_end_password_label": "點到點加密密碼", 
    "add_link_tooltip": "連結目前頁面", 
    "option_only_show_titles_desc": "這將使Pushbullet僅顯示通知訊息的標題，內容隱藏", 
    "all_of_my_devices": "我的所有設備", 
    "unsubscribe_from_channel": "取消追蹤{1}", 
    "updated_notif_title": "Pushbullet 已更新！"
}; 
strings["tr"] = {
    "mute": "Sustur", 
    "thanks_for_installing_message": "Oturum açmak için tıklayın", 
    "option_open_my_pushes_automatically_desc": "Bu Pushbullet'in, yolladığınız bağlantıları otomatik olarak yeni sekmede açmasını sağlar.", 
    "unsubscribed_from_channel": "{1} artık takip etmiyorsunuz", 
    "option_show_context_menu": "Pushbullet'i context menüsünde göster", 
    "option_use_dark_icon_desc": "Araç çubuğundaki ikonun rengini koyu griye dönüştür.", 
    "alert_desktop_app_notifications": "Bildirimleri, Pushbullet Masaüstü Uygulaması yönetiyor.", 
    "sms_recipient_placeholder": "Kişi veya telefon numarası", 
    "message_placeholder_link": "Bir mesaj yazın ve göndermek için enter tuşuna basın", 
    "unsnooze": "Ertelemeyi durdur", 
    "encryption_password_needed_body": "Parolanızı girmek için buraya tıklayın", 
    "send": "Gönder", 
    "pushbullet_pro_feature": "", 
    "save": "Kaydet", 
    "option_instant_push_shortcuts_not_set": "ayarlanmadı", 
    "send_failed": "Gönderme başarısız", 
    "muted_app": "{1} susturuldu", 
    "now": "Şimdi", 
    "no_notifications": "Şu an için bildirim yok", 
    "advanced": "Gelişmiş", 
    "channels": "Kanallar", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "Yenilikler", 
    "snoozing_desc": "Pushbullet'te bir saat için bildirim gösterilmesini durdur.", 
    "thanks_for_installing_title": "Pushbullet'i yüklediğiniz için teşekkür ederiz", 
    "how_to_unmute_app": "Susturulmuş bir uygulamanın sesini nasıl açarım?", 
    "title_placeholder": "Başlık", 
    "message_placeholder": "Bir mesaj yazın ve göndermek için enter tuşuna basın", 
    "updated_notif_message": "Yenilikleri görmek için buraya tıklayın", 
    "unmute_app": " {1} Sesi aç", 
    "type_file": "Dosya", 
    "panel_sign_up": "Pushbullet.com üzerinden kaydolun →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Bağlantı adresi", 
    "recipient_placeholder": "Kime", 
    "retry": "Tekrar dene", 
    "option_play_sound": "Bir bildirim geldiğinde ses çal", 
    "sms": "SMS", 
    "option_only_show_titles": "Yalnızca bildirim başlıklarını göster", 
    "sms_disclaimer": "SMS göndermek için telefonunuz açık ve bir İnternet bağlantınız olmalıdır.", 
    "reply": "Yanıtla", 
    "see_full_history": "Tüm geçmişi gör", 
    "type_link": "Link", 
    "undo": "Geri al", 
    "learn_more": "Daha fazla bilgi edinin", 
    "option_show_mirrors_desc": "Tiki kaldırarak bildirimlerinizin görüntülenmesini durdurursunuz (ama hala araç çubuğu simgesinde bildirim sayısını görebilirsiniz).", 
    "push_label": "Push", 
    "option_play_sound_desc": "Bu Pushbullet'in, bir bildirim geldiğinde kısa bir ses çalarak sizi uyarmasını sağlar.", 
    "devices_placeholder": "Bir cihaz seçin", 
    "sending": "Gönderiliyor...", 
    "option_background_permission": "Tarayıcı kapalı olduğunda bile Pushbullet'i açık tut", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Şifre çözülemedi", 
    "push_context_message": "{1} ile saat {2}", 
    "options": "Ayarlar", 
    "option_background_permission_desc": "Bildirimleri tarayıcıyı açık tutmak zorunda kalmadan görmenize olanak sağlar.", 
    "mirror_context_message": "{1} Pushbullet ile saat {2}", 
    "encryption_password_needed_title": "Şifrelenmiş veri alındı", 
    "option_automatically_attach_link_desc": "Bu cihazlara daha hızlı bağlantı göndermenizi sağlar.", 
    "how_to_unmute_app_answer": "Pushbullet Android uygulamasında ekranı sola çekerek çekmeceyi açın, 'Yansıtma' seçeneğine dokunun. 'Uygulamalar için bildirim ayarları'ndan uygulamayı tekrar aktive edin.", 
    "device": "Cihaz", 
    "done": "Bitti", 
    "cancel": "İptal", 
    "snoozed_until": "{1}'e kadar ertelendi.", 
    "sign_out": "Oturumu Kapat", 
    "from": " {1}'dan", 
    "panel_cant_sign_in": "Giriş yapılamadı mı? Geçici olarak Adblock'u devre dışı bırakmayı deneyin. Bu işe yaramazsa, Pushbullet'e giriş yapmak için gereken üçüncü-parti çerezlerini açın. Giriş yaptıktan sonra tekrar devre dışı bırakabilirsiniz.", 
    "option_allow_instant_push_desc": "", 
    "option_show_notification_count": "Araç çubuğu simgesinde bildirim sayısını göster", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Pushbullet sağ tıklama ile açılan menüde gösterilir.", 
    "panel_third_party_cookies": "Ayarların nasıl değiştirileceğini görmek için buraya tıkla.", 
    "option_show_mirrors": "Bildirimlerinizi bilgisayarınız üzerinde görün.", 
    "notifications": "Bildirimler", 
    "option_use_dark_icon": "Karanlık ikon kullan", 
    "add_a_friend": "Bir arkadaş ekle", 
    "option_allow_instant_push": "Anlık bildirim göndermek için etkinleştirin", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "Bağlantıları otomatik olarak tarayıcıda aç.", 
    "me": "Ben", 
    "file_too_big": "Dosya çok büyük", 
    "option_clipboard_permission": "Evrensel kopyala & yapıştır", 
    "pushed_successfully": "Başarıyla gönderildi", 
    "devices": "Cihazlar", 
    "option_show_notification_count_desc": "Bildirim sayısını araç çubuğu simgesinde görebilirsiniz.", 
    "add_a_device": "Bir cihaz ekle", 
    "end_to_end_password_desc": "Eğer bir parola belirlemek isterseniz yazmanız yeterlidir. Bu parolanın tüm cihazlarınızda girilmesi gerekmektedir.", 
    "general": "Genel", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Bir mesaj yazın veya bir dosya bırakın", 
    "option_clipboard_permission_desc": "Metni kopyalayın ve bu ayarın açık olduğu herhangi bir cihazda yapıştırın.", 
    "no_pushes": "Hiç gönderi yok", 
    "push_failed": "Üzgünüm, bunu gönderemem", 
    "option_notification_duration": "Bildirimleri şu kadar sonra otomatik gizle", 
    "new_sms_thread": "Yeni metin iletisi", 
    "dismiss": "Gizle", 
    "decryption_failed_body": "Lütfen parolanızın tüm cihazlarda eşleştiğini onaylayın", 
    "sign_in": "Oturum Aç", 
    "go_to_link": "Bağlantıya git", 
    "snooze": "1 saat ertele", 
    "friends": "Arkadaşlar", 
    "num_new_messages": "{1} yeni ileti", 
    "remove_link_tooltip": "Geçerli sayfanın bağlantısını kaldır", 
    "phone": "Telefon", 
    "mute_app": "{1} bildirimlerini kapat", 
    "clear": "Temizle", 
    "end_to_end_password_label": "Uçtan uca şifreleme parolası", 
    "add_link_tooltip": "Geçerli sayfanın bağlantısı", 
    "option_only_show_titles_desc": "Bu Pushbullet'in, telefonunuzdan gelen bildirimlerin sadece başlığını görüntülemesini, iletilerin gizli tutmasını sağlar.", 
    "all_of_my_devices": "Tüm cihazlarım", 
    "unsubscribe_from_channel": "{1} takibi bırak", 
    "updated_notif_title": "Pushbullet güncellendi!"
}; 
strings["fr"] = {
    "mute": "Désactiver", 
    "thanks_for_installing_message": "Appuyez ici pour vous connecter", 
    "option_open_my_pushes_automatically_desc": "Avec cela Pushbullet ouvrira automatiquement tout ce que vous envoyez au navigateur dans un nouvel onglet.", 
    "unsubscribed_from_channel": "{1} n'est plus suivi", 
    "option_show_context_menu": "Afficher Pushbullet dans le menu contextuel", 
    "option_use_dark_icon_desc": "Cela rendra notre icône de la barre d'outil gris foncé.", 
    "alert_desktop_app_notifications": "L'application de bureau Pushbullet gère les notifications. La désactivation des notifications dans les paramètres de l'application de bureau retournera le contrôle à l'extension.", 
    "sms_recipient_placeholder": "Contact ou numéro de téléphone", 
    "message_placeholder_link": "Ajoutez un message, appuyez sur entrée pour envoyer", 
    "unsnooze": "Annuler l'interruption", 
    "encryption_password_needed_body": "Appuyez ici pour entrer votre mot de passe", 
    "send": "Envoyer", 
    "pushbullet_pro_feature": "Pushbullet Pro est nécessaire pour activer cette option.", 
    "save": "Enregistrer", 
    "option_instant_push_shortcuts_not_set": "non défini", 
    "send_failed": "Envoi impossible", 
    "muted_app": "{1} désactivé", 
    "now": "Maintenant", 
    "no_notifications": "Aucune notification actuellement", 
    "advanced": "Avancé", 
    "channels": "Canaux", 
    "option_automatically_attach_link": "Lier automatiquement l'onglet actif pour les messages vers un appareil", 
    "changelog_tab": "Quoi de nouveau", 
    "snoozing_desc": "L'interruption arrête l'affichage de vos notifications Pushbullet pendant une heure.", 
    "thanks_for_installing_title": "Merci d'avoir installé Pushbullet", 
    "how_to_unmute_app": "J'ai désactivé une application, comment la réactiver ?", 
    "title_placeholder": "Titre", 
    "message_placeholder": "Saisissez un message, appuyez sur entrée pour envoyer", 
    "updated_notif_message": "Appuyez ici pour voir les nouveautés", 
    "unmute_app": "Réactiver {1}", 
    "type_file": "Fichier", 
    "panel_sign_up": "Inscrivez-vous sur Pushbullet.com →", 
    "pushbullet_pro_required": "Pushbullet Pro requis", 
    "url_placeholder": "Lien URL", 
    "recipient_placeholder": "À", 
    "retry": "Réessayer", 
    "option_play_sound": "Jouer un son lorsqu'une notification arrive", 
    "sms": "SMS", 
    "option_only_show_titles": "Afficher uniquement les titres de notification", 
    "sms_disclaimer": "Le téléphone doit être allumé et disposer d'une connexion internet pour les SMS à envoyer.", 
    "reply": "Répondre", 
    "see_full_history": "Voir l'historique complet", 
    "type_link": "Lien", 
    "undo": "Annuler", 
    "learn_more": "En savoir plus", 
    "option_show_mirrors_desc": "Décocher ceci arrêtera les notifications (vous pourrez toujours voir le compteur sur notre icône de la barre de notifications).", 
    "push_label": "Envoyer", 
    "option_play_sound_desc": "Avec cela Pushbullet jouera un son court lorsqu'une notification est reçue pour vous alerter.", 
    "devices_placeholder": "Sélectionnez un appareil", 
    "sending": "Envoi en cours...", 
    "option_background_permission": "Garder Pushbullet en cours d'exécution lorsque mon navigateur est fermé", 
    "reply_limit_reached": "Vous avez atteint la limite du nombre de messages gratuits pour ce mois.", 
    "decryption_failed_title": "Déchiffrement impossible", 
    "push_context_message": "{1} à {2}", 
    "options": "Paramètres", 
    "option_background_permission_desc": "Cela vous permettra de voir vos notifications sans devoir garder une fenêtre de votre navigateur ouverte.", 
    "mirror_context_message": "{1} via Pushbullet à {2}", 
    "encryption_password_needed_title": "Données chiffrées reçues", 
    "option_automatically_attach_link_desc": "Cela rend l'envoi de liens aux appareils plus rapide.", 
    "how_to_unmute_app_answer": "Ouvrez l'application Pushbullet, ouvrez le menu de gauche, appuyez sur Mirroring. Appuyez ensuite sur \"uniquement pour certaines applications\", puis ré-autorisez l'application.", 
    "device": "Appareil", 
    "done": "Terminé", 
    "cancel": "Annuler", 
    "snoozed_until": "Interrompre jusqu'à {1}.", 
    "sign_out": "Déconnexion", 
    "from": "De {1}", 
    "panel_cant_sign_in": "Connexion impossible ? Essayez de désactiver temporairement Adblock. Si cela n'aide pas, Pushbullet requiert que des cookies tierce soit activé pour vous connecter. Vous pouvez les désactiver à nouveau après connexion.", 
    "option_allow_instant_push_desc": "Envoyer l'onglet actif pour l'appareil choisi par raccourci clavier.", 
    "option_show_notification_count": "Afficher le nombre de notifications sur l'icône de la barre d'outils", 
    "reply_limit_warning": "Vous êtes proche de la limite du nombre de messages gratuits pour ce mois.", 
    "option_show_context_menu_desc": "Afficher Pushbullet dans le menu de la liste des options (clic droit).", 
    "panel_third_party_cookies": "Appuyez ici pour savoir comment modifier ce paramètre.", 
    "option_show_mirrors": "Afficher les notifications sur mon ordinateur.", 
    "notifications": "Notifications", 
    "option_use_dark_icon": "Utiliser une icône sombre", 
    "add_a_friend": "Ajouter un ami", 
    "option_allow_instant_push": "Activer l'envoi instantané", 
    "option_instant_push_shortcuts": "Appuyez ici pour définir (actuellement {1}).", 
    "option_open_my_pushes_automatically": "Ouvrir ce que j'envoie sur ce navigateur automatiquement.", 
    "me": "Moi", 
    "file_too_big": "Fichier trop lourd", 
    "option_clipboard_permission": "Copier-coller universel", 
    "pushed_successfully": "Notifié avec succès", 
    "devices": "Appareils", 
    "option_show_notification_count_desc": "Voir d'un coup d’œil le nombre de notifications dans la barre d'outils.", 
    "add_a_device": "Ajouter un appareil", 
    "end_to_end_password_desc": "Si vous choisissez de mettre un mot de passe, ce mot de passe devra être identique sur tous vos appareils.", 
    "general": "Général", 
    "reply_limit_upgrade": "Passez à Pushbullet Pro pour envoyer des messages illimités.", 
    "message_placeholder_files": "Saisissez un message ou déposez un fichier", 
    "option_clipboard_permission_desc": "Copier du texte sur un appareil et le coller sur n'importe quel autre ayant aussi ce paramètre activé.", 
    "no_pushes": "Aucun historique récent", 
    "push_failed": "Désolé, impossible d'envoyer ça", 
    "option_notification_duration": "Masquer les notifications automatiquement après", 
    "new_sms_thread": "Nouveau SMS", 
    "dismiss": "Effacer", 
    "decryption_failed_body": "Veuillez vérifier que votre mot de passe est identique sur tous vos appareils", 
    "sign_in": "Connexion", 
    "go_to_link": "Aller au lien", 
    "snooze": "Interrompre 1h", 
    "friends": "Amis", 
    "num_new_messages": "{1} nouveaux messages", 
    "remove_link_tooltip": "Délier la page actuelle", 
    "phone": "Téléphone", 
    "mute_app": "Désactiver notifications de {1}", 
    "clear": "Effacer", 
    "end_to_end_password_label": "Mot de passe de chiffrement de bout en bout", 
    "add_link_tooltip": "Lien page actuelle", 
    "option_only_show_titles_desc": "Cela permet à Pushbullet d'afficher uniquement le titre des notifications, gardant le message privé.", 
    "all_of_my_devices": "Tous mes appareils", 
    "unsubscribe_from_channel": "Ne plus suivre {1}", 
    "updated_notif_title": "Pushbullet a été mis à jour !"
}; 
strings["cs"] = {
    "mute": "Vypnout oznámení", 
    "thanks_for_installing_message": "Klikněte sem pro přihlášení", 
    "option_open_my_pushes_automatically_desc": "Pushbullet automaticky otevře v nové záložce vše, co pošlete do tohoto prohlížeče .", 
    "unsubscribed_from_channel": "Již nesledujete {1}", 
    "option_show_context_menu": "Zobrazit Pushbullet v místní nabídce", 
    "option_use_dark_icon_desc": "Ikona v panelu nástrojů bude tmavě šedá.", 
    "alert_desktop_app_notifications": "Desktop aplikace Pushbullet spravuje oznámení.", 
    "sms_recipient_placeholder": "Kontakt nebo telefonní číslo", 
    "message_placeholder_link": "Přidejte zprávu, stisknutím Enter odešlete", 
    "unsnooze": "Zrušit odložení", 
    "encryption_password_needed_body": "Stiskněte pro zadání vašeho hesla", 
    "send": "Odeslat", 
    "pushbullet_pro_feature": "", 
    "save": "Uložit", 
    "option_instant_push_shortcuts_not_set": "nenastaveno", 
    "send_failed": "Odeslání se nezdařilo", 
    "muted_app": "Vypnuto {1}", 
    "now": "Teď", 
    "no_notifications": "Nemáte žádná oznámení", 
    "advanced": "Rozšířené", 
    "channels": "Kanály", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "Novinky", 
    "snoozing_desc": "Odložení zabrání Pushbullet v zobrazování oznámení na jednu hodinu.", 
    "thanks_for_installing_title": "Děkujeme za instalaci Pushbullet", 
    "how_to_unmute_app": "Ztlumil jsem aplikaci, jak mám ztlumení zrušit?", 
    "title_placeholder": "Předmět", 
    "message_placeholder": "Napište zprávu, stiskněte enter pro odeslání", 
    "updated_notif_message": "Klikněte sem, abyste viděli, co je nového", 
    "unmute_app": "Povolit oznámení od {1}", 
    "type_file": "Soubor", 
    "panel_sign_up": "Zaregistrujte se na Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "", 
    "recipient_placeholder": "Komu", 
    "retry": "Zkusit znovu", 
    "option_play_sound": "Přehrát zvuk při doručení oznámení.", 
    "sms": "SMS", 
    "option_only_show_titles": "Zobrazovat pouze nadpisy oznámení.", 
    "sms_disclaimer": "", 
    "reply": "Odpovědět", 
    "see_full_history": "Zobrazit celou historii", 
    "type_link": "Odkaz", 
    "undo": "Zrušit", 
    "learn_more": "Číst více", 
    "option_show_mirrors_desc": "", 
    "push_label": "Push", 
    "option_play_sound_desc": "Pushbullet přehraje krátký zvuk při doručení oznámení, čímž vás na něj upozorní.", 
    "devices_placeholder": "Vyberte zařízení", 
    "sending": "Probíhá odesílání...", 
    "option_background_permission": "Ponechat Pushbullet spuštěný, když je prohlížeč zavřený", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Dešifrování selhalo", 
    "push_context_message": "{1} na {2}", 
    "options": "Nastavení", 
    "option_background_permission_desc": "Toto umožní, abyste viděli svá oznámení, aniž byste museli mít otevřené okno prohlížeče.", 
    "mirror_context_message": "{1} přes Pushbullet na {2}", 
    "encryption_password_needed_title": "Zašifrovaná data přijata", 
    "option_automatically_attach_link_desc": "", 
    "how_to_unmute_app_answer": "", 
    "device": "Zařízení", 
    "done": "Hotovo", 
    "cancel": "Zrušit", 
    "snoozed_until": "Odloženo do {1}.", 
    "sign_out": "Odhlásit se", 
    "from": "Od {1}", 
    "panel_cant_sign_in": "Nemůžete se přihlásit? Zkuste dočasně deaktivujte Adblock. Pokud to nepomůže, Pushbullet vyžaduje k přihlášení soubory cookies třetích stran. Po přihlášení je můžete znovu zakázat.", 
    "option_allow_instant_push_desc": "", 
    "option_show_notification_count": "Zobrazit počet upozornění na ikoně", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Zobrazit Pushbullet v seznamu možností nabídky zobrazené po kliknutí pravým tlačítkem myši.", 
    "panel_third_party_cookies": "Klikněte sem pro zjištění, jak změnit toto nastavení.", 
    "option_show_mirrors": "", 
    "notifications": "Oznámení", 
    "option_use_dark_icon": "Používat tmavou ikonu", 
    "add_a_friend": "Přidat přítele", 
    "option_allow_instant_push": "Povolit okamžité odesílání do", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "Automaticky otevírat věci, které postrčím do tohoto prohlížeče.", 
    "me": "Já", 
    "file_too_big": "Soubor je příliš velký", 
    "option_clipboard_permission": "Univerzální kopírovat & vložit", 
    "pushed_successfully": "Úspěšně postrčeno", 
    "devices": "Zařízení", 
    "option_show_notification_count_desc": "Zobrazit počet upozornění na liště.", 
    "add_a_device": "Přidat zařízení", 
    "end_to_end_password_desc": "", 
    "general": "Obecné", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Napište zprávu nebo vyberte soubor", 
    "option_clipboard_permission_desc": "Kopírování textu na zařízení a potom ji vložit na jiné, které má také je toto nastavení povoleno.", 
    "no_pushes": "Žádná nedávná historie", 
    "push_failed": "Bohužel, toto jsme nemohli postrčit", 
    "option_notification_duration": "Skrýt oznámení automaticky po", 
    "new_sms_thread": "Nová textová zpráva", 
    "dismiss": "Zavřít", 
    "decryption_failed_body": "", 
    "sign_in": "Přihlásit se", 
    "go_to_link": "Přejít na odkaz", 
    "snooze": "Odložit o 1 hod", 
    "friends": "Přátelé", 
    "num_new_messages": "{1} nových zpráv", 
    "remove_link_tooltip": "Odeberte odkaz", 
    "phone": "Telefon", 
    "mute_app": "Vypnout oznámení od {1}", 
    "clear": "Vyčistit", 
    "end_to_end_password_label": "", 
    "add_link_tooltip": "Odkaz na aktuální stránku", 
    "option_only_show_titles_desc": "Pushbullet bude zobrazovat pouze nadpis upozornění.", 
    "all_of_my_devices": "Všechna má zařízení", 
    "unsubscribe_from_channel": "Nesledovat {1}", 
    "updated_notif_title": "Pushbullet byl aktualizován!"
}; 
strings["ja"] = {
    "mute": "ミュート", 
    "thanks_for_installing_message": "ここをクリックしてサインイン", 
    "option_open_my_pushes_automatically_desc": "このブラウザへ何かをプッシュしたら自動的に新しいタブで開きます。", 
    "unsubscribed_from_channel": "", 
    "option_show_context_menu": "Pushbullet をコンテキストメニューに表示", 
    "option_use_dark_icon_desc": "ツールバーのアイコンにダークグレーのアイコンを使用します。", 
    "alert_desktop_app_notifications": "Pushbulletのデスクトップアプリが通知を管理しています。", 
    "sms_recipient_placeholder": "連絡先、または電話番号", 
    "message_placeholder_link": "追加メッセージを送信する enter キーを押します", 
    "unsnooze": "スヌーズ解除", 
    "encryption_password_needed_body": "パスワードを入力するにはここをクリック", 
    "send": "送信", 
    "pushbullet_pro_feature": "", 
    "save": "保存", 
    "option_instant_push_shortcuts_not_set": "", 
    "send_failed": "送信に失敗しました", 
    "muted_app": "{1} をミュートしました", 
    "now": "今", 
    "no_notifications": "", 
    "advanced": "高度な設定", 
    "channels": "チャンネル", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "新着情報", 
    "snoozing_desc": "スヌーズを有効にすると Pushbullet からの通知が1時間非表示になります。", 
    "thanks_for_installing_title": "Pushbullet をご利用いただきありがとうございます", 
    "how_to_unmute_app": "", 
    "title_placeholder": "タイトル", 
    "message_placeholder": "送信するにはメッセージを入力してenter キーを押してください", 
    "updated_notif_message": "クリックして新着情報を確認する", 
    "unmute_app": "{1} のミュートを解除", 
    "type_file": "ファイル", 
    "panel_sign_up": "Pushbullet.com にサインアップ →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "URLリンク", 
    "recipient_placeholder": "To", 
    "retry": "再試行", 
    "option_play_sound": "通知を受け取ったらサウンドを再生", 
    "sms": "SMS", 
    "option_only_show_titles": "通知のタイトルのみ表示", 
    "sms_disclaimer": "", 
    "reply": "返信", 
    "see_full_history": "完全な履歴", 
    "type_link": "リンク", 
    "undo": "元に戻す", 
    "learn_more": "詳細情報", 
    "option_show_mirrors_desc": "", 
    "push_label": "プッシュ", 
    "option_play_sound_desc": "通知を受け取ったら短いサウンドを鳴らして知らせます。", 
    "devices_placeholder": "デバイスを選択して下さい。", 
    "sending": "送信しています...", 
    "option_background_permission": "ブラウザを閉じた後も Pushbullet の処理を続行", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "暗号化に失敗しました", 
    "push_context_message": "", 
    "options": "設定", 
    "option_background_permission_desc": "ブラウザを開いたままにしなくても通知を確認できるようになります。", 
    "mirror_context_message": "{1} 経由 Pushbullet 時刻 {2}", 
    "encryption_password_needed_title": "暗号化されたデータの受信", 
    "option_automatically_attach_link_desc": "", 
    "how_to_unmute_app_answer": "", 
    "device": "デバイス", 
    "done": "完了", 
    "cancel": "キャンセル", 
    "snoozed_until": "{1} までスヌーズ", 
    "sign_out": "サインアウト", 
    "from": "{1} からのプッシュ", 
    "panel_cant_sign_in": "サインイン出来ませんか？一時的にAdblockを無効にしてみてください。それでも問題が解決しない場合、Pushbulletはサインインするのためにサード パーティのcookieを有効にする必要があります。それらはサインインの後に再び無効にできます。", 
    "option_allow_instant_push_desc": "", 
    "option_show_notification_count": "", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "右クリックメニューに Pushbullet を表示します。", 
    "panel_third_party_cookies": "ここをクリックして設定の変更方法を見る", 
    "option_show_mirrors": "コンピュータ上に通知を表示する", 
    "notifications": "通知", 
    "option_use_dark_icon": "ダークアイコンを使用", 
    "add_a_friend": "+ 友だちを追加", 
    "option_allow_instant_push": "", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "このブラウザへプッシュしたものを自動的に開く", 
    "me": "私", 
    "file_too_big": "ファイルが大きすぎます", 
    "option_clipboard_permission": "ユニバーサル コピー＆ペースト", 
    "pushed_successfully": "プッシュ成功", 
    "devices": "端末", 
    "option_show_notification_count_desc": "", 
    "add_a_device": "+ 端末を追加", 
    "end_to_end_password_desc": "", 
    "general": "一般", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "メッセージを入力するか、ファイルをドロップして下さい", 
    "option_clipboard_permission_desc": "ある端末でコピーしたテキストを、設定が有効になっている他の端末で貼り付けられます。", 
    "no_pushes": "最近の履歴はありません", 
    "push_failed": "すみません、プッシュできませんでした。", 
    "option_notification_duration": "通知を自動的に隠すまでの時間：", 
    "new_sms_thread": "新しいテキストメッセージ", 
    "dismiss": "消去", 
    "decryption_failed_body": "", 
    "sign_in": "サインイン", 
    "go_to_link": "リンク先へ移動", 
    "snooze": "1 時間スヌーズ", 
    "friends": "フレンド", 
    "num_new_messages": "", 
    "remove_link_tooltip": "現在のページをアンリンク", 
    "phone": "携帯電話", 
    "mute_app": "{1} の通知をミュート", 
    "clear": "クリア", 
    "end_to_end_password_label": "", 
    "add_link_tooltip": "現在のページをリンク", 
    "option_only_show_titles_desc": "", 
    "all_of_my_devices": "すべての端末", 
    "unsubscribe_from_channel": "", 
    "updated_notif_title": "Pushbullet がアップデートされました！"
}; 
strings["da"] = {
    "mute": "Dæmp", 
    "thanks_for_installing_message": "Klik her for at logge ind", 
    "option_open_my_pushes_automatically_desc": "Dette vil få Pushbullet til at åbne alt, du pusher til denne browser, automatisk i en ny fane.", 
    "unsubscribed_from_channel": "Følges ikke længere {1}", 
    "option_show_context_menu": "Vis Pushbullet i kontekstmenuen", 
    "option_use_dark_icon_desc": "Dette vil gøre vores værktøjslinie-ikon mørkegråt.", 
    "alert_desktop_app_notifications": "Pushbullet desktop appen håndterer meddelelser.", 
    "sms_recipient_placeholder": "Kontakt eller telefonnummer", 
    "message_placeholder_link": "Tilføj en besked, tryk Retur for at afsende", 
    "unsnooze": "Unsnooze", 
    "encryption_password_needed_body": "Klik her for at angivee din adgangskode", 
    "send": "Send", 
    "pushbullet_pro_feature": "Pushbullet Pro er tvunget til at aktivere denne funktion.", 
    "save": "Gem", 
    "option_instant_push_shortcuts_not_set": "ikke angivet", 
    "send_failed": "Afsendelse mislykkedes", 
    "muted_app": "Dæmpede {1}", 
    "now": "Nu", 
    "no_notifications": "Ingen notifikationer lige nu", 
    "advanced": "Avanceret", 
    "channels": "Kanaler", 
    "option_automatically_attach_link": "Vedhæft automatisk den aktuelle fane til beskeden til en enhed", 
    "changelog_tab": "Hvad er nyt", 
    "snoozing_desc": "Snoozing stopper Pushbullet fra at vise dine notifikationer i en time.", 
    "thanks_for_installing_title": "Tak for at du installerede Pushbullet", 
    "how_to_unmute_app": "Jeg satte en app på lydløs, hvordan slår jeg lyden til igen?", 
    "title_placeholder": "Titel", 
    "message_placeholder": "Skriv en besked, tryk Retur for at afsende", 
    "updated_notif_message": "Klik her for at se hvad der er nyt", 
    "unmute_app": "Lyd til {1}", 
    "type_file": "Fil", 
    "panel_sign_up": "Tilmeld dig på Pushbullet.com →", 
    "pushbullet_pro_required": "Pushbullet Pro påkrævet", 
    "url_placeholder": "Link URL", 
    "recipient_placeholder": "Til", 
    "retry": "Forsøg igen", 
    "option_play_sound": "Afspil en lyd når en notifikation modtages", 
    "sms": "SMS", 
    "option_only_show_titles": "Viser kun notifikationers titler", 
    "sms_disclaimer": "Enheden skal være tændt og tilsluttet Internet for kunne afsende SMS'er.", 
    "reply": "Besvar", 
    "see_full_history": "Vise fuld historik", 
    "type_link": "Link", 
    "undo": "Fortryd", 
    "learn_more": "Få mere at vide", 
    "option_show_mirrors_desc": "Afmarkering af dette vil hindre os i at vise notifikationer (du kan fortsat se antal i vores værktøjsbjælken).", 
    "push_label": "Push", 
    "option_play_sound_desc": "Dette vil få Pushbullet til at afspille en kort lyd når en notifikation modtages, for at advare om dette.", 
    "devices_placeholder": "Vælg en enhed", 
    "sending": "Afsender...", 
    "option_background_permission": "Hold Pushbullet kørende når min browser er lukket", 
    "reply_limit_reached": "Du har nået grænsen for gratis beskeder for denne måned.", 
    "decryption_failed_title": "Dekryptering mislykkedes", 
    "push_context_message": "{1} på {2}", 
    "options": "Indstillinger", 
    "option_background_permission_desc": "Dette vil gøre dig i stand til at se dine notifikationer uden at have et browservindue åbent.", 
    "mirror_context_message": "{1} via Pushbullet på {2}", 
    "encryption_password_needed_title": "Krypteret data modtaget", 
    "option_automatically_attach_link_desc": "Dette gør afsendelse af links til enheder hurtigere.", 
    "how_to_unmute_app_answer": "Åbn Pushbullet Android app'en, træk skuffen ud fra venstre, tryk dernæst 'Spejling'. Tryk her 'Kun for visse apps', og genaktivér derefter app'en.", 
    "device": "Enhed", 
    "done": "Udført", 
    "cancel": "Annuller", 
    "snoozed_until": "Snooze indtil {1}.", 
    "sign_out": "Log ud", 
    "from": "Fra {1}", 
    "panel_cant_sign_in": "Problemer med at logge ind? Prøv midlertidigt at deaktivere Adblock. Hvis det ikke hjælper, kræver Pushbullet at tredjeparts-cookies er aktiveret for at logge ind. Du kan deaktivere dem efter at have logget ind.", 
    "option_allow_instant_push_desc": "Skub den aktuelle fane til den valgte enhed via tastaturgenvej.", 
    "option_show_notification_count": "Vis notifikationstæller på værktøjsbjælke-ikonet", 
    "reply_limit_warning": "Du nærmer dig grænsen for gratis beskeder for denne måned.", 
    "option_show_context_menu_desc": "Vis Pushbullet i listen over højreklik menuindstillinger.", 
    "panel_third_party_cookies": "Klik her for at se hvordan du ændrer denne indstilling.", 
    "option_show_mirrors": "Vis notifikationer på min computer.", 
    "notifications": "Notifikationer", 
    "option_use_dark_icon": "Brug mørkt ikon", 
    "add_a_friend": "Tilføj en ven", 
    "option_allow_instant_push": "Aktivér øjeblikkelig skub til", 
    "option_instant_push_shortcuts": "Klik her for at angive (i øjeblikket {1}).", 
    "option_open_my_pushes_automatically": "Åben ting jeg pusher automatisk i denne browser.", 
    "me": "Mig", 
    "file_too_big": "Fil for stor", 
    "option_clipboard_permission": "Universel kopiér & indsæt", 
    "pushed_successfully": "Pushet med succes", 
    "devices": "Enheder", 
    "option_show_notification_count_desc": "Se med et øjekast din notifikationstæller i din værktøjsbjælke.", 
    "add_a_device": "Tilføj en enhed", 
    "end_to_end_password_desc": "Vælger at angive en adgangskode, skal denne adgangskoden ligeledes angives på hver af dine enheder.", 
    "general": "Generelt", 
    "reply_limit_upgrade": "Opgradér til Pushbullet Pro for ubegrænset at sende beskeder.", 
    "message_placeholder_files": "Skriv en besked eller slip en fil her", 
    "option_clipboard_permission_desc": "Kopiér en tekst på én enhed, og indsæt den på enhver enhed, hvor denne indstilling ligeledes er aktiveret.", 
    "no_pushes": "Ingen seneste historik", 
    "push_failed": "Beklager, vi kunne desværre ikke pushe det", 
    "option_notification_duration": "Skjul mine notifikationer automatisk efter", 
    "new_sms_thread": "Ny SMS-besked", 
    "dismiss": "Minimer", 
    "decryption_failed_body": "Verificér venligst at din adgangskode matcher på alle enheder", 
    "sign_in": "Log ind", 
    "go_to_link": "Gå til link", 
    "snooze": "Snooze 1t", 
    "friends": "Venner", 
    "num_new_messages": "{1} nye beskeder", 
    "remove_link_tooltip": "Fjern link til nuværende side", 
    "phone": "Telefon", 
    "mute_app": "Dæmp {1} notifikationer", 
    "clear": "Ryd", 
    "end_to_end_password_label": "Punkt-til-punkt krypteret adgangskode", 
    "add_link_tooltip": "Link nuværende side", 
    "option_only_show_titles_desc": "Dette får Pushbullet til kun at vise notifikationstitlen, og holde selve beskeden skjult (privat).", 
    "all_of_my_devices": "Alle mine enheder", 
    "unsubscribe_from_channel": "Følg ikke {1}", 
    "updated_notif_title": "Pushbullet er opdateret!"
}; 
strings["ms"] = {
    "mute": "Senyapkan", 
    "thanks_for_installing_message": "Klik di sini untuk daftar masuk", 
    "option_open_my_pushes_automatically_desc": "Ini akan membuat Pushbullet akan membuka apa jua yang anda tolak untuk pelayar ini secara automatik di tab baru.", 
    "unsubscribed_from_channel": "", 
    "option_show_context_menu": "Tunjukkan Pushbullet dalam menu konteks pelayar saya", 
    "option_use_dark_icon_desc": "Ini akan membuat ikon toolbar menjadi kelabu gelap.", 
    "alert_desktop_app_notifications": "Aplikasi desktop Pushbullet mengurus notifikasi.", 
    "sms_recipient_placeholder": "", 
    "message_placeholder_link": "", 
    "unsnooze": "Nyahtidur", 
    "encryption_password_needed_body": "", 
    "send": "Hantar", 
    "pushbullet_pro_feature": "", 
    "save": "Simpan", 
    "option_instant_push_shortcuts_not_set": "", 
    "send_failed": "", 
    "muted_app": "Senyapkan {1}", 
    "now": "", 
    "no_notifications": "", 
    "advanced": "Lanjutan", 
    "channels": "Saluran", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "Apa Yang Baru", 
    "snoozing_desc": "Fungsi tidur menghalang Pushbullet dari memaparkan notifikasi selama satu jam.", 
    "thanks_for_installing_title": "Terima kasih kerana memasang Pushbullet", 
    "how_to_unmute_app": "", 
    "title_placeholder": "Tajuk", 
    "message_placeholder": "", 
    "updated_notif_message": "Klik di sini untuk melihat apa yang baru", 
    "unmute_app": "Mennyahsenyapkan {1}", 
    "type_file": "Fail", 
    "panel_sign_up": "Daftar di Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "", 
    "recipient_placeholder": "Kepada", 
    "retry": "", 
    "option_play_sound": "Mainkan bunyi apabila notifikasi tiba.", 
    "sms": "SMS", 
    "option_only_show_titles": "Hanya tunjukkan tajuk notifikasi.", 
    "sms_disclaimer": "", 
    "reply": "Balas", 
    "see_full_history": "", 
    "type_link": "Pautan", 
    "undo": "Undur", 
    "learn_more": "", 
    "option_show_mirrors_desc": "", 
    "push_label": "Tolak", 
    "option_play_sound_desc": "Ini akan membuat Pushbullet memainkan bunyi yang pendek apabila notifikasi tiba.", 
    "devices_placeholder": "", 
    "sending": "", 
    "option_background_permission": "Biarkan Pushbullet berfungsi walaupun pelayar saya ditutup", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "", 
    "push_context_message": "", 
    "options": "Tetapan", 
    "option_background_permission_desc": "Ini akan membolehkan anda melihat notifikasi anda tanpa perlu membuka tetingkap pelayar.", 
    "mirror_context_message": "", 
    "encryption_password_needed_title": "", 
    "option_automatically_attach_link_desc": "", 
    "how_to_unmute_app_answer": "", 
    "device": "", 
    "done": "Selesai", 
    "cancel": "Batal", 
    "snoozed_until": "Tidur sehingga {1}.", 
    "sign_out": "Dafat keluar", 
    "from": "Dari {1}", 
    "panel_cant_sign_in": "Tidak dapat mendaftar masuk? Cuba nyahaktifkan Adblock buat sementara waktu. Jika itu tidak membantu, Pushbullet memerlukan cookies dari pihak ketiga diaktifkan untuk mendaftar masuk. Anda boleh nyahaktifkan cookies tersebut kembali setelah mendaftar masuk.", 
    "option_allow_instant_push_desc": "", 
    "option_show_notification_count": "Tunjukkan bilangan pemberitahuan pada ikon toolbar", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Tunjukkan Pushbullet dalam senarai pilihan menu klik-kanan.", 
    "panel_third_party_cookies": "Klik di sini untuk mengubah tetapan ini.", 
    "option_show_mirrors": "", 
    "notifications": "Notifikasi", 
    "option_use_dark_icon": "Guna ikon gelap", 
    "add_a_friend": "Tambah rakan", 
    "option_allow_instant_push": "", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "Buka benda yang saya tolak ke pelayar ini secara automatik.", 
    "me": "", 
    "file_too_big": "", 
    "option_clipboard_permission": "Salin & tampal universal", 
    "pushed_successfully": "Tolakan berjaya", 
    "devices": "Peranti", 
    "option_show_notification_count_desc": "Lihat sekilas pandang bilangan pemberitahuan di toolbar anda.", 
    "add_a_device": "Tambah peranti", 
    "end_to_end_password_desc": "", 
    "general": "Am", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "", 
    "option_clipboard_permission_desc": "Salin teks pada peranti, kemudian tampalkannya pada peranti lain yang juga mengaktifkan tetapan ini.", 
    "no_pushes": "", 
    "push_failed": "Maaf, kami tidak dapat menolak itu", 
    "option_notification_duration": "Sembunyi notifikasi secara automatik selepas", 
    "new_sms_thread": "", 
    "dismiss": "Keluar", 
    "decryption_failed_body": "", 
    "sign_in": "Daftar masuk", 
    "go_to_link": "Pergi ke pautan", 
    "snooze": "Tidur 1 jam", 
    "friends": "Rakan", 
    "num_new_messages": "", 
    "remove_link_tooltip": "", 
    "phone": "", 
    "mute_app": "Senyapkan {1} pemberitahuan", 
    "clear": "", 
    "end_to_end_password_label": "", 
    "add_link_tooltip": "", 
    "option_only_show_titles_desc": "", 
    "all_of_my_devices": "Semua peranti saya", 
    "unsubscribe_from_channel": "", 
    "updated_notif_title": "Pushbullet telah dikemaskini!"
}; 
strings["vi"] = {
    "mute": "Tắt âm", 
    "thanks_for_installing_message": "Bấm vào đây để đăng nhập", 
    "option_open_my_pushes_automatically_desc": "Điều này giúp Pushbullet tự mở mọi thứ bạn truyền đến trình duyệt này trong tab mới.", 
    "unsubscribed_from_channel": "Không còn theo dõi {1}", 
    "option_show_context_menu": "Hiển thị Pushbullet trong trình tùy chọn", 
    "option_use_dark_icon_desc": "ĐIều này sẽ khiến biểu tượng thanh công cụ chuyển sáng màu xám tối.", 
    "alert_desktop_app_notifications": "Ứng dụng  Pushbullet cho máy tính đang quản lý các thông báo. Vô hiệu hóa thông báo trong phần cài đặt  của ứng dụng cho máy tính sẽ trả lại quyền kiểm soát cho tiện ích mở rộng.", 
    "sms_recipient_placeholder": "Số liên lạc hoặc số điện thoại", 
    "message_placeholder_link": "Thêm một tin nhắn, bấm enter để gửi", 
    "unsnooze": "Bỏ báo lại", 
    "encryption_password_needed_body": "Bấm vào để nhập mã", 
    "send": "Gửi", 
    "pushbullet_pro_feature": "", 
    "save": "Lưu", 
    "option_instant_push_shortcuts_not_set": "chưa thiết lập", 
    "send_failed": "Gửi không thành công", 
    "muted_app": "Đã tắt {1}", 
    "now": "Hiện tại", 
    "no_notifications": "Hiện không có tin nhắn", 
    "advanced": "Nâng cao", 
    "channels": "Kênh", 
    "option_automatically_attach_link": "Tự động đính kèm tab hiện tại vào tin nhắn đến thiết bị", 
    "changelog_tab": "Có gì mới", 
    "snoozing_desc": "Tính năng báo lại sẽ ngăn Pushbullet đưa tin lên thanh thông báo trong 1 giờ.", 
    "thanks_for_installing_title": "Cảm ơn đã cài đặt Pushbullet", 
    "how_to_unmute_app": "Tôi đã tắt thông báo một ứng dụng, làm thế nào để mở thông báo?", 
    "title_placeholder": "Tiêu đề", 
    "message_placeholder": "Tạo một tin nhắn, nhấn enter để gửi", 
    "updated_notif_message": "Bấm vào để xem có gì mới", 
    "unmute_app": "Bỏ tắt âm {1}", 
    "type_file": "Tập tin", 
    "panel_sign_up": "Đăng ký trên Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Đường dẫn url", 
    "recipient_placeholder": "Đến", 
    "retry": "Thử lại", 
    "option_play_sound": "Âm thanh phát ra khi có thông báo đến", 
    "sms": "SMS", 
    "option_only_show_titles": "Chỉ hiển thị tựa đề thông báo", 
    "sms_disclaimer": "Điện thoại phải đang mở và có mạng để gửi tin nhắn.", 
    "reply": "Trả lời", 
    "see_full_history": "Xem lịch sử đầy đủ", 
    "type_link": "Liên kết", 
    "undo": "Hoàn tác", 
    "learn_more": "Tìm hiểu thêm", 
    "option_show_mirrors_desc": "Bỏ chọn dòng này sẽ làm ứng dụng ngừng hiện thông báo (bạn vẫn có thể thấy số đếm trên biểu tượng toolbar).", 
    "push_label": "Truyền", 
    "option_play_sound_desc": "Điều này khiến Pushbullet phát 1 đoạn âm ngắn khi có thông báo đến, nhằm nhắc bạn về điều đó.", 
    "devices_placeholder": "Chọn một thiết bị", 
    "sending": "Đang gửi...", 
    "option_background_permission": "Luôn chạy Pushbullet khi đã đóng trình duyệt", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Giải mã bất thành", 
    "push_context_message": "{1} tại {2}", 
    "options": "Cài đặt", 
    "option_background_permission_desc": "Điều này cho phép bạn thấy các thông báo của bạn mà không cần luôn mở cửa sổ trình duyệt.", 
    "mirror_context_message": "{1} thông qua Pushbullet tại {2}", 
    "encryption_password_needed_title": "Mã hóa dữ liệu nhận được", 
    "option_automatically_attach_link_desc": "Giúp gửi đường dẫn đến thiết bị nhanh hơn.", 
    "how_to_unmute_app_answer": "Mở ứng dụng Pushbullet Android, kéo thanh bên trái, sau đó chọn 'Chuyển hướng'. Ở đây, chọn 'Chỉ với vài ứng dụng', sau đó bật lại ứng dụng.", 
    "device": "Thiết bị", 
    "done": "Xong", 
    "cancel": "Hủy bỏ", 
    "snoozed_until": "Báo lại cho đến khi {1}.", 
    "sign_out": "Đăng xuất", 
    "from": "Từ {1}", 
    "panel_cant_sign_in": "Không thể đăng nhập? Thử tạm tắt chặn quảng cáo. Nếu chưa được, để đăng nhập Pushbullet đòi hỏi kích hoạt cookie bên thứ ba. Bạn có thể vô hiệu hóa chúng sau khi đã đăng nhập.", 
    "option_allow_instant_push_desc": "Truyền tab hiện tại đến thiết bị được chọn qua phím tắt.", 
    "option_show_notification_count": "Hiển thị số lượng thông báo ở biểu tượng trên thanh công cụ", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Hiển thị Pushbullet trong danh sách các trình tùy chọn khi bấm chuột phải.", 
    "panel_third_party_cookies": "Bấm vào đây để biết cách thay đổi thiết lập này.", 
    "option_show_mirrors": "Hiển thị thông báo trên mấy tính của tôi.", 
    "notifications": "Thông báo", 
    "option_use_dark_icon": "Dùng biểu tượng màu tối", 
    "add_a_friend": "+ Thêm bạn", 
    "option_allow_instant_push": "Kích hoạt truyền ngay đến", 
    "option_instant_push_shortcuts": "Bấm vào đây để thiết lập (hiện là {1}).", 
    "option_open_my_pushes_automatically": "Tự mở mọi thứ tôi truyền cho trình duyệt này.", 
    "me": "Tôi", 
    "file_too_big": "File quá lớn", 
    "option_clipboard_permission": "Toàn quyền sao & chép", 
    "pushed_successfully": "Đã truyền", 
    "devices": "Thiết bị", 
    "option_show_notification_count_desc": "Xem số lượng thông báo nhanh chóng trên thanh công cụ.", 
    "add_a_device": "+ Thêm thiết bị", 
    "end_to_end_password_desc": "Nếu bạn chọn nhập mật mã, mật mã này sẽ dùng để đăng nhập trên từng thiết bị bạn có.", 
    "general": "Tổng quan", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Tạo một tin nhắn hoặc kéo thả một tệp", 
    "option_clipboard_permission_desc": "Sao văn bản từ một thiết bị, sau đó chép qua bên khác đã được kích hoạt cài đặt này.", 
    "no_pushes": "Không có lịch sử gần đây", 
    "push_failed": "Xin lỗi, không thể truyền dữ liệu này", 
    "option_notification_duration": "Tự động ẩn thông báo sau khi", 
    "new_sms_thread": "Tin nhắn mới", 
    "dismiss": "Bỏ qua", 
    "decryption_failed_body": "Vui lòng xác nhận mật khẩu dùng cho mọi thiết bị", 
    "sign_in": "Đăng nhập", 
    "go_to_link": "Đến liên kết", 
    "snooze": "Báo lại sau 1h", 
    "friends": "Bạn bè", 
    "num_new_messages": "{1} tin nhắn mới", 
    "remove_link_tooltip": "Bỏ liên kết trang hiện tại", 
    "phone": "Điện thoại", 
    "mute_app": "Tắt âm {1} thông báo", 
    "clear": "Xoá", 
    "end_to_end_password_label": "Mã hóa mật khẩu end-to-end", 
    "add_link_tooltip": "Liên kết trang hiện tại", 
    "option_only_show_titles_desc": "Chỉ hiển thị tiêu đề của thông báo, giữ riêng tư cho tin nhắn.", 
    "all_of_my_devices": "Các thiết bị của tôi", 
    "unsubscribe_from_channel": "Bỏ theo dõi {1}", 
    "updated_notif_title": "Đã cập nhật Pushbullet!"
}; 
strings["zh-CN"] = {
    "mute": "不再同步通知", 
    "thanks_for_installing_message": "点击此处登录", 
    "option_open_my_pushes_automatically_desc": "勾选后浏览器自动在新标签页中打开推送到该浏览器的图片、链接或者其他内容。", 
    "unsubscribed_from_channel": "不再关注 {1}", 
    "option_show_context_menu": "在右键菜单中显示 Pushbullet", 
    "option_use_dark_icon_desc": "勾选后使工具栏图标变成灰黑配色", 
    "alert_desktop_app_notifications": "桌面版 Pushbullet 正在管理通知。在桌面版软件中禁用通知后您可以用浏览器扩展来控制。", 
    "sms_recipient_placeholder": "联系人或电话号码", 
    "message_placeholder_link": "添加一条消息，按回车键发送", 
    "unsnooze": "停止休眠", 
    "encryption_password_needed_body": "单击此处输入您的密码", 
    "send": "发送", 
    "pushbullet_pro_feature": "启用此功能需要 Pushbullet Pro。", 
    "save": "保存", 
    "option_instant_push_shortcuts_not_set": "未设置", 
    "send_failed": "发送失败", 
    "muted_app": "{1} 已设为不再同步通知", 
    "now": "现在", 
    "no_notifications": "当前无通知", 
    "advanced": "进阶", 
    "channels": "频道", 
    "option_automatically_attach_link": "在推送至设备的信息中自动附加当前选项卡", 
    "changelog_tab": "更新日志", 
    "snoozing_desc": "休眠后，Pushbullet 将于 1 小时内暂停显示同步通知。", 
    "thanks_for_installing_title": "感谢您安装 Pushbullet", 
    "how_to_unmute_app": "我静音了一个应用，如何取消静音？", 
    "title_placeholder": "标题", 
    "message_placeholder": "输入信息，按回车键发送", 
    "updated_notif_message": "点此查看更新日志", 
    "unmute_app": "恢复来自 {1} 的消息", 
    "type_file": "文件", 
    "panel_sign_up": "前往 Pushbullet.com 注册帐户 →", 
    "pushbullet_pro_required": "需要 Pushbullet Pro", 
    "url_placeholder": "链接网址", 
    "recipient_placeholder": "发送到", 
    "retry": "重试", 
    "option_play_sound": "收到通知时播放提示音", 
    "sms": "短信", 
    "option_only_show_titles": "仅显示通知的标题", 
    "sms_disclaimer": "发送文本信息时，手机必须保持开机并连接到互联网。", 
    "reply": "回复", 
    "see_full_history": "打开完整历史记录", 
    "type_link": "链接", 
    "undo": "撤消", 
    "learn_more": "了解更多信息", 
    "option_show_mirrors_desc": "取消选中这会停止显示通知 (您仍然可以在工具栏图标看到通知计数)。", 
    "push_label": "推送", 
    "option_play_sound_desc": "勾选后当电脑接收到来自设备的通知同步时播放提示音", 
    "devices_placeholder": "选择设备", 
    "sending": "正在发送...", 
    "option_background_permission": "浏览器关闭时依然保持 Pushbullet 在后台运行", 
    "reply_limit_reached": "您已达到本月免费信息发送限额。", 
    "decryption_failed_title": "解密失败", 
    "push_context_message": "{1} 在 {2}", 
    "options": "设置", 
    "option_background_permission_desc": "勾选后 Pushbullet 成为后台应用程序，即使在所有浏览器的标签页关闭后依然可以正常接收通知。", 
    "mirror_context_message": "{1} 通过 Pushbullet 从 {2} 发送", 
    "encryption_password_needed_title": "收到加密的数据", 
    "option_automatically_attach_link_desc": "这将更快的发送链接到设备。", 
    "how_to_unmute_app_answer": "打开 Pushbullet Android 应用程序，从左边拉出抽屉，然后点击“镜像”。在这里，点击“只为一些应用程序”，然后重新启用应用程序。", 
    "device": "设备", 
    "done": "完成", 
    "cancel": "取消", 
    "snoozed_until": "休眠至 {1}", 
    "sign_out": "登出", 
    "from": "来自 {1}", 
    "panel_cant_sign_in": "无法登登录？尝试暂时禁用 Adblock 扩展程序。如果禁用后问题依旧，Pushbullet 需要启用第三方 cookies 以登录。您可以在登录后再次禁用它。", 
    "option_allow_instant_push_desc": "通过键盘快捷方式将当前选项卡推送至选定的设备。", 
    "option_show_notification_count": "在工具栏图标上显示通知计数", 
    "reply_limit_warning": "您已接近本月免费信息发送限额。", 
    "option_show_context_menu_desc": "勾选后，在右键菜单中显示 Pushbullet", 
    "panel_third_party_cookies": "了解如何更改此设置，请单击此处。", 
    "option_show_mirrors": "在我的电脑上显示通知。", 
    "notifications": "通知", 
    "option_use_dark_icon": "使用灰黑图标", 
    "add_a_friend": "添加联系人", 
    "option_allow_instant_push": "开启即时推送", 
    "option_instant_push_shortcuts": "单击此处以设定 (当前为 {1})", 
    "option_open_my_pushes_automatically": "自动打开发送到此浏览器的消息", 
    "me": "我", 
    "file_too_big": "文件过大", 
    "option_clipboard_permission": "跨设备复制粘贴", 
    "pushed_successfully": "发送成功", 
    "devices": "设备", 
    "option_show_notification_count_desc": "简便快捷地在通知栏中查看通知数量", 
    "add_a_device": "添加设备", 
    "end_to_end_password_desc": "如果您选择输入密码，此密码将需要输入到您的每个设备上。", 
    "general": "常规", 
    "reply_limit_upgrade": "升级到 Pushbullet Pro 以发送无限的消息。", 
    "message_placeholder_files": "输入消息或者拖动一个文件到此处", 
    "option_clipboard_permission_desc": "在一台设备上复制内容，然后你就可以在打开此功能的另一台设备上粘贴", 
    "no_pushes": "没有最近的历史记录", 
    "push_failed": "抱歉，目前无法发送此消息", 
    "option_notification_duration": "通知同步的显示时间长度", 
    "new_sms_thread": "新文本消息", 
    "dismiss": "清除", 
    "decryption_failed_body": "请确认您的密码在所有设备上匹配", 
    "sign_in": "登录", 
    "go_to_link": "打开链接", 
    "snooze": "休眠 1 小时", 
    "friends": "朋友", 
    "num_new_messages": "{1} 新消息", 
    "remove_link_tooltip": "取消连接当前页面", 
    "phone": "手机", 
    "mute_app": "停止来自 {1} 的通知同步", 
    "clear": "清除", 
    "end_to_end_password_label": "端到端加密密码", 
    "add_link_tooltip": "插入当前链接", 
    "option_only_show_titles_desc": "这将使 Pushbullet 仅显示通知的标题，内容保密。", 
    "all_of_my_devices": "我的所有设备", 
    "unsubscribe_from_channel": "取消关注 {1}", 
    "updated_notif_title": "Pushbullet 已更新 ！"
}; 
strings["de"] = {
    "mute": "Stummschalten", 
    "thanks_for_installing_message": "Zum Anmelden hier klicken", 
    "option_open_my_pushes_automatically_desc": "Dadurch wird Pushbullet alle an diesen Browser gesendeten Inhalte automatisch in einem neuen Tab öffnen.", 
    "unsubscribed_from_channel": "Abonnement von {1} beendet", 
    "option_show_context_menu": "Pushbullet im Kontextmenü anzeigen", 
    "option_use_dark_icon_desc": "Toolbar-Icon dunkelgrau darstellen.", 
    "alert_desktop_app_notifications": "Derzeit werden die Benachrichtigungen von der Desktop-Anwendung verwaltet. Schalten Sie die entsprechende Option dort ab, um die Verwaltung an die Browser-Erweiterung zu übergeben.", 
    "sms_recipient_placeholder": "Kontakt oder Telefonnummer", 
    "message_placeholder_link": "Fügen Sie eine Nachricht hinzu, drücken Sie Enter zum Senden", 
    "unsnooze": "Nicht mehr stummschalten", 
    "encryption_password_needed_body": "Zur Eingabe des Passwortes tippen Sie hier", 
    "send": "Senden", 
    "pushbullet_pro_feature": "Für diese Funktionalität benötigen Sie die Pro-Version.", 
    "save": "Speichern", 
    "option_instant_push_shortcuts_not_set": "nicht festgelegt", 
    "send_failed": "Senden fehlgeschlagen", 
    "muted_app": "{1} stummgeschaltet", 
    "now": "Jetzt", 
    "no_notifications": "Derzeit keine Benachrichtigungen", 
    "advanced": "Erweitert", 
    "channels": "Kanäle", 
    "option_automatically_attach_link": "Aktuellen Tab automatisch an Nachrichten anhängen", 
    "changelog_tab": "Was ist neu?", 
    "snoozing_desc": "Stummschalten hält Pushbullet eine Stunde lang davon ab, Ihre Benachrichtigungen anzuzeigen.", 
    "thanks_for_installing_title": "Danke, dass Sie Pushbullet installiert haben", 
    "how_to_unmute_app": "Ich habe eine App stumm geschaltet, wie mache ich das rückgängig?", 
    "title_placeholder": "Titel", 
    "message_placeholder": "Schreiben Sie eine Nachricht und drücken Sie die Eingabe-Taste zum Versenden", 
    "updated_notif_message": "Klicken Sie hier, um zu sehen was neu ist", 
    "unmute_app": "{1} nicht mehr stummschalten", 
    "type_file": "Datei", 
    "panel_sign_up": "Auf pushbullet.com anmelden →", 
    "pushbullet_pro_required": "Nur in der Pro Version", 
    "url_placeholder": "Link URL", 
    "recipient_placeholder": "An", 
    "retry": "Wiederholen", 
    "option_play_sound": "Ton bei eingehenden Beanchrichtigungen", 
    "sms": "SMS", 
    "option_only_show_titles": "Nur die Titel der Benachrichtigungen anzeigen", 
    "sms_disclaimer": "Das Telefon muss angeschaltet und online sein, damit Text-Nachrichten verschickt werden können.", 
    "reply": "Antworten", 
    "see_full_history": "Gesamten Verlauf anzeigen", 
    "type_link": "Link", 
    "undo": "Rückgängig machen", 
    "learn_more": "Erfahren Sie mehr", 
    "option_show_mirrors_desc": "Abschalten dieser Option bewirkt, das keine Benachrichtigungen mehr angezeigt werden (der Zähler im Toolbar-Icon wird weiterhin angezeigt).", 
    "push_label": "Senden", 
    "option_play_sound_desc": "Akustischer Hinweis beim Eintreffen neuer Nachrichten.", 
    "devices_placeholder": "Wählen Sie ein Gerät aus", 
    "sending": "Sende...", 
    "option_background_permission": "Pushbullet bleibt aktiv, wenn der Browser geschlossen wird", 
    "reply_limit_reached": "Sie haben das Limit für freie Nachrichten erreicht.", 
    "decryption_failed_title": "Entschlüsselung fehlgeschlagen", 
    "push_context_message": "{1} um {2}", 
    "options": "Einstellungen", 
    "option_background_permission_desc": "Mitteilungen anzeigen, auch wenn der Browser geschlossen ist.", 
    "mirror_context_message": "{1} über Pushbullet um {2}", 
    "encryption_password_needed_title": "Verschlüsselte Daten empfangen", 
    "option_automatically_attach_link_desc": "Beschleunigt das Senden von Links an andere Geräte.", 
    "how_to_unmute_app_answer": "Starten Sie die Pushbullet-App, öffnen Sie das linke Menü und tippen Sie dort auf 'Spiegeln'. Anschließend tippen Sie auf 'Nur für bestimmte Apps' und können die gewünschte App dann dort reaktivieren.", 
    "device": "Gerät", 
    "done": "Fertig", 
    "cancel": "Abbrechen", 
    "snoozed_until": "Stummgeschaltet bis {1}.", 
    "sign_out": "Abmelden", 
    "from": "Von {1}", 
    "panel_cant_sign_in": "Anmeldung fehlgeschlagen? Versuchen Sie, kurzzeitig Ihren Werbeblocker abzuschalten. Wenn das nicht hilft: Pushbullet benötigt Drittanbieter-Cookies für diesen Vorgang. Sie können die Cookies nach erfolgreicher Anmeldung wieder abschalten.", 
    "option_allow_instant_push_desc": "Aktuellen Tab via Tastenkürzel zum ausgewählten Gerät senden.", 
    "option_show_notification_count": "Anzahl der Benachrichtigungen über dem Icon in der Symbolleiste anzeigen", 
    "reply_limit_warning": "Sie haben das Limit für freie Nachrichten fast erreicht.", 
    "option_show_context_menu_desc": "Pushbullet in der Liste mit den Rechtsklickoptionen anzeigen.", 
    "panel_third_party_cookies": "Klicken Sie hier, um zu erfahren, wie Sie diese Einstellung ändern können.", 
    "option_show_mirrors": "Benachrichtigungen auf meinem PC anzeigen.", 
    "notifications": "Benachrichtigungen", 
    "option_use_dark_icon": "Dunkles Icon verwenden", 
    "add_a_friend": "Kontakt hinzufügen", 
    "option_allow_instant_push": "Sofortiges Versenden aktiveren an", 
    "option_instant_push_shortcuts": "Klicken Sie hier zum Festlegen (aktuell {1}).", 
    "option_open_my_pushes_automatically": "Dinge, die ich an diesen Browser sende, automatisch öffnen", 
    "me": "Mich", 
    "file_too_big": "Datei zu groß", 
    "option_clipboard_permission": "Universelles Kopieren & Einfügen", 
    "pushed_successfully": "Erfolgreich gesendet", 
    "devices": "Geräte", 
    "option_show_notification_count_desc": "Sie können die Anzahl der eingegangenen Benachrichtigungen auf einem Blick in Ihrer Symbolleiste sehen.", 
    "add_a_device": "Gerät hinzufügen", 
    "end_to_end_password_desc": "Wenn Sie ein Passwort hinterlegen, muss dieses auf all Ihren Geräten eingegeben werden.", 
    "general": "Allgemein", 
    "reply_limit_upgrade": "Erwerben Sie die Pro Version, um unbegrenzt viele Nachrichten versenden zu können.", 
    "message_placeholder_files": "Schreiben Sie eine Nachricht oder ziehen Sie eine Datei hierher", 
    "option_clipboard_permission_desc": "Kopieren Sie Text auf einem Gerät in die Zwischenablage und fügen Sie diesen auf jedem anderen Gerät wieder ein, auf dem diese Option aktiviert ist.", 
    "no_pushes": "Nichts neues im Verlauf", 
    "push_failed": "Diese Daten konnten nicht versendet werden", 
    "option_notification_duration": "Ausblenden von Benachrichtigungen automatisch nach", 
    "new_sms_thread": "Neue Textnachricht", 
    "dismiss": "Verwerfen", 
    "decryption_failed_body": "Bitte bestätigen Sie, dass Ihr Kennwort auf allen Geräten übereinstimmt", 
    "sign_in": "Anmelden", 
    "go_to_link": "Link öffnen", 
    "snooze": "1 Stunde stummschalten", 
    "friends": "Freunde", 
    "num_new_messages": "{1} neue Nachrichten", 
    "remove_link_tooltip": "Aktuelle Seite nicht verlinken", 
    "phone": "Telefon", 
    "mute_app": "{1} Benachrichtigungen stummschalten", 
    "clear": "Löschen", 
    "end_to_end_password_label": "Passwort für Ende-Zu-Ende Verschlüsselung", 
    "add_link_tooltip": "Aktuelle Seite verlinken", 
    "option_only_show_titles_desc": "Pushbullet wird nur den Titel der Benachrichtigungen zeigen, während die Nachricht privat bleibt.", 
    "all_of_my_devices": "Alle meine Geräte", 
    "unsubscribe_from_channel": "Abonnement von {1} beenden", 
    "updated_notif_title": "Pushbullet wurde aktualisiert!"
}; 
strings["es-US"] = {
    "mute": "Silenciar", 
    "thanks_for_installing_message": "Pulsa aquí para conectarte", 
    "option_open_my_pushes_automatically_desc": "Esto hace que Pushbullet abra automáticamente cualquier cosa que envíes a este navegador en una nueva pestaña.", 
    "unsubscribed_from_channel": "Has dejado de seguir {1}", 
    "option_show_context_menu": "Mostrar Pushbullet en el menú contextual", 
    "option_use_dark_icon_desc": "Esto hace que nuestro icono en la barra de herramientas sea de color gris oscuro.", 
    "alert_desktop_app_notifications": "La aplicación de escritorio de Pushbullet está gestionando las notificaciones. Si deshabilitas las notificaciones en los ajustes de la aplicación de escritorio, devolverás el control a la extensión.", 
    "sms_recipient_placeholder": "Contacto o número telefónico", 
    "message_placeholder_link": "hola", 
    "unsnooze": "Quitar retraso de aviso", 
    "encryption_password_needed_body": "Haz clic aquí para introducir tu contraseña", 
    "send": "Enviar", 
    "pushbullet_pro_feature": "", 
    "save": "Guardar", 
    "option_instant_push_shortcuts_not_set": "no establecido", 
    "send_failed": "El envío ha fallado", 
    "muted_app": "{1} silenciado", 
    "now": "Ahora", 
    "no_notifications": "No hay notificaciones hasta ahora", 
    "advanced": "Avanzado", 
    "channels": "Canales", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "Qué hay de Nuevo", 
    "snoozing_desc": "\"Retrasar las notificaciones\" evita que Pushbullet muestre notificaciones durante una hora.", 
    "thanks_for_installing_title": "Gracias por instalar Pushbullet", 
    "how_to_unmute_app": "He silenciado una app, ¿Cómo desactivo el silencio?", 
    "title_placeholder": "Título", 
    "message_placeholder": "Escribe un mensaje, presiona retorno para enviar", 
    "updated_notif_message": "Pulsa aquí para ver las novedades", 
    "unmute_app": "Desactivar silencio {1}", 
    "type_file": "Archivo", 
    "panel_sign_up": "Regístrate en Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "", 
    "recipient_placeholder": "Para", 
    "retry": "Reintentar", 
    "option_play_sound": "Reproducir un sonido cuando llegue una notificación.", 
    "sms": "SMS", 
    "option_only_show_titles": "Mostrar sólo el título de las notificaciones.", 
    "sms_disclaimer": "El teléfono debe estar encendido y tener una conexión a Internet para que los mensajes puedan ser enviados.", 
    "reply": "Responder", 
    "see_full_history": "Revisa el historial completo", 
    "type_link": "Vínculo", 
    "undo": "Deshacer", 
    "learn_more": "Aprende más", 
    "option_show_mirrors_desc": "Desmarcar ésto hará que no podamos mostrarte notificaciones (aún podrás seguir viendo un contador en nuestra barra de herramientas).", 
    "push_label": "Enviar", 
    "option_play_sound_desc": "Esto hace que Pushbullet reproduzca un sonido corto cuando llegue una notificación, para avisarte de su llegada.", 
    "devices_placeholder": "Escoge un dispositivo", 
    "sending": "Enviando...", 
    "option_background_permission": "Mantener Pushbullet en ejecución cuando se cierre mi navegador", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Error de descifrado", 
    "push_context_message": "{1} a las {2}", 
    "options": "Ajustes", 
    "option_background_permission_desc": "Esto te permitirá ver las notificaciones sin tener que mantener una ventana del navegador abierta.", 
    "mirror_context_message": "{1} vía Pushbullet a las {2}", 
    "encryption_password_needed_title": "Datos cifrados recibidos", 
    "option_automatically_attach_link_desc": "Esto hace que el envío de enlaces sea más rápido.", 
    "how_to_unmute_app_answer": "", 
    "device": "Dispositivo", 
    "done": "Hecho", 
    "cancel": "Cancelar", 
    "snoozed_until": "Retrasado hasta {1}.", 
    "sign_out": "Desconectarse", 
    "from": "De {1}", 
    "panel_cant_sign_in": "¿No puedes acceder? Prueba desactivando Adblock temporalmente. Si eso no funciona, Pushbullet necesita que  las cookies de terceros estén habilitadas para poder acceder. Puedes volver a inhabilitarlas después de haber accedido.", 
    "option_allow_instant_push_desc": "Enviar la pestaña actual al dispositivo elegido mediante un atajo de teclado.", 
    "option_show_notification_count": "Ver la cantidad de notificaciones en el ícono de la barra de herramientas", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Mostrar Pushbullet en las opciones del menú del botón derecho del ratón.", 
    "panel_third_party_cookies": "Pincha aquí para ver cómo cambiar este ajuste.", 
    "option_show_mirrors": "Mostrar notificaciones en mi computadora", 
    "notifications": "Notificaciones", 
    "option_use_dark_icon": "Usar icono oscuro", 
    "add_a_friend": "Añade un amigo", 
    "option_allow_instant_push": "Habilitar envíos instantáneos a", 
    "option_instant_push_shortcuts": "Pulsa aquí para establecer (actualmente {1}).", 
    "option_open_my_pushes_automatically": "Abrir automáticamente todo lo que envíe a este navegador.", 
    "me": "Yo", 
    "file_too_big": "Archivo demasiado grande", 
    "option_clipboard_permission": "Copiado & Pegado Universal", 
    "pushed_successfully": "Enviado correctamente", 
    "devices": "Dispositivos", 
    "option_show_notification_count_desc": "Ver rápidamente la cantidad de notificaciones en la barra de herramientas.", 
    "add_a_device": "Agregar un dispositivo", 
    "end_to_end_password_desc": "Si opta por introducir una contraseña, esta contraseña tendrá que introducirse en cada uno de sus dispositivos.", 
    "general": "General", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Escribe un mensaje o incluye un archivo", 
    "option_clipboard_permission_desc": "Copia texto en un dispositivo, luego pégalo en cualquier otro que también tenga esta opción activada.", 
    "no_pushes": "No hay actividad reciente", 
    "push_failed": "Lo sentimos, no pudimos envíar eso", 
    "option_notification_duration": "Ocultar automáticamente las notificaciones después de", 
    "new_sms_thread": "Nuevo mensaje de texto", 
    "dismiss": "Descartar", 
    "decryption_failed_body": "Por favor, confirma que tu contraseña coincida en todos los dispositivos", 
    "sign_in": "Conectarse", 
    "go_to_link": "Ir al enlace", 
    "snooze": "Repetir en 1h", 
    "friends": "", 
    "num_new_messages": "{1} mensaje(s) nuevo(s)", 
    "remove_link_tooltip": "Desvincular página actual", 
    "phone": "Teléfono", 
    "mute_app": "Silenciar {1} notificaciones", 
    "clear": "Borrar", 
    "end_to_end_password_label": "Contraseña de cifrado de extremo a extremo", 
    "add_link_tooltip": "Vincula la página actual", 
    "option_only_show_titles_desc": "Esto va a hacer que Pushbullet solo muestre el título de las notificaciones, manteniendo privado el mensaje.", 
    "all_of_my_devices": "Todos mis dispositivos", 
    "unsubscribe_from_channel": "Dejar de seguir {1}", 
    "updated_notif_title": "¡Se ha actualizado Pushbullet!"
}; 
strings["hr"] = {
    "mute": "Utišaj", 
    "thanks_for_installing_message": "Kliknite ovdje za prijavu", 
    "option_open_my_pushes_automatically_desc": "Pushbullet će Vam u pregledniku automatski otvoriti sve što ste mu poslali.", 
    "unsubscribed_from_channel": "Ne pratim više {1}", 
    "option_show_context_menu": "Prikaži Pushbullet u kontekstualnom izborniku preglednika", 
    "option_use_dark_icon_desc": "Ovo će obojiti našu ikonu u alatnoj traci u tamnosivu boju.", 
    "alert_desktop_app_notifications": "Pushbullet desktop aplikacija upravlja obavijestima.", 
    "sms_recipient_placeholder": "Kontakt ili telefonski broj", 
    "message_placeholder_link": "Dodajte poruku, te zatim pritisnite Enter za slanje\n", 
    "unsnooze": "Isključi odgodu", 
    "encryption_password_needed_body": "Kliknite ovdje za unos vaše lozinke", 
    "send": "Pošalji", 
    "pushbullet_pro_feature": "", 
    "save": "Spremi", 
    "option_instant_push_shortcuts_not_set": "", 
    "send_failed": "Slanje nije uspjelo", 
    "muted_app": "Utišan {1}", 
    "now": "Sada", 
    "no_notifications": "Trenutno nema obavijesti", 
    "advanced": "Napredno", 
    "channels": "Kanali", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "Što je novo", 
    "snoozing_desc": "Odgoda obavijesti prestaje prikazivati obavijesti od Pushbulleta za jedan sat.", 
    "thanks_for_installing_title": "Zahvaljujemo što ste instalirali Pushbullet", 
    "how_to_unmute_app": "Isključio sam zvuk aplikacije, kako da ga uključim?", 
    "title_placeholder": "Naslov", 
    "message_placeholder": "Upišite poruku, te zatim pritisnite tipku Enter za slanje", 
    "updated_notif_message": "Kliknite ovdje za pregled novosti", 
    "unmute_app": "Uključivanje zvuka {1}", 
    "type_file": "Datoteka", 
    "panel_sign_up": "Prijavite se na Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Poveznica url", 
    "recipient_placeholder": "Prema", 
    "retry": "Pokušajte ponovno", 
    "option_play_sound": "Reproducirati zvučni signal po dolasku obavijesti.", 
    "sms": "SMS", 
    "option_only_show_titles": "Prikazati samo naslove obavijesti.", 
    "sms_disclaimer": "Telefon mora biti uključen i imati internetsku vezu za slanje poruka.", 
    "reply": "Odgovor", 
    "see_full_history": "Pregledaj svu povijest", 
    "type_link": "Link", 
    "undo": "Poništi", 
    "learn_more": "Nauči više", 
    "option_show_mirrors_desc": "Isključite ovo će nas zaustaviti od prikaza obavijesti (još uvijek možete vidjeti broj u našoj alatnoj traci ikona).", 
    "push_label": "Pošalji", 
    "option_play_sound_desc": "Pushbullet će Vam dolazak obavijesti javiti uz kratki zvučni signal.", 
    "devices_placeholder": "Odaberite uređaj", 
    "sending": "Šaljem...", 
    "option_background_permission": "Zadržati Pushbullet otvorenim čak i kada zatvorite preglednik", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Dekripcija nije uspjela", 
    "push_context_message": "{1} u {2}", 
    "options": "Postavke", 
    "option_background_permission_desc": "Ovo Vam omogućuje pregled obavijesti bez potrebe za otvaranjem preglednika.", 
    "mirror_context_message": "{1} pomoću Pushbulleta na {2}", 
    "encryption_password_needed_title": "Primljeni enkriptirani podaci", 
    "option_automatically_attach_link_desc": "", 
    "how_to_unmute_app_answer": "Otvorite Pushbullet Android aplikaciju, izvucite ladicu obrasca lijevo, zatim dodirnite \"Zrcaljenje\". Dodirnite 'Samo za neke aplikacije', a zatim ponovo omogućite aplikacije.", 
    "device": "Uređaj", 
    "done": "Gotovo", 
    "cancel": "Odustani", 
    "snoozed_until": "Odgođeno do {1}.", 
    "sign_out": "Odjavite se", 
    "from": "Od {1}", 
    "panel_cant_sign_in": "Ne možete se prijaviti? Pokušajte privremeno onemogućiti Adblock. Ukoliko to ne pomogne, Pushbullet zahtijeva omogućene third-party kolačiće za uspješnu prijavu. Možete ih ponovno onemogućiti nakon što se uspješno prijavite.", 
    "option_allow_instant_push_desc": "", 
    "option_show_notification_count": "Prikaži broj obavijesti na ikoni alatne trake", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Prikaži Pushbullet na popisu u izborniku desnog klika miša.", 
    "panel_third_party_cookies": "Kliknite ovdje za promjenu ove postavke.", 
    "option_show_mirrors": "Prikaži obavijesti na mom računalu.", 
    "notifications": "Obavijesti", 
    "option_use_dark_icon": "Koristiti tamnu ikonu", 
    "add_a_friend": "Dodajte prijatelja", 
    "option_allow_instant_push": "", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "Automatski prikaži sve poslane obavijesti u ovom pregledniku.", 
    "me": "Ja", 
    "file_too_big": "Datoteka je prevelika", 
    "option_clipboard_permission": "Univerzalni kopiraj i zalijepi", 
    "pushed_successfully": "Uspješno poslano", 
    "devices": "Uređaji", 
    "option_show_notification_count_desc": "Pogledajte vaš brojač obavijesti odmah na vašoj alatnoj traci.", 
    "add_a_device": "Dodajte uređaj", 
    "end_to_end_password_desc": "Ako odaberete unos lozinke, ta lozinka će biti potrebna za ulaz u svaki vaš uređaj.", 
    "general": "Općenito", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Upišite poruku ili ispustite datoteku", 
    "option_clipboard_permission_desc": "Kopirajte tekst na jednom uređaju, a zatim ga zalijepite na bilo koji drugi uređaj na kojemu je ova postavka omogućena.", 
    "no_pushes": "Nema nedavne povijesti", 
    "push_failed": "Isprika, slanje push obavijesti nije uspjelo", 
    "option_notification_duration": "Sakriti obavijesti automatski nakon", 
    "new_sms_thread": "Nova tekstualna poruka", 
    "dismiss": "Odbaciti", 
    "decryption_failed_body": "Molimo vas potvrdite da vaša lozinka odgovara na svim uređajima", 
    "sign_in": "Prijavite se", 
    "go_to_link": "Posjeti link", 
    "snooze": "Odgodi za 1 sat", 
    "friends": "Prijatelji", 
    "num_new_messages": "{1} novih poruka", 
    "remove_link_tooltip": "Prekini vezu trenutne stranice", 
    "phone": "Telefon", 
    "mute_app": "Utišaj {1} obavijesti", 
    "clear": "Čisto", 
    "end_to_end_password_label": "Kraj-na-kraj lozinka enkripcije", 
    "add_link_tooltip": "Poveži trenutnu stranicu", 
    "option_only_show_titles_desc": "To će učiniti da Pushbullet prikaže samo naslov obavijesti, zadržavajući privatnost poruke.", 
    "all_of_my_devices": "Svi moji uređaji", 
    "unsubscribe_from_channel": "Prestanak praćenja {1}", 
    "updated_notif_title": "Pushbullet je nadograđen!"
}; 
strings["et"] = {
    "mute": "Vaigista", 
    "thanks_for_installing_message": "Klõpsa sisselogimiseks siia", 
    "option_open_my_pushes_automatically_desc": "See paneb Pushbullet'i avama mistahes siia brauserisse saadetud tõukeid automaatselt uuel kaardil.", 
    "unsubscribed_from_channel": "Oled eemaldanud end {1} jälgmisest", 
    "option_show_context_menu": "Kuva Pushbullet mu brauseri kontekstmenüüs", 
    "option_use_dark_icon_desc": "See muudab meie tööriistariba ikooni tumehalliks.", 
    "alert_desktop_app_notifications": "Pushbullet'i töölauarakendus haldab teateid.", 
    "sms_recipient_placeholder": "Kontakt või telefoninumber", 
    "message_placeholder_link": "Lisa sõnum, vajuta saatmiseks sisestusklahvi", 
    "unsnooze": "Lõpeta edasilükkamine", 
    "encryption_password_needed_body": "Klõpsa siia, et sisestada oma parool", 
    "send": "Saada", 
    "pushbullet_pro_feature": "", 
    "save": "Salvesta", 
    "option_instant_push_shortcuts_not_set": "pole seatud", 
    "send_failed": "Saatmine nurjus", 
    "muted_app": "{1} on vaigistatud", 
    "now": "Nüüd", 
    "no_notifications": "Hetkel pole teateid", 
    "advanced": "Täpsemalt", 
    "channels": "Kanalid", 
    "option_automatically_attach_link": "Lisa praegune kaart automaatselt seadme sõnumitesse", 
    "changelog_tab": "Mis on uut", 
    "snoozing_desc": "Edasilükkamine peatab Pushbullet'i teadete kuvamise üheks tunniks.", 
    "thanks_for_installing_title": "Täname Pushbullet'i installimise eest", 
    "how_to_unmute_app": "Kuidas summutatud rakendust taastada?", 
    "title_placeholder": "Pealkiri", 
    "message_placeholder": "Tippige sõnum ja vajutage saatmiseks enter", 
    "updated_notif_message": "Vaata, mis on uut", 
    "unmute_app": "Tühista {1} vaigistus", 
    "type_file": "Fail", 
    "panel_sign_up": "Registreeru aadressil Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Lingi URL", 
    "recipient_placeholder": "Asukohta", 
    "retry": "Proovi uuesti", 
    "option_play_sound": "Mängi heli teate saabumisel.", 
    "sms": "SMS", 
    "option_only_show_titles": "Kuva ainult teadete pealkirjad.", 
    "sms_disclaimer": "Telefon peab sõnumite saatmiseks olema sisse lülitatud ning omama internetiühendust.", 
    "reply": "Vasta", 
    "see_full_history": "Vaata täielikku ajalugu", 
    "type_link": "Link", 
    "undo": "Võta tagasi", 
    "learn_more": "Lisateave", 
    "option_show_mirrors_desc": "Märke eemaldamisel me ei kuva enam teateid (sa näed siiski teadete arvu tööriistariba ikoonil).", 
    "push_label": "Tõuka", 
    "option_play_sound_desc": "See paneb Pushbullet'i mängima lühikest heliklippi teate saabumisel, tõmmates su tähelepanu sellele.", 
    "devices_placeholder": "Valige seade", 
    "sending": "Saatmine...", 
    "option_background_permission": "Hoia Pushbullet käimas, kui mu brauser on suletud", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Lahtikrüpteerimine ebaõnnestus", 
    "push_context_message": "{1} {2}", 
    "options": "Seaded", 
    "option_background_permission_desc": "See lubab sul näha teateid, ilma et peaksid hoidma brauseriakent lahti.", 
    "mirror_context_message": "{1} Pushbullet'i kaudu {2}", 
    "encryption_password_needed_title": "Krüpteeritud andmed vastuvõetud", 
    "option_automatically_attach_link_desc": "See teeb seadmetesse linkide saatmise kiiremaks.", 
    "how_to_unmute_app_answer": "Ava Pushbullet'i Android'i rakendus, sikuta vasakult välja sahtel ning koputa \"Peegeldamine\". Seal koputa \"Ainult teatud rakendustele\", seejärel taasluba rakendus.", 
    "device": "Seade", 
    "done": "Valmis", 
    "cancel": "Loobu", 
    "snoozed_until": "Edasilükatud ajani {1}.", 
    "sign_out": "Logi välja", 
    "from": "Asukohast {1}", 
    "panel_cant_sign_in": "Ei saa sisse logida? Proovi ajutiselt keelata Adblock. Kui see ei aita, vajab Pushbullet sisse logimiseks kolmanda osapoole küpsiste lubamist. Pärast sisse logimist võid sa need uuesti keelata.", 
    "option_allow_instant_push_desc": "Tõuka avatud kaarti soovitud seadmesse klaviatuuriotsetee kaudu.", 
    "option_show_notification_count": "Kuva teadete arv tööriistariba ikoonil", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Kuvab Pushbullet'i paremklõpsumenüüs.", 
    "panel_third_party_cookies": "Klõpsa siia, et näha kuidas seda seadet muuta.", 
    "option_show_mirrors": "Näita teateid mu arvutis.", 
    "notifications": "Teated", 
    "option_use_dark_icon": "Kasuta tumedat ikooni", 
    "add_a_friend": "Lisa sõber", 
    "option_allow_instant_push": "Luba kohene tõukamine asukohta", 
    "option_instant_push_shortcuts": "Klõpsa siin, et seada (hetkel {1}).", 
    "option_open_my_pushes_automatically": "Ava asjad, mida ma siia brauserisse tõukan automaatselt.", 
    "me": "Mina", 
    "file_too_big": "Liiga suur fail", 
    "option_clipboard_permission": "Universaalne kopeeri-kleebi", 
    "pushed_successfully": "Edukalt tõugatud", 
    "devices": "Seadmed", 
    "option_show_notification_count_desc": "Kuva oma teadete arv kiireks vaatamiseks tööriistaribal.", 
    "add_a_device": "Lisa seade", 
    "end_to_end_password_desc": "Kui valid parooli, tuleb see sisestada igas seadmes.", 
    "general": "Üldine", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Tippige sõnum või lohistage fail", 
    "option_clipboard_permission_desc": "Kopeeri tekst ühes seadmes ning kleebi mõnes teises, kus on samuti see valik lubatud.", 
    "no_pushes": "Hiljutist ajalugu pole", 
    "push_failed": "Vabandust, me ei suutnud seda tõugata", 
    "option_notification_duration": "Peida teated automaatselt pärast", 
    "new_sms_thread": "Uus tekstsõnum", 
    "dismiss": "Hülga", 
    "decryption_failed_body": "Palun kinnita, et su parool on sama igas seadmes", 
    "sign_in": "Logi sisse", 
    "go_to_link": "Mine lingile", 
    "snooze": "Lükka 1h edasi", 
    "friends": "Sõbrad", 
    "num_new_messages": "{1} uut sõnumit", 
    "remove_link_tooltip": "Eemalda lehe viide", 
    "phone": "Telefon", 
    "mute_app": "Vaigista {1} teated", 
    "clear": "Puhasta", 
    "end_to_end_password_label": "Mõlemipoolse krüpteerimise parool", 
    "add_link_tooltip": "Viita aktiivset lehte", 
    "option_only_show_titles_desc": "Pushbullet näitab ainult teavituste pealkirju, sisu jääb varjatuks.", 
    "all_of_my_devices": "Kõik mu seadmed", 
    "unsubscribe_from_channel": "Ära jälgi enam {1}", 
    "updated_notif_title": "Pushbullet on uuendatud!"
}; 
strings["sk"] = {
    "mute": "Stlmiť", 
    "thanks_for_installing_message": "Kliknite sem pre prihlásenie", 
    "option_open_my_pushes_automatically_desc": "Pushbullet otvorí všetko čo pošlete do tohto prehliadača automaticky v novej karte.", 
    "unsubscribed_from_channel": "Už nesledujete {1}", 
    "option_show_context_menu": "Zobraziť Pushbullet v kontextovej ponuke", 
    "option_use_dark_icon_desc": "Ikona v paneli nástrojov bude tmavo šedá.", 
    "alert_desktop_app_notifications": "Desktopová aplikácia Pushbullet spravuje oznámenia.", 
    "sms_recipient_placeholder": "Kontakt alebo telefónne číslo", 
    "message_placeholder_link": "Pridajte správu, stlačte enter pre odoslanie", 
    "unsnooze": "Zrušiť odloženie", 
    "encryption_password_needed_body": "Kliknite pre zadanie hesla", 
    "send": "Poslať", 
    "pushbullet_pro_feature": "Pushbullet Pro je potrebný pre povolenie tejto funkcie.", 
    "save": "Uložiť", 
    "option_instant_push_shortcuts_not_set": "nie je nastavené", 
    "send_failed": "Správu sa nepodarilo odoslať", 
    "muted_app": "Stlemené {1}", 
    "now": "Teraz", 
    "no_notifications": "Nemáte žiadne oznámenia", 
    "advanced": "Pokročilé", 
    "channels": "Kanály", 
    "option_automatically_attach_link": "Automaticky pripojiť aktuálnu kartu k správe do zariadenia", 
    "changelog_tab": "Čo je nové", 
    "snoozing_desc": "Odloženie zastaví Pushbullet zobrazovanie vašich oznámení na jednu hodinu.", 
    "thanks_for_installing_title": "Ďakujeme za inštaláciu Pushbullet", 
    "how_to_unmute_app": "Umlčal som aplikácu, ako to navrátiť?", 
    "title_placeholder": "Názov", 
    "message_placeholder": "Napíšte správu, stlačte enter pre odoslanie", 
    "updated_notif_message": "Kliknite sem a uvidíte, čo je nové", 
    "unmute_app": "Zrušiť stlmenie {1}", 
    "type_file": "Súbor", 
    "panel_sign_up": "Zaregistrujte sa na Pushbullet.com →", 
    "pushbullet_pro_required": "Je potrebné mať zakúpené Pushbullet Pro", 
    "url_placeholder": "URL adresa", 
    "recipient_placeholder": "Komu", 
    "retry": "Skúste to znova", 
    "option_play_sound": "Prehrať zvuk pri príchode oznámenia", 
    "sms": "SMS", 
    "option_only_show_titles": "Zobraziť iba názvy oznámení", 
    "sms_disclaimer": "Telefón musí byť zapnutý a pripojený k internetu pre odoslanie SMS správy.", 
    "reply": "Odpovedať", 
    "see_full_history": "Vidieť plnú históriu", 
    "type_link": "Odkaz", 
    "undo": "Späť", 
    "learn_more": "Zistiť viac", 
    "option_show_mirrors_desc": "Odškrtnutím prestanete dostávať upozornenia. Zobrazujú sa len oznámenia (môžete vidieť počet oznámení v našej ikone panela s nástrojmi).", 
    "push_label": "Odoslanie", 
    "option_play_sound_desc": "Pushbullet prehrá krátky zvuk pri doručení oznámenia.", 
    "devices_placeholder": "Vyberte zariadenie", 
    "sending": "Odosielanie...", 
    "option_background_permission": "Ponechať Pushbullet spustený po zavretí prehliadača", 
    "reply_limit_reached": "Dosiahli ste limit voľných správ pre tento mesiac.", 
    "decryption_failed_title": "Dešifrovanie sa nepodarilo", 
    "push_context_message": "{1} v {2}", 
    "options": "Nastavenia", 
    "option_background_permission_desc": "Umožní vám vidieť vaše oznámenia bez toho, aby ste museli mať otvorené okno v prehliadači.", 
    "mirror_context_message": "{1} cez Pushbullet o {2}", 
    "encryption_password_needed_title": "Šifrované údaje prijaté", 
    "option_automatically_attach_link_desc": "Toto umožňuje odosielanie odkazov do zariadení rýchlejšie.", 
    "how_to_unmute_app_answer": "Otvorte Pushbullet aplikáciu v telefóne, vysunete ponuku vľavo a potom zvoľte \"Zrkadlenie\". Stlačte \"Len pre niektoré aplikácie\", potom vyberte aplikácie ktoré môžu posielať upozornenia do PC cez Puhsbullet.", 
    "device": "Zariadenie", 
    "done": "Hotovo", 
    "cancel": "Zrušiť", 
    "snoozed_until": "Odložené do {1}.", 
    "sign_out": "Odhlásiť sa", 
    "from": "Od {1}", 
    "panel_cant_sign_in": "Nemôže sa prihlásiť? Skúste dočasne vypnúť Adblock. Ak to nepomôže, Pushbullet vyžaduje povolené cookies tretích strán pre prihlásenie. Môžete ich znova zakázať po prihlásení.", 
    "option_allow_instant_push_desc": "Poslať aktuálnu kartu do vybraného zariadenia cez klávesovú skratku.", 
    "option_show_notification_count": "Zobraziť počet upozornení v ikone na paneli nástrojov", 
    "reply_limit_warning": "Približujete sa k limitu voľných správ pre tento mesiac.", 
    "option_show_context_menu_desc": "Zobraziť Pushbullet v zozname možností pri kliknutí pravým tlačidlom myši.", 
    "panel_third_party_cookies": "Kliknite sem pre zmenu nastavenia.", 
    "option_show_mirrors": "Zobraziť upozornenia na mojom počítači.", 
    "notifications": "Oznámenia", 
    "option_use_dark_icon": "Použiť tmavú ikonu", 
    "add_a_friend": "+ Pridať priateľa", 
    "option_allow_instant_push": "Povoliť okamžité odosielanie do", 
    "option_instant_push_shortcuts": "Kliknite sem pre nastavenie (aktuálne {1}).", 
    "option_open_my_pushes_automatically": "Otvoriť veci, ktoré som poslal do tohto prehliadača automaticky.", 
    "me": "Ja", 
    "file_too_big": "Súbor príliš veľký", 
    "option_clipboard_permission": "Univerzálne kopírovanie a prilepenie", 
    "pushed_successfully": "Úspešne poslané", 
    "devices": "Zariadenia", 
    "option_show_notification_count_desc": "Uvidíte počet upozornení na prvý pohľad na váš panel nástrojov.", 
    "add_a_device": "+ Pridať zariadenie", 
    "end_to_end_password_desc": "Ak zadáte heslo, budete ho musieť zadať na každom vašom zariadení.", 
    "general": "Všeobecné", 
    "reply_limit_upgrade": "Zakúpte si Pushbullet Pro pre posielanie neobmedzeného množstva správ.", 
    "message_placeholder_files": "Napíšte správu alebo pustite súbor", 
    "option_clipboard_permission_desc": "Skopírujte text na jednom zariadení a vložte ho na všetkých ostatných, ktoré majú toto nastavenie povolené.", 
    "no_pushes": "Žiadna nedávna história", 
    "push_failed": "Prepáčte, ale toto sme nemohli poslať", 
    "option_notification_duration": "Skryť oznámenia automaticky po", 
    "new_sms_thread": "Nová SMS správa", 
    "dismiss": "Zavrieť", 
    "decryption_failed_body": "Prosím, potvrďte vaše heslo", 
    "sign_in": "Prihlásiť sa", 
    "go_to_link": "Prejsť na odkaz", 
    "snooze": "Odložiť o 1 hodinu", 
    "friends": "Priatelia", 
    "num_new_messages": "{1} nových správ", 
    "remove_link_tooltip": "Zrušíť odkaz na aktuálnu stránku", 
    "phone": "Telefón", 
    "mute_app": "Stlmiť oznámenia ({1})", 
    "clear": "Vyčistiť", 
    "end_to_end_password_label": "Koncové šifrovacie heslo", 
    "add_link_tooltip": "Odkaz na aktuálnu stránku", 
    "option_only_show_titles_desc": "Pushbullet bude zobrazovať iba titulky upozornení, ponechajúc obsah správy ukrytý.", 
    "all_of_my_devices": "Všetky moje zariadenia", 
    "unsubscribe_from_channel": "Nesledovať {1}", 
    "updated_notif_title": "Pushbullet bol aktualizovaný!"
}; 
strings["es-ES"] = {
    "mute": "Silenciar", 
    "thanks_for_installing_message": "Pulsa aquí para conectarte", 
    "option_open_my_pushes_automatically_desc": "Esto hace que Pushbullet abra automáticamente en una nueva pestaña cualquier cosa que envíes a este navegador.", 
    "unsubscribed_from_channel": "Has dejado de seguir {1}", 
    "option_show_context_menu": "Mostrar Pushbullet en el menú contextual", 
    "option_use_dark_icon_desc": "Esto hace que nuestro icono en la barra de herramientas sea gris oscuro.", 
    "alert_desktop_app_notifications": "La aplicación de escritorio de Pushbullet está gestionando las notificaciones. Si deshabilitas las notificaciones en los ajustes de la aplicación de escritorio, devolverás el control a la extensión.", 
    "sms_recipient_placeholder": "Contacto o número telefónico", 
    "message_placeholder_link": "Añade un mensaje, pulsa intro para enviar", 
    "unsnooze": "Quitar retraso de aviso", 
    "encryption_password_needed_body": "Haz clic aquí para introducir la contraseña", 
    "send": "Enviar", 
    "pushbullet_pro_feature": "", 
    "save": "Guardar", 
    "option_instant_push_shortcuts_not_set": "sin establecer", 
    "send_failed": "El envío ha fallado", 
    "muted_app": "{1} silenciado", 
    "now": "Ahora", 
    "no_notifications": "No hay notificaciones en este momento", 
    "advanced": "Avanzado", 
    "channels": "Canales", 
    "option_automatically_attach_link": "Adjuntar automáticamente la pestaña actual a los mensajes", 
    "changelog_tab": "Novedades", 
    "snoozing_desc": "Retrasar las notificaciones evita que Pushbullet muestre notificaciones durante una hora.", 
    "thanks_for_installing_title": "Gracias por instalar Pushbullet", 
    "how_to_unmute_app": "He silenciado una app, ¿Cómo desactivo el silencio?", 
    "title_placeholder": "Título", 
    "message_placeholder": "Escriba un mensaje, pulse enter para enviar", 
    "updated_notif_message": "Pulsa aquí para ver las novedades", 
    "unmute_app": "Desactivar silencio de {1}", 
    "type_file": "Archivo", 
    "panel_sign_up": "Regístrate en Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Url del enlace", 
    "recipient_placeholder": "Para", 
    "retry": "Reintentar", 
    "option_play_sound": "Reproducir un sonido cuando llegue una notificación", 
    "sms": "SMS", 
    "option_only_show_titles": "Mostrar sólo el título de las notificaciones", 
    "sms_disclaimer": "El teléfono debe estar encendido y tener una conexión a Internet para que los mensajes puedan ser enviados.", 
    "reply": "Responder", 
    "see_full_history": "Revisa el historial completo", 
    "type_link": "Enlace", 
    "undo": "Deshacer", 
    "learn_more": "Saber más", 
    "option_show_mirrors_desc": "Desmarcar ésto hará que no podamos mostrarte notificaciones (aún podrás seguir viendo un contador en nuestra barra de herramientas).", 
    "push_label": "Envío", 
    "option_play_sound_desc": "Esto hace que Pushbullet reproduzca un sonido corto cuando llegue una notificación, para avisarte.", 
    "devices_placeholder": "Seleccione un dispositivo", 
    "sending": "Enviando...", 
    "option_background_permission": "Mantener Pushbullet en ejecución cuando se cierre el navegador", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Error de descifrado", 
    "push_context_message": "{1} a las {2}", 
    "options": "Ajustes", 
    "option_background_permission_desc": "Esto te permitirá ver las notificaciones sin tener que mantener una ventana del navegador abierta.", 
    "mirror_context_message": "{1} via Pushbullet a las {2}", 
    "encryption_password_needed_title": "Datos cifrados recibidos", 
    "option_automatically_attach_link_desc": "Esto hace que el envío de enlaces sea más rápido.", 
    "how_to_unmute_app_answer": "Abre la aplicación Pushbullet de Android, arrastra el cajón desde la izquierda, después pulsa sobre \"Mirroring\". Aquí, pulsa sobre \"Sólo para algunas aplicaciones\", luego reactiva la aplicación.", 
    "device": "Dispositivo", 
    "done": "Hecho", 
    "cancel": "Cancelar", 
    "snoozed_until": "Retrasado hasta {1}.", 
    "sign_out": "Desconectarse", 
    "from": "De {1}", 
    "panel_cant_sign_in": "¿No puedes acceder? Prueba a deshabilitar Adblock temporalmente. Si eso no funciona, Pushbullet necesita que estén habilitadas las cookies de terceros para poder acceder. Puedes volver a deshabilitarlas después de haber accedido.", 
    "option_allow_instant_push_desc": "Enviar la pestaña actual al dispositivo elegido mediante un atajo de teclado.", 
    "option_show_notification_count": "Ver el contador de notificaciones en el icono de la barra de herramientas", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Mostrar Pushbullet en las opciones del menú que sale con el botón derecho del ratón.", 
    "panel_third_party_cookies": "Haga clic aquí para saber cómo cambiar esta configuración.", 
    "option_show_mirrors": "Mostrar notificaciones en mi ordenador.", 
    "notifications": "Notificaciones", 
    "option_use_dark_icon": "Usar icono oscuro", 
    "add_a_friend": "+ Añadir un amigo", 
    "option_allow_instant_push": "Habilitar envíos instantáneos a", 
    "option_instant_push_shortcuts": "Haz clic aquí para establecerlo (actualmente {1}).", 
    "option_open_my_pushes_automatically": "Abrir automáticamente todo lo que envíe a este navegador.", 
    "me": "Yo", 
    "file_too_big": "Archivo demasiado grande", 
    "option_clipboard_permission": "Copiado y pegado universal", 
    "pushed_successfully": "Enviado correctamente", 
    "devices": "Dispositivos", 
    "option_show_notification_count_desc": "Ver rápidamente la cantidad de notificaciones en la barra de herramientas.", 
    "add_a_device": "+ Añadir un dispositivo", 
    "end_to_end_password_desc": "Si opta por introducir una contraseña, esta contraseña tendrá que introducirse en cada uno de sus dispositivos.", 
    "general": "General", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Escribe un mensaje o incluye un archivo", 
    "option_clipboard_permission_desc": "Copia texto en un dispositivo, luego pégalo en cualquier otro que también tenga esta opción activada.", 
    "no_pushes": "No hay actividad reciente", 
    "push_failed": "Lo sentimos, no se pudo envíar eso", 
    "option_notification_duration": "Ocultar automáticamente las notificaciones después de", 
    "new_sms_thread": "Nuevo mensaje de texto", 
    "dismiss": "Descartar", 
    "decryption_failed_body": "Por favor confirma que la contraseña coincide en todos los dispositivos", 
    "sign_in": "Conectarse", 
    "go_to_link": "Ir al enlace", 
    "snooze": "Retrasar aviso 1 hora", 
    "friends": "Amigos", 
    "num_new_messages": "{1} mensaje(s) nuevo(s)", 
    "remove_link_tooltip": "Desvincular página actual", 
    "phone": "Tlf", 
    "mute_app": "Silenciar {1} notificaciones", 
    "clear": "Borrar", 
    "end_to_end_password_label": "Contraseña de cifrado de extremo a extremo", 
    "add_link_tooltip": "Vincula la página actual", 
    "option_only_show_titles_desc": "Esto hará que Pushbullet solo muestre el título de las notificaciones, manteniendo privado el mensaje.", 
    "all_of_my_devices": "Todos mis dispositivos", 
    "unsubscribe_from_channel": "Dejar de seguir {1}", 
    "updated_notif_title": "¡Se ha actualizado Pushbullet!"
}; 
strings["ru"] = {
    "mute": "Скрыть", 
    "thanks_for_installing_message": "Нажмите сюда, чтобы войти", 
    "option_open_my_pushes_automatically_desc": "При включении этой опции Pushbullet будет автоматически открывать в новой вкладке всё отправленное в этот браузер.", 
    "unsubscribed_from_channel": "Больше не подписаны {1}", 
    "option_show_context_menu": "Показывать Pushbullet в контекстном меню", 
    "option_use_dark_icon_desc": "Это сделает иконку в тулбаре тёмно-серой.", 
    "alert_desktop_app_notifications": "В данный момент приложение Pushbullet управляет уведомлениями. Отключите уведомления в приложении для возврата управления расширению браузера.", 
    "sms_recipient_placeholder": "Контакт или номер телефона", 
    "message_placeholder_link": "Добавить сообщение, нажмите enter, чтобы отправить", 
    "unsnooze": "Отменить", 
    "encryption_password_needed_body": "Нажмите здесь, чтобы ввести ваш пароль", 
    "send": "Отправить", 
    "pushbullet_pro_feature": "Для включения этой функции требуется Pushbullet Pro.", 
    "save": "Сохранить", 
    "option_instant_push_shortcuts_not_set": "не задано", 
    "send_failed": "Не удалось отправить", 
    "muted_app": "{1} скрыто", 
    "now": "Сейчас", 
    "no_notifications": "Уведомлений нет", 
    "advanced": "Продвинутые", 
    "channels": "Каналы", 
    "option_automatically_attach_link": "Автоматически прикрепить текущую вкладку к сообщениям на устройстве", 
    "changelog_tab": "Новые возможности", 
    "snoozing_desc": "Скрытие отключает показ уведомлений на один час.", 
    "thanks_for_installing_title": "Спасибо за установку Pushbullet", 
    "how_to_unmute_app": "Я скрыл уведомления от приложения, как показывать снова?", 
    "title_placeholder": "Тема", 
    "message_placeholder": "Введите сообщение и нажмите enter, чтобы отправить", 
    "updated_notif_message": "Нажмите сюда, чтобы узнать, что нового", 
    "unmute_app": "Показывать {1} снова", 
    "type_file": "Файл", 
    "panel_sign_up": "Зарегистрируйтесь на Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Ссылка", 
    "recipient_placeholder": "Кому", 
    "retry": "Повторить", 
    "option_play_sound": "Звуковой сигнал при поступлении уведомления", 
    "sms": "SMS", 
    "option_only_show_titles": "Показывать только заголовки уведомлений", 
    "sms_disclaimer": "Телефон должен быть включен и иметь доступ к Интернету для отправки текста.", 
    "reply": "Ответить", 
    "see_full_history": "Просмотреть полную историю", 
    "type_link": "Ссылка", 
    "undo": "Отменить", 
    "learn_more": "Узнать больше", 
    "option_show_mirrors_desc": "При отключении этой опции остановится показ уведомлений (Вы все еще можете видеть счетчик на панели инструментов).", 
    "push_label": "Отправить", 
    "option_play_sound_desc": "При включении этой опции Pushbullet будет издавать короткий сигнал при поступлении уведомления.", 
    "devices_placeholder": "Выберите устройство", 
    "sending": "Отправка...", 
    "option_background_permission": "Не закрывать Pushbullet при закрытии браузера", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Ошибка при расшифровке", 
    "push_context_message": "{1} в {2}", 
    "options": "Настройки", 
    "option_background_permission_desc": "Это позволит вам видеть уведомления даже при закрытом окне браузера.", 
    "mirror_context_message": "{1} через Pushbullet в {2}", 
    "encryption_password_needed_title": "Зашифрованные данные получены", 
    "option_automatically_attach_link_desc": "Это делает отправку ссылок на устройства быстрее.", 
    "how_to_unmute_app_answer": "Откройте приложение Pushbullet для Android, вытяните меню слева, затем выберите \"Зеркалирование\". Здесь нажмите \"Только для некоторых устройств\", затем перезапустите приложение.", 
    "device": "Устройство", 
    "done": "Готово", 
    "cancel": "Отменить", 
    "snoozed_until": "Скрыто до {1}.", 
    "sign_out": "Выйти", 
    "from": "От {1}", 
    "panel_cant_sign_in": "Не удается войти? Попробуйте временно отключить Adblock. Если это не помогает, разрешите предоставление cookies для сторонних приложений. Вы можете отключить их снова после входа.", 
    "option_allow_instant_push_desc": "Отправить текущую вкладку на выбранное устройство через сочетание клавиш.", 
    "option_show_notification_count": "Показать счетчик уведомлений на иконке тулбара", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Показывать Pushbullet в списке опций по правому клику.", 
    "panel_third_party_cookies": "Нажмите сюда, чтобы узнать, как изменить настройку.", 
    "option_show_mirrors": "Показывать уведомления на моём компьютере.", 
    "notifications": "Уведомления", 
    "option_use_dark_icon": "Использовать тёмную иконку", 
    "add_a_friend": "+ Добавить друга", 
    "option_allow_instant_push": "Включить мгновенную отправку на", 
    "option_instant_push_shortcuts": "Нажмите здесь, чтобы настроить (сейчас {1}).", 
    "option_open_my_pushes_automatically": "Автоматически открывать отправленное в этот браузер.", 
    "me": "Мне", 
    "file_too_big": "Файл слишком большой", 
    "option_clipboard_permission": "Универсальное копирование и вставка", 
    "pushed_successfully": "Успешно отправлено", 
    "devices": "Устройства", 
    "option_show_notification_count_desc": "Показывать счетчик уведомлений сразу на панели инструментов.", 
    "add_a_device": "+ Добавить устройство", 
    "end_to_end_password_desc": "Если вы решили ввести пароль, то этот пароль нужно будет ввести на каждом из ваших устройств.", 
    "general": "Общие", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Введите сообщение или выберите файл", 
    "option_clipboard_permission_desc": "Скопируйте текст на одном устройстве, затем вставьте его на другом устройстве, на котором включена эта функция.", 
    "no_pushes": "Нет недавней истории", 
    "push_failed": "Извините, не удалось отправить это", 
    "option_notification_duration": "Автоматически скрывать уведомления через", 
    "new_sms_thread": "Новое текстовое сообщение", 
    "dismiss": "Отклонить", 
    "decryption_failed_body": "Пожалуйста, подтвердите ваш пароль, который должен совпадать на всех устройствах", 
    "sign_in": "Войти", 
    "go_to_link": "Перейти", 
    "snooze": "Скрыть на час", 
    "friends": "Друзья", 
    "num_new_messages": "{1} новых сообщений", 
    "remove_link_tooltip": "Убрать ссылку на текущую страницу", 
    "phone": "Телефон", 
    "mute_app": "Скрыть уведомления от {1}", 
    "clear": "Очистить", 
    "end_to_end_password_label": "Пароль для End-to-End шифрования", 
    "add_link_tooltip": "Отправить ссылку на текущую старицу", 
    "option_only_show_titles_desc": "Это позволит Pushbullet показывать только заголовки уведомлений, сохраняя текст приватным.", 
    "all_of_my_devices": "Все мои устройства", 
    "unsubscribe_from_channel": "Отписаться {1}", 
    "updated_notif_title": "Pushbullet обновился!"
}; 
strings["fi"] = {
    "mute": "Mykistä", 
    "thanks_for_installing_message": "Klikkaa tästä kirjautuaksesi sisään", 
    "option_open_my_pushes_automatically_desc": "Pushbullet avaa kaikki työntämäsi asiat automaattisesti uuteen välilehteen selaimessa.", 
    "unsubscribed_from_channel": "{1} ei seurata enää", 
    "option_show_context_menu": "Näytä Pushbullet selaimen pikavalikossa", 
    "option_use_dark_icon_desc": "Tämä tekee työkalurivin kuvakkeesta tummanharmaan.", 
    "alert_desktop_app_notifications": "Pushbulletin työpöytäsovellus hallinnoi ilmoituksia. Poistamalla ilmoitukset käytöstä työpöytäsovelluksen asetuksista palauttaa hallinnan laajennukselle.", 
    "sms_recipient_placeholder": "Yhteystieto tai puhelinnumero", 
    "message_placeholder_link": "Lisää viesti, paina enteriä lähettääksesi", 
    "unsnooze": "Poista mykistys", 
    "encryption_password_needed_body": "Klikkaa tästä syöttääksesi salasanan", 
    "send": "Lähetä", 
    "pushbullet_pro_feature": "Tämä ominaisuus edellyttää Pushbullet Pron.", 
    "save": "Tallenna", 
    "option_instant_push_shortcuts_not_set": "ei määritetty", 
    "send_failed": "Lähettäminen epäonnistui", 
    "muted_app": "{1} mykistetty", 
    "now": "Nyt", 
    "no_notifications": "Ei ilmoituksia juuri nyt", 
    "advanced": "Lisäasetukset", 
    "channels": "Kanavat", 
    "option_automatically_attach_link": "Automaattisesti liittää laitteelle nykyisen välilehden", 
    "changelog_tab": "Mitä uutta", 
    "snoozing_desc": "Mykistyksen aikana ilmoituksia ei näytetä yhden tunnin aikana.", 
    "thanks_for_installing_title": "Kiitos Pushbulletin asentamisesta", 
    "how_to_unmute_app": "Kuinka poistan sovelluksesta mykistyksen?", 
    "title_placeholder": "Otsikko", 
    "message_placeholder": "Kirjoita viesti, paina enteriä lähettääksesi", 
    "updated_notif_message": "Katso, mikä on uutta", 
    "unmute_app": "Poista mykistys sovellukselta {1}", 
    "type_file": "Tiedosto", 
    "panel_sign_up": "Rekisteröidy →", 
    "pushbullet_pro_required": "Pushbullet Pro vaaditaan", 
    "url_placeholder": "Linkin URL-osoite", 
    "recipient_placeholder": "Vastaanottaja", 
    "retry": "Yritä uudelleen", 
    "option_play_sound": "Anna äänimerkki, kun ilmoitus saapuu", 
    "sms": "SMS", 
    "option_only_show_titles": "Näytä vain ilmoituksen otsikot", 
    "sms_disclaimer": "Puhelin on oltava päällä ja siinä on oltava yhteys internetiin lähettääksesi tekstiviestejä.", 
    "reply": "Vastaa", 
    "see_full_history": "Näytä koko historia", 
    "type_link": "Linkki", 
    "undo": "Kumoa", 
    "learn_more": "Opi lisää", 
    "option_show_mirrors_desc": "Poistamalla valinnan estät meitä näyttämästä ilmoituksia (voit silti nähdä määrän työkalurivin kuvakkeessa).", 
    "push_label": "Työnnä", 
    "option_play_sound_desc": "Pushbullet toistaa lyhyen äänen ilmoituksen saapuessa.", 
    "devices_placeholder": "Valitse laite", 
    "sending": "Lähetetään...", 
    "option_background_permission": "Pidä Pushbullet käynnissä, kun selain on suljettu", 
    "reply_limit_reached": "Ilmaisten viestien raja on tullut täyteen tältä kuukaudelta.", 
    "decryption_failed_title": "Salauksen purkaminen epäonnistui", 
    "push_context_message": "{1} klo {2}", 
    "options": "Asetukset", 
    "option_background_permission_desc": "Näin voit nähdä ilmoitukset tarvitsematta pitää selaimen ikkunaa auki.", 
    "mirror_context_message": "{1} Pushbulletin kautta klo {2}", 
    "encryption_password_needed_title": "Salattuja tietoja vastaanotettu", 
    "option_automatically_attach_link_desc": "Tämä nopeuttaa linkkien lähettämistä laitteisiin.", 
    "how_to_unmute_app_answer": "Avaa Pushbullet Androidissa, avaa sivuvalikko, ja sitten napauta 'Peilaus'. Valitse 'Hallitse sovelluksia' ja valitse sovellus.", 
    "device": "Laite", 
    "done": "Valmis", 
    "cancel": "Peruuta", 
    "snoozed_until": "Mykistys päättyy {1}.", 
    "sign_out": "Kirjaudu ulos", 
    "from": "Lähettäjä {1}", 
    "panel_cant_sign_in": "Etkö voi kirjautua? Yritä väliaikaisesti poistaa Adblock käytöstä. Jos tämä ei auta, Pushbullet vaatii kolmannen osapuolen evästeiden olevan käytössä kirjautumiseen. Voit poistaa ne käytöstä kirjautumisen jälkeen.", 
    "option_allow_instant_push_desc": "Työnnä nykyinen välilehti valitulle laitteelle pikanäppäimellä.", 
    "option_show_notification_count": "Näytä ilmoitusten määrä työkalurivin kuvakkeessa", 
    "reply_limit_warning": "Ilmaisten viestien raja on tulossa täyteen tältä kuukaudelta.", 
    "option_show_context_menu_desc": "Näytä Pushbullet oikean klikkauksen valikossa.", 
    "panel_third_party_cookies": "Klikkaa tästä, miten voit muuttaa kyseistä asetusta.", 
    "option_show_mirrors": "Näytä ilmoitukset tietokoneellani.", 
    "notifications": "Ilmoitukset", 
    "option_use_dark_icon": "Käytä tummaa kuvaketta", 
    "add_a_friend": "+ Lisää ystävä", 
    "option_allow_instant_push": "Ota pikatyöntö käyttöön laitteelle", 
    "option_instant_push_shortcuts": "Määritä napauttamalla tätä (tällä hetkellä {1}).", 
    "option_open_my_pushes_automatically": "Avaa työntämäni asiat tähän selaimeen automaattisesti", 
    "me": "Minä", 
    "file_too_big": "Tiedosto on liian suuri", 
    "option_clipboard_permission": "Universaali kopiointi ja liittäminen", 
    "pushed_successfully": "Työntö onnistui", 
    "devices": "Laitteet", 
    "option_show_notification_count_desc": "Näytä ilmoitusten määrä yhdellä silmäyksellä työkalurivissä.", 
    "add_a_device": "+ Lisää laite", 
    "end_to_end_password_desc": "Jos päätät kirjoittaa salasanan, sen täytyy syöttää kullakin laitteilla.", 
    "general": "Yleiset", 
    "reply_limit_upgrade": "Päivitä Pushbullet Prohon lähettääksesi rajattomasti viestejä.", 
    "message_placeholder_files": "Kirjoita viesti tai pudota tiedosto", 
    "option_clipboard_permission_desc": "Kopioi teksti yhdellä laitteella ja liitä se toisaalle, jossa tämä asetus on myös käytössä.", 
    "no_pushes": "Ei lähihistoriaa", 
    "push_failed": "Valitettavasti emme voineet työntää tätä", 
    "option_notification_duration": "Piilota ilmoitukset automaattisesti", 
    "new_sms_thread": "Uusi tekstiviesti", 
    "dismiss": "Hylkää", 
    "decryption_failed_body": "Vahvista salasanasi kaikissa laitteissasi", 
    "sign_in": "Kirjaudu sisään", 
    "go_to_link": "Siirry linkkiin", 
    "snooze": "Mykistä tunniksi", 
    "friends": "Ystävät", 
    "num_new_messages": "{1} uutta viestiä", 
    "remove_link_tooltip": "Poista nykyisen sivun linkki", 
    "phone": "Puhelin", 
    "mute_app": "Mykistä ilmoitukset sovellukselta {1}", 
    "clear": "Tyhjennä", 
    "end_to_end_password_label": "Päästä päähän -salaussalasana", 
    "add_link_tooltip": "Linkki nykyiselle sivulle", 
    "option_only_show_titles_desc": "Tämän myötä Pushbullet näyttää ilmoituksista vain otsikon ja pitää viestin yksityisenä.", 
    "all_of_my_devices": "Kaikkiin laitteisiini", 
    "unsubscribe_from_channel": "Lopeta {1} seuraaminen", 
    "updated_notif_title": "Pushbullet on päivitetty!"
}; 
strings["ro"] = {
    "mute": "Dezactivează", 
    "thanks_for_installing_message": "Apasă aici pentru autentificare", 
    "option_open_my_pushes_automatically_desc": "Acest lucru va face Pushbullet sa deschida orice trimiți acestui browser automat într-o filă nouă.", 
    "unsubscribed_from_channel": "Nemaiurmărind {1}", 
    "option_show_context_menu": "Arată Pushbullet în meniul contextual", 
    "option_use_dark_icon_desc": "Această acțiune va transforma iconița într-un gri închis.", 
    "alert_desktop_app_notifications": "Aplicația desktop Pushbullet administrează notificările. Dezactivarea notificărilor in aplicație va restaura controlul acestora către extensie.", 
    "sms_recipient_placeholder": "Contact sau număr de telefon", 
    "message_placeholder_link": "Adaugă un mesaj, apasă enter pentru a trimite", 
    "unsnooze": "Anulează amânare", 
    "encryption_password_needed_body": "Apasă aici ca să îți tastezi parola", 
    "send": "Trimite", 
    "pushbullet_pro_feature": "", 
    "save": "Salvează", 
    "option_instant_push_shortcuts_not_set": "", 
    "send_failed": "Trimiterea a eșuat", 
    "muted_app": "{1} a fost dezactivată", 
    "now": "Acum", 
    "no_notifications": "Nicio notificare deocamdată", 
    "advanced": "Avansat", 
    "channels": "Canale", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "Noutăți", 
    "snoozing_desc": "Amânarea va împiedica notificările Pushbullet pentru 1 oră.", 
    "thanks_for_installing_title": "Mulţumim pentru instalarea Pushbullet", 
    "how_to_unmute_app": "Am dezactivat o aplicaţie, cum o reactivez?", 
    "title_placeholder": "Titlu", 
    "message_placeholder": "Tastați un mesaj, apăsaţi enter pentru a trimite", 
    "updated_notif_message": "Apasă aici pentru a vedea ce este nou", 
    "unmute_app": "{1} a fost reactivată", 
    "type_file": "Fișier", 
    "panel_sign_up": "Înscrie-te pe Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Link url", 
    "recipient_placeholder": "Către", 
    "retry": "Reîncearcă", 
    "option_play_sound": "Redă un sunet atunci când sosește o notificare", 
    "sms": "SMS", 
    "option_only_show_titles": "Afișează numai titlurile notificărilor", 
    "sms_disclaimer": "Telefonul trebuie să fie pornit și conectat la internet pentru a trimite mesaje.", 
    "reply": "Răspunde", 
    "see_full_history": "Vezi istoricul complet", 
    "type_link": "Legătură", 
    "undo": "Anulare", 
    "learn_more": "Află mai multe", 
    "option_show_mirrors_desc": "Dacă debifezi asta, înseamnă că nu vei mai primi notificări de la noi (poți să vezi în continuare un total în pictograma barei noastre de instrumente).", 
    "push_label": "Apasă", 
    "option_play_sound_desc": "Acest lucru va face Pushbullet sa redea un scurt sunet atunci când soseşte o notificare, alertându-vă.", 
    "devices_placeholder": "Selectaţi un dispozitiv", 
    "sending": "Se trimite...", 
    "option_background_permission": "Păstrează Pushbullet pornit când browser-ul meu este închis", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Decriptare eșuată", 
    "push_context_message": "{1} la {2}", 
    "options": "Setări", 
    "option_background_permission_desc": "Acest lucru vă va permite să vedeți notificările fără a menține o fereastră de browser deschisă.", 
    "mirror_context_message": "{1} prin intermediul Pushbullet la {2}", 
    "encryption_password_needed_title": "Date criptate primite", 
    "option_automatically_attach_link_desc": "", 
    "how_to_unmute_app_answer": "Deschide aplicația Android Pushbullet, trage sertarul din stânga, apoi apasă pe \"Oglindire\". Aici, apasă pe \"Doar pentru unele aplicații\", apoi redeschide aplicația.", 
    "device": "Dispozitiv", 
    "done": "Gata", 
    "cancel": "Anulare", 
    "snoozed_until": "Amânat până la {1}.", 
    "sign_out": "Ieșire", 
    "from": "De la {1}", 
    "panel_cant_sign_in": "Nu te poți autentifica? Încearcă să dezactivezi temporar AdBlock. Dacă tot nu reușești, Pushbullet are nevoie să ai activate cookieurile terțe pentru autentificare. Le poți dezactiva după autentificare.", 
    "option_allow_instant_push_desc": "", 
    "option_show_notification_count": "Arată numărul notificărilor pe pictograma barei de instrumente", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Arată Pushbullet în lista de opţiuni la click dreapta.", 
    "panel_third_party_cookies": "Apasă aici pentru a afla cum să schimbi această setare.", 
    "option_show_mirrors": "Afișează notificările pe calculatorul meu.", 
    "notifications": "Notificări", 
    "option_use_dark_icon": "Utilizează iconiță întunecată", 
    "add_a_friend": "Adaugă prieten", 
    "option_allow_instant_push": "", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "Deschide automat lucrurile pe care le trimit acestui browser.", 
    "me": "Eu", 
    "file_too_big": "Fișier prea mare", 
    "option_clipboard_permission": "Copiere & lipire universala", 
    "pushed_successfully": "Împins cu succes", 
    "devices": "Dispozitive", 
    "option_show_notification_count_desc": "Vezi numărul de notificări dintr-o ochire în bara ta de instrumente.", 
    "add_a_device": "Adăugaţi un dispozitiv", 
    "end_to_end_password_desc": "Dacă alegi să tastezi o parolă, aceasta va trebui să fie introdusă pe fiecare dintre dispozitivele tale.", 
    "general": "General", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Scrie un mesaj sau atașează un fișier", 
    "option_clipboard_permission_desc": "Copiaţi textul de pe un singur dispozitiv, apoi lipiţi-l pe oricare altul care are, de asemenea, această setare activată.", 
    "no_pushes": "Niciun istoric recent", 
    "push_failed": "Ne pare rău, nu am putut trimite asta", 
    "option_notification_duration": "Ascunde notificările automat după", 
    "new_sms_thread": "Mesaj nou", 
    "dismiss": "Respinge", 
    "decryption_failed_body": "Te rugăm să confirmi faptul că parola ta se potrivește pe toate dispozitivele", 
    "sign_in": "Autentificare", 
    "go_to_link": "Mergi la legătură", 
    "snooze": "Amână pentru o oră", 
    "friends": "Prieteni", 
    "num_new_messages": "{1} mesaje noi", 
    "remove_link_tooltip": "Deselectează link -ul paginii curente", 
    "phone": "Telefon", 
    "mute_app": "Dezactivează notificarea {1}", 
    "clear": "Golește", 
    "end_to_end_password_label": "Parolă de criptare end-to-end", 
    "add_link_tooltip": "Selectează link -ul paginii curente", 
    "option_only_show_titles_desc": "Asta va face ca Pushbullet să afișeze doar titlul notificărilor, păstrând mesajul privat.", 
    "all_of_my_devices": "Toate dispozitivele mele", 
    "unsubscribe_from_channel": "Nu urmări {1}", 
    "updated_notif_title": "Pushbullet a fost actualizat!"
}; 
strings["no"] = {
    "mute": "Demp", 
    "thanks_for_installing_message": "Klikk her for å bli logget inn", 
    "option_open_my_pushes_automatically_desc": "Dette vil gjøre at Pushbullet åpner hva som helst du pusher til nettleseren automatisk i en ny fane.", 
    "unsubscribed_from_channel": "Er ikke lenger påmeldt {1}", 
    "option_show_context_menu": "Vis Pushbullet i min nettlesers kontekstmeny", 
    "option_use_dark_icon_desc": "Dette vil gjøre toolbar ikonet mørkegrått.", 
    "alert_desktop_app_notifications": "Pushbullet-programmet for PC og Mac administrerer varsler.", 
    "sms_recipient_placeholder": "Kontakt eller telefonnummer", 
    "message_placeholder_link": "Legg til en beskjed, trykk \"enter\" å sende", 
    "unsnooze": "Fjern slumring", 
    "encryption_password_needed_body": "Klikk her for å skrive inn passord", 
    "send": "Send", 
    "pushbullet_pro_feature": "", 
    "save": "Lagre", 
    "option_instant_push_shortcuts_not_set": "ikke angitt", 
    "send_failed": "Sendingen mislyktes", 
    "muted_app": "Dempet {1}", 
    "now": "Nå", 
    "no_notifications": "Ingen varsler akkurat nå", 
    "advanced": "Avansert", 
    "channels": "Kanaler", 
    "option_automatically_attach_link": "Automatisk feste den gjeldende fanen til meldinger til en enhet", 
    "changelog_tab": "Hva som er nytt", 
    "snoozing_desc": "Slumring stopper Pushbullet fra å vise varsler i en time.", 
    "thanks_for_installing_title": "Takk for at du installerte Pushbullet", 
    "how_to_unmute_app": "Jeg slo av beskjeder fra en app, hvordan slår jeg de på igjen?", 
    "title_placeholder": "Tittel", 
    "message_placeholder": "Skriv inn en melding og trykk enter for å sende", 
    "updated_notif_message": "Klikk her for å se hva som er nytt", 
    "unmute_app": "Slå på lyd fra {1}", 
    "type_file": "Fil", 
    "panel_sign_up": "Registrer deg på Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Lenke", 
    "recipient_placeholder": "Til", 
    "retry": "Prøv på nytt", 
    "option_play_sound": "Varsle meg med lyd når jeg får varsler.", 
    "sms": "SMS", 
    "option_only_show_titles": "Vis bare tittel på varslene.", 
    "sms_disclaimer": "Telefonen må være slått på og ha Internett-tilkobling for at meldingene skal bli sendt.", 
    "reply": "Svar", 
    "see_full_history": "Se hele historien", 
    "type_link": "Kobling", 
    "undo": "Angre", 
    "learn_more": "Lær mer", 
    "option_show_mirrors_desc": "Ved å fjerne haken vil du stoppe oss fra å vise varslinger (du kan fortsatt se en telling i vårt verktøylinjeikon).", 
    "push_label": "Push", 
    "option_play_sound_desc": "Dette vil gjøre at Pushbullet spiller en kort lyd når det kommer varsler.", 
    "devices_placeholder": "Velg en enhet", 
    "sending": "Sender...", 
    "option_background_permission": "Hold Pushbullet gående mens nettleseren min er lukket", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Dekryptering feilet", 
    "push_context_message": "{1} kl. {2}", 
    "options": "Innstillinger", 
    "option_background_permission_desc": "Dette gir deg mulighet til å se varsler uten å ha et nettleservindu åpent.", 
    "mirror_context_message": "{1} via Pushbullet kl. {2}", 
    "encryption_password_needed_title": "Kryptert data mottatt", 
    "option_automatically_attach_link_desc": "Dette gjør det å sende koblinger til andre enheter raskere.", 
    "how_to_unmute_app_answer": "Åpne Pushbullet Android appen, trekk ut skuffen til venstre, trykk deretter på 'Speiling'. Her, trykk 'Bare for noen apper', deretter reaktiver appen.", 
    "device": "Enheten", 
    "done": "Ferdig", 
    "cancel": "Avbryt", 
    "snoozed_until": "Slumret til {1}.", 
    "sign_out": "Logg ut", 
    "from": "Fra {1}", 
    "panel_cant_sign_in": "Kan du ikke logge inn? Prøv å midlertidig deaktivere Adblock. Hvis det ikke hjelper, så krever Pushbullet at tredjeparts informasjonskapsler er aktivert for å logge inn. Du kan deaktivere dem etter du har logget inn.", 
    "option_allow_instant_push_desc": "Push den gjeldende fanen til den valgte enheten via tastatursnarvei.", 
    "option_show_notification_count": "Vis antall varsler på verktøylinjens ikon", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Vis Pushbullet i listen ved høyre-klikking som et menyvalg.", 
    "panel_third_party_cookies": "Klikk her for å se hvordan du endrer denne innstillingen.", 
    "option_show_mirrors": "Vis varslinger på datamaskinen min.", 
    "notifications": "Varsler", 
    "option_use_dark_icon": "Bruk mørkt ikon", 
    "add_a_friend": "Legg til en venn", 
    "option_allow_instant_push": "Aktiver øyeblikkelig pushing for å", 
    "option_instant_push_shortcuts": "Klikk her for å velge (Antall valgt {1}).", 
    "option_open_my_pushes_automatically": "Åpne ting jeg pusher til denne nettleseren automatisk.", 
    "me": "Meg", 
    "file_too_big": "Filen er for stor", 
    "option_clipboard_permission": "Universell klipp og lim", 
    "pushed_successfully": "Pushet suksessfullt", 
    "devices": "Enheter", 
    "option_show_notification_count_desc": "Se raskt antall varsler i verktøylinjen.", 
    "add_a_device": "Legg til en enhet", 
    "end_to_end_password_desc": "Dersom du velger å skrive inn et passord, må passordet skrives inn på alle enhetene dine.", 
    "general": "Generelt", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Skriv inn en melding eller slipp en fil her", 
    "option_clipboard_permission_desc": "Kopièr tekst på en enhet, og så lim det inn på en annen enhet som også har denne innstillingen aktivert.", 
    "no_pushes": "Ingen nyere historie", 
    "push_failed": "Beklager, vi kunne ikke pushe det", 
    "option_notification_duration": "Skjul varsler automatisk etter", 
    "new_sms_thread": "Ny tekstmelding", 
    "dismiss": "Avvis", 
    "decryption_failed_body": "Vennligst bekreft at passordet ditt stemmer på alle enheter", 
    "sign_in": "Logg inn", 
    "go_to_link": "Gå til kobling", 
    "snooze": "Slumre 1 time", 
    "friends": "Venner", 
    "num_new_messages": "{1} nye beskjeder", 
    "remove_link_tooltip": "Fjern link for gjeldende side", 
    "phone": "Telefon", 
    "mute_app": "Demp {1}-varsler", 
    "clear": "Tøm", 
    "end_to_end_password_label": "Ende-til-ende krypteringspassord", 
    "add_link_tooltip": "Link for gjeldende side", 
    "option_only_show_titles_desc": "Dette gjør at Pushbullet bare viser tittel på varsler mens innholdet i meldingen holdes privat.", 
    "all_of_my_devices": "Alle mine enheter", 
    "unsubscribe_from_channel": "Meld av {1}", 
    "updated_notif_title": "Pushbullet har blitt oppdatert!"
}; 
strings["sl"] = {
    "mute": "Utišaj", 
    "thanks_for_installing_message": "Klilkni sem, da se prijaviš", 
    "option_open_my_pushes_automatically_desc": "S tem bo Pushbullet avtomatično odprl vse, kar potisneš na brskalnik, v novem zavihku.", 
    "unsubscribed_from_channel": "Nehali ste slediti {1}", 
    "option_show_context_menu": "Pokaži Pushbullet v kontekstnem meniju", 
    "option_use_dark_icon_desc": "To bo spremenilo našo ikono v orodni vrstici v temno sivo.", 
    "alert_desktop_app_notifications": "Pushbullet aplikacija na namizju ureja obvestila.", 
    "sms_recipient_placeholder": "Stik ali telefonska številka", 
    "message_placeholder_link": "Dodaj sporočilo in pritisni nadaljuj za pošiljanje", 
    "unsnooze": "Znova omogoči zvok", 
    "encryption_password_needed_body": "Kliknite tukaj za vnos gesla", 
    "send": "Pošlji", 
    "pushbullet_pro_feature": "Za omogočanje te funkcije je zahtevan Pushbullet Pro.", 
    "save": "Shrani", 
    "option_instant_push_shortcuts_not_set": "ni nastavljeno", 
    "send_failed": "Pošiljanje neuspešno", 
    "muted_app": "Utišana je aplikacija {1}", 
    "now": "Zdaj", 
    "no_notifications": "Trenutno ni obvestil", 
    "advanced": "Napredno", 
    "channels": "Kanali", 
    "option_automatically_attach_link": "Samodejno priloži trenutni zavihek k sporočilom za napravo", 
    "changelog_tab": "Kaj je novega", 
    "snoozing_desc": "Utišanje ustavi Pushbullet pred kazanjem obvestil za eno uro.", 
    "thanks_for_installing_title": "Hvala za namestitev Pushbulleta", 
    "how_to_unmute_app": "Utišal sem aplikacijo, kako jo vključim?", 
    "title_placeholder": "Naslov", 
    "message_placeholder": "Napiši sporočilo in pritisni nadaljuj za pošiljanje", 
    "updated_notif_message": "Klikni sem, da ugotoviš, kaj je novega", 
    "unmute_app": "Znova vključi aplikacijo {1}", 
    "type_file": "Datoteka", 
    "panel_sign_up": "Prijavi se na Pushbullet.com →", 
    "pushbullet_pro_required": "Zahtevan Pushbullet Pro", 
    "url_placeholder": "Naslov URL", 
    "recipient_placeholder": "Prejemnik:", 
    "retry": "Poskusi znova", 
    "option_play_sound": "Zaigraj zvok ob prihodu obvestila", 
    "sms": "SMS", 
    "option_only_show_titles": "Pokaži le naslove obvestil", 
    "sms_disclaimer": "Telefon mora biti prižgan ter imeti internetno povezavo za pošiljanje sporočil.", 
    "reply": "Odgovori", 
    "see_full_history": "Ogled celotne zgodovine", 
    "type_link": "Povezava", 
    "undo": "Razveljavi", 
    "learn_more": "Več o tem", 
    "option_show_mirrors_desc": "Onemogočanje tega bo ustavilo prikazovanje obvestil (število obvestil bo še vedno prikazano na ikoni).", 
    "push_label": "Potisni", 
    "option_play_sound_desc": "S tem bo Pushbullet zaigral kratek zvok, ko prejmeš obvestilo, da te opozori nanjo.", 
    "devices_placeholder": "Izberi napravo", 
    "sending": "Pošiljanje...", 
    "option_background_permission": "Pushbullet naj teče naprej, ko je brskalnik zaprt", 
    "reply_limit_reached": "Dosegli ste omejitev brezplačnih sporočil za ta mesec.", 
    "decryption_failed_title": "Dešifriranje ni uspelo", 
    "push_context_message": "{1} ob {2}", 
    "options": "Nastavitve", 
    "option_background_permission_desc": "To bo omogočilo, da vidiš obvestila brez, da bi moral/a vedno imeti odprto vsaj eno okno brskalnika.", 
    "mirror_context_message": "{1} preko Pushbullet ob {2}", 
    "encryption_password_needed_title": "Šifrirani podatki prejeti", 
    "option_automatically_attach_link_desc": "To naredi pošiljanje povezav v naprave hitrejše.", 
    "how_to_unmute_app_answer": "Odprite Pushbullet aplikacijo, izvlecite predal na levi, nato tapnite 'Zrcaljenje'. Tapnite 'Le za nekatere aplikacije' in ponovno omogočite želeno aplikacijo.", 
    "device": "Naprava", 
    "done": "Opravljeno", 
    "cancel": "Prekliči", 
    "snoozed_until": "Utišano do {1}.", 
    "sign_out": "Odjavi se", 
    "from": "Od {1}", 
    "panel_cant_sign_in": "Se ne morete vpisati? Poskusite začasno izklopiti AdBlock ali vklopiti piškotke.", 
    "option_allow_instant_push_desc": "Potisni trenutni zavihek na izbrano napravo preko tipkovne bližnjice.", 
    "option_show_notification_count": "Prikaži število obvestil na ikoni orodne vrstice", 
    "reply_limit_warning": "Približujete se omejitvi brezplačnih sporočil za ta mesec.", 
    "option_show_context_menu_desc": "Pokaži Pushbullet na seznamu menija, ki se odpre z desnim klikom.", 
    "panel_third_party_cookies": "Klikni sem za navodila, kako spremeniti to nastavitev.", 
    "option_show_mirrors": "Pokaži obvestila na računalniku.", 
    "notifications": "Obvestila", 
    "option_use_dark_icon": "Uporabi temno ikono", 
    "add_a_friend": "+ Dodaj prijatelja", 
    "option_allow_instant_push": "Omogoči takojšnje potiskanje", 
    "option_instant_push_shortcuts": "Kliknite tukaj, da nastavite (trenutno {1}).", 
    "option_open_my_pushes_automatically": "Avtomatično odpri stvari, ki jih potisnem na ta brskalnik.", 
    "me": "Jaz", 
    "file_too_big": "Datoteke prevelika", 
    "option_clipboard_permission": "Univerzalno kopiranje in lepljenje", 
    "pushed_successfully": "Uspešno potisnjeno", 
    "devices": "Naprave", 
    "option_show_notification_count_desc": "Vidite število vaših obvestil v orodni vrstici na prvi pogled.", 
    "add_a_device": "+ Dodaj napravo", 
    "end_to_end_password_desc": "Če želite vnesti geslo, boste morali geslo vnesti na vse vaše naprave.", 
    "general": "Splošno", 
    "reply_limit_upgrade": "Nadgradite na Pushbullet Pro, da pošljete neomejeno št. sporočil.", 
    "message_placeholder_files": "Vnesi sporočilo ali spusti datoteke", 
    "option_clipboard_permission_desc": "Besedilo kopirajte na eni napravi, nato pa ga prilepite na katerikoli drugi napravi, ki ima to možnost vklopljeno.", 
    "no_pushes": "Ni nedavne zgodovine", 
    "push_failed": "Oprosti, tega nismo mogli potisniti", 
    "option_notification_duration": "Avtomatično skrij obvestila po", 
    "new_sms_thread": "Novo sporočilo", 
    "dismiss": "Zavrži", 
    "decryption_failed_body": "Preverite ujemanje kode na vseh napravah", 
    "sign_in": "Prijavi se", 
    "go_to_link": "Obišči povezavo", 
    "snooze": "Utišaj za 1 uro", 
    "friends": "Prijatelji", 
    "num_new_messages": "{1} novo sporočilo", 
    "remove_link_tooltip": "Odstrani povezavo", 
    "phone": "Telefon", 
    "mute_app": "Utišaj obvestila aplikacije {1}", 
    "clear": "Počisti", 
    "end_to_end_password_label": "Geslo za šifriranje", 
    "add_link_tooltip": "Dodaj povezavo", 
    "option_only_show_titles_desc": "Tako bo Pushbullet aplikacija prikazala samo naslov obvestila, ne vsebino.", 
    "all_of_my_devices": "Vse moje naprave", 
    "unsubscribe_from_channel": "Nehaj slediti {1}", 
    "updated_notif_title": "Pushbullet je posodobljen!"
}; 
strings["ca"] = {
    "mute": "Silencia", 
    "thanks_for_installing_message": "Feu clic aquí per iniciar la sessió", 
    "option_open_my_pushes_automatically_desc": "Això farà que Pushbullet obri el que envieu a aquest navegador automàticament en una nova pestanya.", 
    "unsubscribed_from_channel": "Ja no seguiu a {1}", 
    "option_show_context_menu": "Mostra Pushbullet al menú de context", 
    "option_use_dark_icon_desc": "Això posarà la nostra icona de la barra d'eines en gris fosc.", 
    "alert_desktop_app_notifications": "La aplicació d'escriptori Pushbullet està gestionant les notificacions. Desactivant les notificacions des de la configuració de l'aplicació per escriptori, retornarà el control a l'extensió.", 
    "sms_recipient_placeholder": "Contacte o número de telèfon", 
    "message_placeholder_link": "Afegiu un missatge, premeu intro per enviar", 
    "unsnooze": "Reactiva", 
    "encryption_password_needed_body": "Feu clic aquí per introduir la contrasenya", 
    "send": "Envia", 
    "pushbullet_pro_feature": "", 
    "save": "Desa", 
    "option_instant_push_shortcuts_not_set": "no activat", 
    "send_failed": "Ha fallat l'enviament", 
    "muted_app": "Silenciades {1}", 
    "now": "Ara mateix", 
    "no_notifications": "No hi ha notificacions", 
    "advanced": "Avançat", 
    "channels": "Canals", 
    "option_automatically_attach_link": "Adjunta automàticament la pestanya actual als missatges al vostre dispositiu", 
    "changelog_tab": "Novetats", 
    "snoozing_desc": "Desactivar impedeix Pushbullet de mostrar notificacions durant una hora.", 
    "thanks_for_installing_title": "Gràcies per instal·lar Pushbullet", 
    "how_to_unmute_app": "He emmudit una aplicació, com m'ho faig per desfer-ho?", 
    "title_placeholder": "Títol", 
    "message_placeholder": "Entreu un missatge, premeu intro per enviar", 
    "updated_notif_message": "Feu clic aquí per veure les novetats", 
    "unmute_app": "Reactiva so {1}", 
    "type_file": "Arxiu", 
    "panel_sign_up": "Registreu-vos a Pushbullet.com →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "URL de l'enllaç", 
    "recipient_placeholder": "A", 
    "retry": "Torna-ho a provar", 
    "option_play_sound": "Reprodueix un so quan arriba una notificació", 
    "sms": "SMS", 
    "option_only_show_titles": "Mostra només els títols de notificació", 
    "sms_disclaimer": "El telèfon ha d'estar encès i tenir una connexió activa a internet perquè els missatges es puguin enviar.", 
    "reply": "Respon", 
    "see_full_history": "Visualitza l'historial sencer", 
    "type_link": "Enllaç", 
    "undo": "Desfés", 
    "learn_more": "Més informació", 
    "option_show_mirrors_desc": "Desmarcant aquesta opció farà que Pushbullet no us mostri les notificacions (però el recompte seguirà present a la barra d'eines).", 
    "push_label": "Enviament", 
    "option_play_sound_desc": "Això farà emetre un curt so quan arriba una notificació, alertant-vos d'ella.", 
    "devices_placeholder": "Sel·leccioneu un dispositiu", 
    "sending": "Enviant...", 
    "option_background_permission": "Continua executant Pushbullet quan el navegador es tanqui", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Ha fallat la desencriptació", 
    "push_context_message": "{1} a les {2}", 
    "options": "Configuració", 
    "option_background_permission_desc": "Això li permetrà veure les notificacions sense necessitat de mantenir una finestra del navegador oberta.", 
    "mirror_context_message": "{1} mitjançant Pushbullet a les {2}", 
    "encryption_password_needed_title": "S'han rebut dades encriptades", 
    "option_automatically_attach_link_desc": "Açò envia els enllaços més ràpid als dispositius.", 
    "how_to_unmute_app_answer": "Obriu l'aplicació de Pushbullet a Android, extregueu el calaix de l'esquerra i premeu \"Sincronització de notificacions\". Allí, sel·leccioneu l'opció de \"Tan sols per algunes aplicacions\" i reestabliu l'aplicació.", 
    "device": "Dispositiu", 
    "done": "Fet", 
    "cancel": "Cancel·la", 
    "snoozed_until": "Desactivat fins {1}.", 
    "sign_out": "Tanca la sessió", 
    "from": "De {1}", 
    "panel_cant_sign_in": "No aconsegueixes entrar? Prova de desconnectar temporalment l'Adblock. Si això no resultés, Pushbullet necessitarà que les cookies de tercers estiguin activades per iniciar sessió.  Pots desactivar-les altre cop,  després de l'inici de sessió.", 
    "option_allow_instant_push_desc": "Empènyer el tabulador actual al dispositiu escollit mitjançant drecera de teclats.", 
    "option_show_notification_count": "Mostra el recompte de notificacions a la barra d'eines", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Mostra el Pushbullet a la llista d'opcions de menú de clic dret.", 
    "panel_third_party_cookies": "Feu clic aquí per saber com canviar aquesta configuració.", 
    "option_show_mirrors": "Mostra les notificacions al meu ordinador.", 
    "notifications": "Notificacions", 
    "option_use_dark_icon": "Utilitza Icona fosca", 
    "add_a_friend": "+ Afegeix un amic", 
    "option_allow_instant_push": "Permet enviament instantani a", 
    "option_instant_push_shortcuts": "Cliqueu aquí per establir (actualment {1}).", 
    "option_open_my_pushes_automatically": "Obre el que envio a aquest navegador automàticament.", 
    "me": "Jo", 
    "file_too_big": "Fitxer massa gran", 
    "option_clipboard_permission": "Copiar i enganxar universals", 
    "pushed_successfully": "Enviat amb èxit", 
    "devices": "Dispositius", 
    "option_show_notification_count_desc": "Comprova el número de notificacions per respondre en un cop d'ull a la barra d'eines.", 
    "add_a_device": "+ Afegeix un dispositiu", 
    "end_to_end_password_desc": "Si trieu introduir una contrasenya, aquesta s'ha d'introduir a tots els vostres dispositius.", 
    "general": "General", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Entreu un missatge o deixeu un fitxer", 
    "option_clipboard_permission_desc": "Copia text en un dispositiu, després enganxa'l en qualsevol altre que també tingui aquesta opció habilitada.", 
    "no_pushes": "No hi ha historial recent", 
    "push_failed": "Disculpa, no hem pogut enviar això", 
    "option_notification_duration": "Amaga notificacions automàticament després de", 
    "new_sms_thread": "Nou missatge de text", 
    "dismiss": "Descarta", 
    "decryption_failed_body": "Sisplau confirmeu que la contrasenya coincideix en tots els dispositius", 
    "sign_in": "Inicia sessió", 
    "go_to_link": "Vés a l'enllaç", 
    "snooze": "Repetició", 
    "friends": "Amics", 
    "num_new_messages": "{1} nous missatges", 
    "remove_link_tooltip": "Desfés l'enllaçament amb la pàgina actual", 
    "phone": "Telèfon", 
    "mute_app": "Silencia {1} notificacions", 
    "clear": "Neteja", 
    "end_to_end_password_label": "Contrasenya de xifratge punt a punt", 
    "add_link_tooltip": "Enllaça amb la pàgina actual", 
    "option_only_show_titles_desc": "Això farà que Pushbullet tan sols mostri el títol de les notificacions, mantenint la privacitat del missatge.", 
    "all_of_my_devices": "Tots el meus dispositius", 
    "unsubscribe_from_channel": "Deixar de seguir a {1}", 
    "updated_notif_title": "Pushbullet s'ha actualitzat!"
}; 
strings["id"] = {
    "mute": "Bisukan", 
    "thanks_for_installing_message": "Klik di sini untuk masuk", 
    "option_open_my_pushes_automatically_desc": "Ini akan membuat Pushbullet secara otomatis membuka apapun yang Anda kirimkan ke peramban ini di tab baru.", 
    "unsubscribed_from_channel": "Tidak lagi mengikuti {1}", 
    "option_show_context_menu": "Tampilkan Pushbullet di menu konteks peramban", 
    "option_use_dark_icon_desc": "Ini akan membuat ikon bilah alat berwarna abu-abu gelap.", 
    "alert_desktop_app_notifications": "Aplikasi desktop Pushbullet sedang mengelola notifikasi.", 
    "sms_recipient_placeholder": "Kontak atau nomor telepon", 
    "message_placeholder_link": "Tulis pesan, tekan enter untuk mengirim", 
    "unsnooze": "Urung Menunda", 
    "encryption_password_needed_body": "Klik di sini untuk memasukkan sandi", 
    "send": "Kirim", 
    "pushbullet_pro_feature": "Membutuhkan Pushbullet Pro untuk mengaktifkan fitur ini.", 
    "save": "Simpan", 
    "option_instant_push_shortcuts_not_set": "belum diatur", 
    "send_failed": "Gagal mengirim", 
    "muted_app": "{1} dibisukan", 
    "now": "Sekarang", 
    "no_notifications": "Saat ini tidak ada notifikasi", 
    "advanced": "Lanjutan", 
    "channels": "Kanal", 
    "option_automatically_attach_link": "Otomatis melampirkan tab saat ini ke pesan untuk perangkat", 
    "changelog_tab": "Apa yang Baru", 
    "snoozing_desc": "Penundaan menghentikan Pushbullet menampilkan notifikasi selama satu jam.", 
    "thanks_for_installing_title": "Terima kasih telah memasang Pushbullet", 
    "how_to_unmute_app": "Saya membisukan sebuah aplikasi, bagaimana cara saya membunyikannya lagi?", 
    "title_placeholder": "Judul", 
    "message_placeholder": "Ketik pesan, tekan enter untuk mengirim", 
    "updated_notif_message": "Klik di sini untuk melihat apa yang baru", 
    "unmute_app": "Bunyikan {1}", 
    "type_file": "Berkas", 
    "panel_sign_up": "Daftar di Pushbullet.com →", 
    "pushbullet_pro_required": "Membutuhkan Pushbullet Pro", 
    "url_placeholder": "Url tautan", 
    "recipient_placeholder": "Kepada", 
    "retry": "Ulangi", 
    "option_play_sound": "Bunyikan suara ketika notifikasi tiba.", 
    "sms": "SMS", 
    "option_only_show_titles": "Hanya tampilkan judul notifikasi.", 
    "sms_disclaimer": "Telepon harus menyala dan memiliki koneksi internet agar teks bisa dikirimkan.", 
    "reply": "Balas", 
    "see_full_history": "Lihat seluruh riwayat", 
    "type_link": "Tautan", 
    "undo": "Urungkan", 
    "learn_more": "Pelajari lebih lanjut", 
    "option_show_mirrors_desc": "Menghapus centang ini akan menghentikan Pushbullet menampilkan notifikasi (Anda masih bisa melihat jumlahnya di ikon bilah alat).", 
    "push_label": "Kiriman", 
    "option_play_sound_desc": "Ini akan membuat Pushbullet membunyikan suara ketika notifikasi tiba, memberitahu Anda tentang notifikasi tersebut.", 
    "devices_placeholder": "Pilih perangkat", 
    "sending": "Mengirim...", 
    "option_background_permission": "Biarkan Pushbullet tetap berjalan ketika peramban ditutup", 
    "reply_limit_reached": "Anda telah mencapai batas pesan gratis untuk bulan ini.", 
    "decryption_failed_title": "Dekripsi gagal", 
    "push_context_message": "{1} pada pukul {2}", 
    "options": "Pengaturan", 
    "option_background_permission_desc": "Ini akan memungkinkan Anda melihat notifikasi tanpa harus membuat jendela peramban tetap terbuka.", 
    "mirror_context_message": "{1} melalui Pushbullet pada {2}", 
    "encryption_password_needed_title": "Menerima data terenkripsi", 
    "option_automatically_attach_link_desc": "Hal ini membuat mengirim link ke perangkat lebih cepat.", 
    "how_to_unmute_app_answer": "Buka aplikasi Pushbullet Android, tarik keluar laci menu dari kiri, lalu ketuk 'Notifikasi'. Di sini, ketuk 'Hanya untuk beberapa apl', lalu aktifkan ulang aplikasi tersebut.", 
    "device": "Perangkat", 
    "done": "Selesai", 
    "cancel": "Batal", 
    "snoozed_until": "Tertunda hingga {1}.", 
    "sign_out": "Keluar", 
    "from": "Dari {1}", 
    "panel_cant_sign_in": "Tidak bisa masuk? Coba nonaktifkan sementara Adblock. Jika masih tidak bisa, Pushbullet mengharuskan kuki pihak ketiga diaktifkan untuk bisa masuk. Anda dapat menonaktifkannya lagi setelah masuk.", 
    "option_allow_instant_push_desc": "Kirim tab saat ini ke perangkat pilihan melalui cara pintas di keyboard.", 
    "option_show_notification_count": "Tampilkan jumlah notifikasi pada ikon bilah alat", 
    "reply_limit_warning": "Anda mendekati batas pesan gratis untuk bulan ini.", 
    "option_show_context_menu_desc": "Menampilkan Pushbullet di dalam daftar opsi menu klik kanan.", 
    "panel_third_party_cookies": "Klik di sini untuk cara mengganti pengaturan ini.", 
    "option_show_mirrors": "Tampilkan notifikasi di komputer saya.", 
    "notifications": "Notifikasi", 
    "option_use_dark_icon": "Gunakan ikon gelap", 
    "add_a_friend": "Tambahkan teman", 
    "option_allow_instant_push": "Aktifkan pengiriman instan ke", 
    "option_instant_push_shortcuts": "Klik di sini untuk menetapkan (saat ini {1}).", 
    "option_open_my_pushes_automatically": "Buka semua yang saya kirimkan ke peramban ini secara otomatis.", 
    "me": "Saya", 
    "file_too_big": "Berkas terlalu besar", 
    "option_clipboard_permission": "Salin & tempel universal", 
    "pushed_successfully": "Berhasil dikirimkan", 
    "devices": "Perangkat", 
    "option_show_notification_count_desc": "Menampilkan jumlah notifikasi sekilas di bilah alat Anda.", 
    "add_a_device": "Tambahkan perangkat", 
    "end_to_end_password_desc": "Jika Anda memilih untuk memasukkan sandi, sandi ini perlu dimasukkan ke setiap perangkat Anda.", 
    "general": "Umum", 
    "reply_limit_upgrade": "Tingkatkan ke Pushbullet Pro untuk pengiriman pesan tidak terbatas.", 
    "message_placeholder_files": "Ketik pesan atau jatuhkan berkas", 
    "option_clipboard_permission_desc": "Salin teks di satu perangkat, lalu tempel di perangkat lainnya yang juga memiliki pengaturan ini diaktifkan.", 
    "no_pushes": "Tidak ada riwayat", 
    "push_failed": "Maaf, kami tidak bisa mengirimkannya", 
    "option_notification_duration": "Sembunyikan notifikasi secara otomatis setelah", 
    "new_sms_thread": "Pesan teks baru", 
    "dismiss": "Abaikan", 
    "decryption_failed_body": "Harap konfirmasi sandi Anda sama di semua perangkat", 
    "sign_in": "Masuk", 
    "go_to_link": "Kunjungi tautan", 
    "snooze": "Tunda 1 jam", 
    "friends": "Teman", 
    "num_new_messages": "{1} pesan baru", 
    "remove_link_tooltip": "Batal taut halaman saat ini", 
    "phone": "Telepon", 
    "mute_app": "Bisukan notifikasi {1}", 
    "clear": "Kosongkan", 
    "end_to_end_password_label": "Sandi enkripsi ujung-ke-ujung", 
    "add_link_tooltip": "Taut halaman saat ini", 
    "option_only_show_titles_desc": "Ini akan membuat Pushbullet hanya menampilkan judul notifikasi, menjaga agar pesan tetap privat.", 
    "all_of_my_devices": "Semua perangkat saya", 
    "unsubscribe_from_channel": "Setop ikuti {1}", 
    "updated_notif_title": "Pushbullet telah diperbarui!"
}; 
strings["uk"] = {
    "mute": "Вимкнути звук", 
    "thanks_for_installing_message": "Натисніть тут, щоб увійти", 
    "option_open_my_pushes_automatically_desc": "Отриманні посилання будуть самостійно відкриватись у новій вкладці браузера.", 
    "unsubscribed_from_channel": "Більше не слідкувати {1}", 
    "option_show_context_menu": "Показувати значок Pushbullet у контекстному меню браузера", 
    "option_use_dark_icon_desc": "Значок додатку в панелі інструментів стане темно-сірим.", 
    "alert_desktop_app_notifications": "Pushbullet - це додаток для управління сповіщеннями.", 
    "sms_recipient_placeholder": "Контакт або номер телефону", 
    "message_placeholder_link": "Введіть повідомлення, натисніть клавішу enter для відправки", 
    "unsnooze": "Відновити сповіщення", 
    "encryption_password_needed_body": "Натисніть тут, щоб ввести пароль", 
    "send": "Надіслати", 
    "pushbullet_pro_feature": "", 
    "save": "Зберегти", 
    "option_instant_push_shortcuts_not_set": "", 
    "send_failed": "Не вдалося надіслати", 
    "muted_app": "{1} приховано", 
    "now": "Зараз", 
    "no_notifications": "Поки ніяких повідомлень", 
    "advanced": "Розширені налаштування", 
    "channels": "Канали", 
    "option_automatically_attach_link": "", 
    "changelog_tab": "Що нового", 
    "snoozing_desc": "\"Не Турбувати\" вимикає показ сповіщень на 1 годину.", 
    "thanks_for_installing_title": "Дякуємо за встановлення Pushbullet", 
    "how_to_unmute_app": "Я вимкнув сповіщення, як їх увімкнути?", 
    "title_placeholder": "Назва", 
    "message_placeholder": "Введіть повідомлення та натисніть enter, щоб надіслати", 
    "updated_notif_message": "Натисніть тут, щоб дізнатися, що нового", 
    "unmute_app": "Показувати {1} знову", 
    "type_file": "Файл", 
    "panel_sign_up": "Авторизуйтесь на Pushbullet.com", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Url посилання", 
    "recipient_placeholder": "Кому", 
    "retry": "Повторити", 
    "option_play_sound": "Звукове сповіщення при нових повідомленнях.", 
    "sms": "SMS", 
    "option_only_show_titles": "Показувати лише заголовки сповіщень.", 
    "sms_disclaimer": "", 
    "reply": "Відповісти", 
    "see_full_history": "Див повну історію", 
    "type_link": "Посилання", 
    "undo": "Відмінити", 
    "learn_more": "Дізнатися більше", 
    "option_show_mirrors_desc": "", 
    "push_label": "Відправити", 
    "option_play_sound_desc": "При надходженні сповіщення Pushbullet подасть короткий звуковий сигнал.", 
    "devices_placeholder": "Оберіть пристрій", 
    "sending": "Надсилання...", 
    "option_background_permission": "Дозволити Pushbullet працювати після закриття браузера", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Дешифрування не вдалося", 
    "push_context_message": "{1} до {2}", 
    "options": "Налаштування", 
    "option_background_permission_desc": "Це дозволить Вам бачити сповіщення не відкриваючи браузер.", 
    "mirror_context_message": "{1} через Pushbullet до {2}", 
    "encryption_password_needed_title": "Отримані зашифровані дані", 
    "option_automatically_attach_link_desc": "", 
    "how_to_unmute_app_answer": "", 
    "device": "Пристрій", 
    "done": "Готово", 
    "cancel": "Скасувати", 
    "snoozed_until": "Не Турбувати до {1}.", 
    "sign_out": "Вихід", 
    "from": "Від {1}", 
    "panel_cant_sign_in": "Не вдалось ввійти? Спробуйте тимчасово вимкнути Adblock. Якщо це не допомагає, дозвольте надання cookies для сторонніх додатків. Ви можете заборонити їх знову після входу.", 
    "option_allow_instant_push_desc": "", 
    "option_show_notification_count": "Показувати кількість сповіщень на значку в панелі інструментів", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Додаток буде доступний при натисканні правої кнопки миші.", 
    "panel_third_party_cookies": "Натисніть сюди, щоб дізнатись, як змінити цей параметр.", 
    "option_show_mirrors": "", 
    "notifications": "Сповіщення", 
    "option_use_dark_icon": "Використовувати темну іконку", 
    "add_a_friend": "Додати друга", 
    "option_allow_instant_push": "", 
    "option_instant_push_shortcuts": "", 
    "option_open_my_pushes_automatically": "Автоматично відкривати посилання із сповіщень для браузера.", 
    "me": "Я", 
    "file_too_big": "Файл занадто великий", 
    "option_clipboard_permission": "Універсальне копіювання & вставка", 
    "pushed_successfully": "Успішно відправлено", 
    "devices": "Пристрої", 
    "option_show_notification_count_desc": "Ви зможете бачити кількість нових сповіщень не відриваючись від роботи.", 
    "add_a_device": "Додати пристрій", 
    "end_to_end_password_desc": "", 
    "general": "Загальні", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Введіть повідомлення або відправте файл", 
    "option_clipboard_permission_desc": "Копіюєте текст на одному пристрої, вставляєте на будь-якому іншому. Для цього ввімкніть цю функцію на усіх пристроях.", 
    "no_pushes": "Немає історії", 
    "push_failed": "На жаль, ми не можемо відправити це", 
    "option_notification_duration": "Самостійно ховати сповіщення після", 
    "new_sms_thread": "Нове текстове повідомлення", 
    "dismiss": "Відхилити", 
    "decryption_failed_body": "", 
    "sign_in": "Вхід", 
    "go_to_link": "Відкрити посилання", 
    "snooze": "Відкласти 1 годину", 
    "friends": "Друзі", 
    "num_new_messages": "{1} нових повідомлень", 
    "remove_link_tooltip": "", 
    "phone": "Телефон", 
    "mute_app": "Приховати сповіщення від {1}", 
    "clear": "Очистити", 
    "end_to_end_password_label": "", 
    "add_link_tooltip": "Слідкувати за поточною сторінкою", 
    "option_only_show_titles_desc": "Pushbullet показуватиме тільки заголовок повідомлення, зберігаючи повідомлення приватним.", 
    "all_of_my_devices": "Всі мої пристрої", 
    "unsubscribe_from_channel": "Перестати слідкувати {1}", 
    "updated_notif_title": "Pushbullet було оновлено!"
}; 
strings["ko"] = {
    "mute": "알림 받지 않기", 
    "thanks_for_installing_message": "여기를 클릭해 로그인하세요.", 
    "option_open_my_pushes_automatically_desc": "보낸 알림이 브라우저의 새 탭에서 열리도록 합니다.", 
    "unsubscribed_from_channel": "{1}을(를) 더는 팔로우하지 않습니다", 
    "option_show_context_menu": "브라우저 바로가기 메뉴에서 Pushbullet 표시", 
    "option_use_dark_icon_desc": "툴바 아이콘을 어두운 회색으로 변경합니다.", 
    "alert_desktop_app_notifications": "Pushbullet 데스크탑 앱이 알림을 제어합니다.", 
    "sms_recipient_placeholder": "연락처 또는 폰번호", 
    "message_placeholder_link": "메시지 추가하기, 엔터 키로 보냅니다.", 
    "unsnooze": "음소거 해제", 
    "encryption_password_needed_body": "비밀번호를 입력하려면 여기를 클릭하세요", 
    "send": "보내기", 
    "pushbullet_pro_feature": "이 기능을 활성화하기 위해 Pushbullet Pro가 필요합니다.", 
    "save": "저장", 
    "option_instant_push_shortcuts_not_set": "설정하지 않음", 
    "send_failed": "전송 실패", 
    "muted_app": "{1}의 알림 받지 않음", 
    "now": "지금", 
    "no_notifications": "알림이 없습니다", 
    "advanced": "고급", 
    "channels": "채널", 
    "option_automatically_attach_link": "장치에 보내는 메시지에 현재 탭 첨부", 
    "changelog_tab": "새로운 업데이트", 
    "snoozing_desc": "음소거를 하면 Pushbullet이 1시간 동안 알림을 보이지 않습니다.", 
    "thanks_for_installing_title": "Pushbullet을 설치해 주셔서 감사합니다.", 
    "how_to_unmute_app": "앱의 알림을 껐습니다. 어떻게 다시 켤 수 있나요?", 
    "title_placeholder": "제목", 
    "message_placeholder": "메세지를 작성 후 엔터 키를 누르세요.", 
    "updated_notif_message": "새 기능을 보려면 여기를 클릭하세요.", 
    "unmute_app": "{1}의 알림 받기", 
    "type_file": "파일", 
    "panel_sign_up": "Pushbullet.com에서 가입하기 →", 
    "pushbullet_pro_required": "Pushbullet Pro가 필요함", 
    "url_placeholder": "링크 url", 
    "recipient_placeholder": "받는 사람", 
    "retry": "다시 시도", 
    "option_play_sound": "알림이 도착하면 소리 재생", 
    "sms": "문자 메시지", 
    "option_only_show_titles": "알림 제목만 표시", 
    "sms_disclaimer": "문자를 전송하기 위해서는 휴대기기가 켜져 있고 인터넷에 연결되어 있어야 합니다.", 
    "reply": "답장", 
    "see_full_history": "전체 내역 보기", 
    "type_link": "링크", 
    "undo": "실행 취소", 
    "learn_more": "자세히", 
    "option_show_mirrors_desc": "이 항목을 체크 해제하면 알림을 표시하는 것을 중지합니다 (툴바 아이콘에서 카운터를 계속 볼 수 있습니다).", 
    "push_label": "푸시", 
    "option_play_sound_desc": "알림이 도착하면 Pushbullet이 짧은 소리를 재생합니다.", 
    "devices_placeholder": "장치를 선택하세요", 
    "sending": "보내는 중...", 
    "option_background_permission": "브라우저가 닫혔을 때에도 Pushbullet이 계속 동작되도록 함", 
    "reply_limit_reached": "이번 달 무료 메시지 한계치에 도달했습니다.", 
    "decryption_failed_title": "복호화 실패", 
    "push_context_message": "{2}에 {1}(으)로부터", 
    "options": "설정", 
    "option_background_permission_desc": "브라우저 창을 열고 있지 않아도 알림을 볼 수 있게 합니다.", 
    "mirror_context_message": "{1}을(를) 통해 {2}에 보냄", 
    "encryption_password_needed_title": "암호화된 데이터 수신됨", 
    "option_automatically_attach_link_desc": "링크를 더 빨리 전송할 수 있습니다.", 
    "how_to_unmute_app_answer": "Pushbullet Android 앱을 실행하고 왼쪽에서 서랍을 여세요. '알림 미러링'을 탭하고 '알림을 활성화할 앱'을 탭하고 앱을 다시 활성화하면 됩니다.", 
    "device": "장치", 
    "done": "완료", 
    "cancel": "취소", 
    "snoozed_until": "{1}까지 음소거됨.", 
    "sign_out": "로그아웃", 
    "from": "{1}이(가) 보냄", 
    "panel_cant_sign_in": "로그인을 할 수 없다면 잠시 Adblock을 꺼보세요. 그래도 로그인을 할 수 없으면 서드 파티 쿠키가 활성화되어 있는지 확인해보세요. 로그인을 한 후 다시 비활성화할 수 있습니다.", 
    "option_allow_instant_push_desc": "키보드 단축 키를 통해 현재 탭을 선택한 장치에 푸시.", 
    "option_show_notification_count": "툴바 아이콘에서 알람 갯수 보기", 
    "reply_limit_warning": "이번 달 무료 메시지 한계치에 곧 도달합니다.", 
    "option_show_context_menu_desc": "마우스 오른쪽 버튼 메뉴에서 Pushbullet을 표시합니다.", 
    "panel_third_party_cookies": "어떻게 설정을 변경하는 지 알고 싶으시다면 여기를 클릭하세요", 
    "option_show_mirrors": "내 컴퓨터에서 알림 보기", 
    "notifications": "알림", 
    "option_use_dark_icon": "어두운 아이콘 사용", 
    "add_a_friend": "친구 추가", 
    "option_allow_instant_push": "인스턴트 푸시 활성화:", 
    "option_instant_push_shortcuts": "설정하려면 여기를 클릭하세요 (현재 {1}).", 
    "option_open_my_pushes_automatically": "이 브라우저로 보낸 링크를 자동으로 열기", 
    "me": "나", 
    "file_too_big": "파일이 너무 큼", 
    "option_clipboard_permission": "유니버셜 복사 붙여넣기", 
    "pushed_successfully": "푸시 성공", 
    "devices": "장치", 
    "option_show_notification_count_desc": "툴바에서 알림 갯수를 한눈에 볼 수 있습니다.", 
    "add_a_device": "장치 추가", 
    "end_to_end_password_desc": "비밀번호를 입력하려면 이 비밀번호를 각 장치에 입력해야 합니다.", 
    "general": "일반", 
    "reply_limit_upgrade": "Pushbullet Pro로 업그레이드하면 메시지를 무제한으로 보낼 수 있습니다.", 
    "message_placeholder_files": "메시지를 작성하거나 파일을 끌어다 놓으세요", 
    "option_clipboard_permission_desc": "하나의 장치에서 텍스트를 복사 후, 이 설정이 역시 켜져있는 다른 장치에 붙여 넣습니다.", 
    "no_pushes": "최근 기록이 없습니다", 
    "push_failed": "푸시를 보낼 수 없습니다.", 
    "option_notification_duration": "다음 시간이 지나면 알림을 자동으로 숨기기", 
    "new_sms_thread": "새 문자 메시지", 
    "dismiss": "닫기", 
    "decryption_failed_body": "모든 장치에서 비밀번호가 일치하는지 확인해주세요", 
    "sign_in": "로그인", 
    "go_to_link": "링크 열기", 
    "snooze": "1시간 음소거", 
    "friends": "친구", 
    "num_new_messages": "{1} 개의 새 메시지", 
    "remove_link_tooltip": "현재 페이지 링크 해제", 
    "phone": "휴대 전화", 
    "mute_app": "{1}의 알림 받지 않기", 
    "clear": "지우기", 
    "end_to_end_password_label": "단대단 암호화 비밀번호", 
    "add_link_tooltip": "현재 페이지 연결", 
    "option_only_show_titles_desc": "이 옵션은 Pushbullet이 오직 알림의 제목만 표시하도록 합니다. 프라이버시 보호에 도움이 될 수 있습니다.", 
    "all_of_my_devices": "모든 장치", 
    "unsubscribe_from_channel": "{1}을(를) 언팔로우하기", 
    "updated_notif_title": "Pushbullet이 업데이트되었습니다!"
}; 
strings["pl"] = {
    "mute": "Wycisz", 
    "thanks_for_installing_message": "Kliknij tutaj aby się zalogować", 
    "option_open_my_pushes_automatically_desc": "Ta opcja sprawia, że Pushbullet otworzy automatycznie w nowej zakładce wszystko co wyślesz do tej przeglądarki.", 
    "unsubscribed_from_channel": "Już nie subskrybujesz {1}", 
    "option_show_context_menu": "Pokaż Pushbullet w menu kontekstowym", 
    "option_use_dark_icon_desc": "Ta opcja zmienia kolor ikony na pasku narzędzi na ciemno szary.", 
    "alert_desktop_app_notifications": "Pushbullet w wersji aplikacji na komputer zarządza teraz powiadomieniami. Wyłączając powiadomienia w ustawieniach aplikacji, zostanie przywrócona kontrola nad nimi w rozszerzeniu przeglądarki.", 
    "sms_recipient_placeholder": "Kontakt lub numer telefoniczny", 
    "message_placeholder_link": "Dodaj wiadomość i naciśnij klawisz enter, aby wysłać", 
    "unsnooze": "Wznów", 
    "encryption_password_needed_body": "Kliknij tutaj, aby wprowadzić swoje hasło", 
    "send": "Wyślij", 
    "pushbullet_pro_feature": "Ta opcja wymaga Pushbullet Pro.", 
    "save": "Zapisz", 
    "option_instant_push_shortcuts_not_set": "nie ustawione", 
    "send_failed": "Wysyłanie nieudane", 
    "muted_app": "Wyciszono {1}", 
    "now": "Teraz", 
    "no_notifications": "Obecnie nie masz powiadomień", 
    "advanced": "Zaawansowane", 
    "channels": "Kanały", 
    "option_automatically_attach_link": "Automatycznie dołączaj otwartą kartę do wiadomości do urządzenia", 
    "changelog_tab": "Nowości", 
    "snoozing_desc": "\"Wstrzymanie powiadomień\" zatrzyma ich wyświetlanie przez Pushbullet na okres jednej godziny.", 
    "thanks_for_installing_title": "Dziękujemy za instalację Pushbullet", 
    "how_to_unmute_app": "Wyciszyłem aplikację, jak mogę to cofnąć?", 
    "title_placeholder": "Tytuł", 
    "message_placeholder": "Napisz wiadomość, i naciśnij przycisk Enter celem wysłania", 
    "updated_notif_message": "Kliknij tutaj aby poznać nowości", 
    "unmute_app": "Przywróć {1}", 
    "type_file": "Plik", 
    "panel_sign_up": "Zarejestruj się na Pushbullet.com →", 
    "pushbullet_pro_required": "Wymagany Pushbullet Pro", 
    "url_placeholder": "Adres łącza", 
    "recipient_placeholder": "Do", 
    "retry": "Powtórz", 
    "option_play_sound": "Odtwórz dźwięk, gdy otrzymasz powiadomienie", 
    "sms": "SMS", 
    "option_only_show_titles": "Pokazuj jedynie tytuł powiadomienia", 
    "sms_disclaimer": "Telefon musi być włączony i posiadać połączenie z internetem by wysyłać SMSy", 
    "reply": "Odpowiedz", 
    "see_full_history": "Zobacz pełną historię", 
    "type_link": "Link", 
    "undo": "Cofnij", 
    "learn_more": "Dowiedz się więcej", 
    "option_show_mirrors_desc": "Odnaczenie spowoduje zakończenie otrzymywania powiadomień (dalej będziesz widzieć ilość powiadomień w ikonie na pasku).", 
    "push_label": "Wyślij", 
    "option_play_sound_desc": "Ta opcja sprawia, że Pushbullet odtworzy krótki dźwięk, by zwrócić Twoją uwagę, gdy tylko przybędzie powiadomienie.", 
    "devices_placeholder": "Wybierz urządzenie", 
    "sending": "Wysyłanie...", 
    "option_background_permission": "Zezwalaj by Pushbullet działał w tle gdy przeglądarka jest wyłączona", 
    "reply_limit_reached": "Wyczerpałeś limit darmowych wiadomości w tym miesiącu.", 
    "decryption_failed_title": "Odszyfrowywanie nie powiodło się", 
    "push_context_message": "{1} na {2}", 
    "options": "Ustawienia", 
    "option_background_permission_desc": "Ta opcja pozwala wyświetlać powiadomienia bez potrzeby utrzymywania otwartego okna przeglądarki.", 
    "mirror_context_message": "{1} przez Pushbullet na {2}", 
    "encryption_password_needed_title": "Odebrano zaszyfrowane dane", 
    "option_automatically_attach_link_desc": "Funkcja przyśpiesza wysyłanie linków do urządzeń.", 
    "how_to_unmute_app_answer": "Otwórz aplikację Pushbullet dla Androida, wyciągnij menu z lewej, naciśnik \"Mirroring\" następnie naciśnij \"Tylko dla wybranych aplikacji\". Następnie ponownie aktywuj aplikację.", 
    "device": "Urządzenie", 
    "done": "Gotowe", 
    "cancel": "Anuluj", 
    "snoozed_until": "Wstrzymane do {1}.", 
    "sign_out": "Wyloguj się", 
    "from": "Od {1}", 
    "panel_cant_sign_in": "Nie możesz się zalogować? Spróbuj tymczasowo wyłączyć Adblock. Jeśli to nie pomaga, Pushbullet wymaga również do logowania włączonej obsługi plików cookie. Możesz ponownie ją wyłączyć po zalogowaniu.", 
    "option_allow_instant_push_desc": "Prześlij bieżącą kartę do wybranego urządzenia używając skrótu klawiszowego.", 
    "option_show_notification_count": "Pokaż licznik powiadomień na ikonie w pasku narzędzi", 
    "reply_limit_warning": "Zbliżasz się do limitu darmowych wiadomości przyznanych na ten miesiąc.", 
    "option_show_context_menu_desc": "Pokaż Pushbullet w menu prawego przycisku myszki.", 
    "panel_third_party_cookies": "Kliknij tutaj aby dowiedzieć się jak zmienić to ustawienie.", 
    "option_show_mirrors": "Pokaż powiadomienia na komputerze", 
    "notifications": "Powiadomienia", 
    "option_use_dark_icon": "Używaj ciemnej ikony", 
    "add_a_friend": "Dodaj znajomego", 
    "option_allow_instant_push": "Włącz natychmiastowe wysyłanie do", 
    "option_instant_push_shortcuts": "Kliknij tutaj, aby ustawić (obecnie {1}).", 
    "option_open_my_pushes_automatically": "Otwieraj automatycznie pliki i powiadomienia wysłane do tej przeglądarki.", 
    "me": "Ja", 
    "file_too_big": "Zbyt duży plik", 
    "option_clipboard_permission": "Uniwersalne kopiuj / wklej", 
    "pushed_successfully": "Wysłano pomyślnie", 
    "devices": "Urządzenia", 
    "option_show_notification_count_desc": "Zobacz swój licznik powiadomień w pasku narzędzi.", 
    "add_a_device": "Dodaj urządzenie", 
    "end_to_end_password_desc": "Jeśli zdecydujesz się podać hasło, będzie ono musiało zostać wprowadzone na każdym urządzeniu.", 
    "general": "Ogólne", 
    "reply_limit_upgrade": "Wykup Pushbullet Pro, aby móc wysyłać wiadomości bez limitu.", 
    "message_placeholder_files": "Napisz wiadomość lub upuść plik", 
    "option_clipboard_permission_desc": "Skopiowany na jednym urządzeniu tekst można następnie wkleić na każdym innym, które ma włączoną tę opcję.", 
    "no_pushes": "Brak historii", 
    "push_failed": "Przepraszamy, nie udało się tego wysłać", 
    "option_notification_duration": "Ukrywaj powiadomienia automatycznie po", 
    "new_sms_thread": "Nowy SMS", 
    "dismiss": "Odrzuć", 
    "decryption_failed_body": "Upewnij się, że Twoje hasło jest takie samo na wszystkich urządzeniach", 
    "sign_in": "Zaloguj się", 
    "go_to_link": "Otwórz link", 
    "snooze": "Wstrzymaj 1 godz.", 
    "friends": "Znajomi", 
    "num_new_messages": "{1} nowych wiadomości", 
    "remove_link_tooltip": "Nie linkuj bieżącej strony", 
    "phone": "Telefon", 
    "mute_app": "Wycisz powiadomienia {1}", 
    "clear": "Wyczyść", 
    "end_to_end_password_label": "Hasło szyfrowania end-to-end", 
    "add_link_tooltip": "Zapisz link do bieżącej strony", 
    "option_only_show_titles_desc": "To spowoduje, że Pushbullet będzie pokazywał tylko nagłówki wiadomości.", 
    "all_of_my_devices": "Wszystkie moje urządzenia", 
    "unsubscribe_from_channel": "Usuń subskrypcję {1}", 
    "updated_notif_title": "Pushbullet został zaktualizowany!"
}; 
strings["bg"] = {
    "mute": "Спиране", 
    "thanks_for_installing_message": "Щракнете тук, за да влезете", 
    "option_open_my_pushes_automatically_desc": "Това ще накара Pushbullet автоматично да отваря в нов раздел всичко, което изпращате до този браузър.", 
    "unsubscribed_from_channel": "Вече не следите {1}", 
    "option_show_context_menu": "Да се показва Pushbullet в контекстното меню", 
    "option_use_dark_icon_desc": "Това ще направи нашата икона в лентата тъмно сива.", 
    "alert_desktop_app_notifications": "Известията се управляват от приложението за работен плот на Pushbullet. Забраняването на известията в настройките му ще върне контрола на разширението.", 
    "sms_recipient_placeholder": "Контакт или телефонен номер", 
    "message_placeholder_link": "Добавете съобщение и натиснете Ентер за изпращане", 
    "unsnooze": "Възобновяване", 
    "encryption_password_needed_body": "Щракнете тук, за да въведете паролата си", 
    "send": "Изпращане", 
    "pushbullet_pro_feature": "За тази функция е необходим Pushbullet Pro.", 
    "save": "Запис", 
    "option_instant_push_shortcuts_not_set": "не е зададена", 
    "send_failed": "Неуспешно изпращане", 
    "muted_app": "Спрени {1}", 
    "now": "Сега", 
    "no_notifications": "Няма известия в момента", 
    "advanced": "Разширени", 
    "channels": "Канали", 
    "option_automatically_attach_link": "Автоматично прикачване на текущия раздел към съобщенията към устройство", 
    "changelog_tab": "Новите неща", 
    "snoozing_desc": "Pushbullet няма да показва известия за един час.", 
    "thanks_for_installing_title": "Благодарим ви, че инсталирахте Pushbullet", 
    "how_to_unmute_app": "Спрях известията от приложение, как да ги включа отново?", 
    "title_placeholder": "Заглавие", 
    "message_placeholder": "Въведете съобщение и натиснете Еnter за изпращане", 
    "updated_notif_message": "Щракнете тук, за да видите новите неща", 
    "unmute_app": "Възстановяване на {1}", 
    "type_file": "Файл", 
    "panel_sign_up": "Регистрация на Pushbullet.com →", 
    "pushbullet_pro_required": "Изисква се Pushbullet Pro", 
    "url_placeholder": "Адрес на връзката", 
    "recipient_placeholder": "До", 
    "retry": "Нов опит", 
    "option_play_sound": "Звуков сигнал при пристигане на известие", 
    "sms": "SMS", 
    "option_only_show_titles": "Да се показват само заглавията на известията", 
    "sms_disclaimer": "Телефонът трябва да е включен и да има връзка с Интернет, за да се изпратят съобщенията.", 
    "reply": "Отговор", 
    "see_full_history": "Преглед на пълната хронология", 
    "type_link": "Връзка", 
    "undo": "Отмяна", 
    "learn_more": "Научете повече", 
    "option_show_mirrors_desc": "Премахването на отметката от това поле ще спре показването на известия (все още можете да виждате броя им върху нашата икона в лентата с инструменти).", 
    "push_label": "Изпращане", 
    "option_play_sound_desc": "Това ще накара Pushbullet да пуска кратък звук, за да ви предупреди, когато пристигне известие.", 
    "devices_placeholder": "Изберете устройство", 
    "sending": "Изпращане...", 
    "option_background_permission": "Pushbullet да работи, дори когато браузъра е затворен", 
    "reply_limit_reached": "Достигнахте лимита на безплатните съобщения за този месец.", 
    "decryption_failed_title": "Дешифрирането е неуспешно", 
    "push_context_message": "{1} в {2}", 
    "options": "Настройки", 
    "option_background_permission_desc": "Това ще ви позволи да виждате вашите съобщения, без да се налага да държите отворен прозореца на браузъра.", 
    "mirror_context_message": "{1} чрез Pushbullet в {2}", 
    "encryption_password_needed_title": "Получени шифровани данни", 
    "option_automatically_attach_link_desc": "Това прави изпращането на връзки към устройствата по-бързо.", 
    "how_to_unmute_app_answer": "Отворете приложението Pushbullet за Android, отворете менюто отляво, след което натиснете „Синхронизиране“. Тук, натиснете „Само за определени приложения“ и включете повторно приложението.", 
    "device": "Устройство", 
    "done": "Готово", 
    "cancel": "Отказ", 
    "snoozed_until": "На пауза до {1}.", 
    "sign_out": "Изход", 
    "from": "От {1}", 
    "panel_cant_sign_in": "Не можете да влезете? Опитайте временно да деактивирате Adblock. Ако това не помогне, Pushbullet изисква да позволите бисквитките от трети лица. Можете да ги забраните отново, след като влезете.", 
    "option_allow_instant_push_desc": "Изпращане на текущия раздел към избраното устройство чрез клавишна комбинация.", 
    "option_show_notification_count": "Показване броя на известията върху иконата на лентата с инструменти", 
    "reply_limit_warning": "Наближавате лимита на безплатните съобщения за този месец.", 
    "option_show_context_menu_desc": "Показване на Pushbullet в списъка с опции при щракване с десния бутон на мишката.", 
    "panel_third_party_cookies": "Щракнете тук, за да разберете как да промените тази настройка.", 
    "option_show_mirrors": "Показване на известия на компютъра.", 
    "notifications": "Известия", 
    "option_use_dark_icon": "Да се използва тъмна икона", 
    "add_a_friend": "+ Добавяне на приятел", 
    "option_allow_instant_push": "Включване на незабавно изпращане до", 
    "option_instant_push_shortcuts": "Щракнете тук, за да зададете (в момента {1}).", 
    "option_open_my_pushes_automatically": "Автоматично отваряне на нещата, които изпращам до този браузър.", 
    "me": "Аз", 
    "file_too_big": "Файлът е твърде голям", 
    "option_clipboard_permission": "Универсално копиране и поставяне", 
    "pushed_successfully": "Изпратено успешно", 
    "devices": "Устройства", 
    "option_show_notification_count_desc": "Виждайте броя на известията си в лентата с инструменти.", 
    "add_a_device": "+ Добавяне на устройство", 
    "end_to_end_password_desc": "Ако изберете да въведете парола, ще трябва да я въведете на всяко от вашите устройства.", 
    "general": "Общи", 
    "reply_limit_upgrade": "Надградете до Pushbullet Pro, за да изпращате неограничен брой съобщения.", 
    "message_placeholder_files": "Въведете съобщение или плъзнете файл тук", 
    "option_clipboard_permission_desc": "Копирайте текст на едно устройство, след това го поставете на всяко друго, което също има включена тази настройка.", 
    "no_pushes": "Няма хронология", 
    "push_failed": "За съжаление, това не може да се изпрати", 
    "option_notification_duration": "Автоматично скриване на известията след", 
    "new_sms_thread": "Ново текстово съобщение", 
    "dismiss": "Отхвърляне", 
    "decryption_failed_body": "Проверете дали паролата ви съвпада на всички устройства", 
    "sign_in": "Вход", 
    "go_to_link": "Отваряне на връзката", 
    "snooze": "Спиране за 1 час", 
    "friends": "Приятели", 
    "num_new_messages": "{1} нови съобщения", 
    "remove_link_tooltip": "Премахване на връзката за текущата страница", 
    "phone": "Телефон", 
    "mute_app": "Спиране на {1} известия", 
    "clear": "Изчистване", 
    "end_to_end_password_label": "Парола за шифроване от край до край", 
    "add_link_tooltip": "Връзка към текущата страница", 
    "option_only_show_titles_desc": "Pushbullet ще показва само заглавията на известията, запазвайки поверителността на съобщението.", 
    "all_of_my_devices": "Всички мои устройства", 
    "unsubscribe_from_channel": "Отписване от {1}", 
    "updated_notif_title": "Pushbullet е актуализиран!"
}; 
strings["pt-PT"] = {
    "mute": "Silenciar", 
    "thanks_for_installing_message": "Clique aqui para iniciar sessão", 
    "option_open_my_pushes_automatically_desc": "Isto fará com que o Pushbullet abra automaticamente num novo separador tudo o que o utilizador enviar para este navegador.", 
    "unsubscribed_from_channel": "Já não segue {1}", 
    "option_show_context_menu": "Mostrar o Pushbullet no menu de contexto do meu navegador", 
    "option_use_dark_icon_desc": "Isto tornará o ícone da barra de ferramentas cinzento-escuro.", 
    "alert_desktop_app_notifications": "A aplicação de ambiente de trabalho do Pushbullet está a gerir as notificações.", 
    "sms_recipient_placeholder": "Contacto ou número de telemóvel", 
    "message_placeholder_link": "Adicione uma mensagem e prima Enter para enviar", 
    "unsnooze": "Cancelar adiamento", 
    "encryption_password_needed_body": "Clique aqui para introduzir a sua palavra-passe", 
    "send": "Enviar", 
    "pushbullet_pro_feature": "É necessário o Pushbullet Pro para ativar esta funcionalidade.", 
    "save": "Guardar", 
    "option_instant_push_shortcuts_not_set": "não definido", 
    "send_failed": "Envio falhado", 
    "muted_app": "Aplicação {1} silenciada", 
    "now": "Agora", 
    "no_notifications": "Nenhuma notificação de momento", 
    "advanced": "Avançadas", 
    "channels": "Canais", 
    "option_automatically_attach_link": "Anexar automaticamente o separador atual às mensagens enviadas para dispositivos", 
    "changelog_tab": "Novidades", 
    "snoozing_desc": "O adiamento impede o Pushbullet de mostrar as suas notificações durante uma hora.", 
    "thanks_for_installing_title": "Obrigado por instalar o Pushbullet", 
    "how_to_unmute_app": "Silenciei uma aplicação. Como a reativo?", 
    "title_placeholder": "Título", 
    "message_placeholder": "Escreva uma mensagem e prima Enter para enviar", 
    "updated_notif_message": "Clique aqui para ver as novidades", 
    "unmute_app": "Reativar {1}", 
    "type_file": "Ficheiro", 
    "panel_sign_up": "Registe-se em Pushbullet.com →", 
    "pushbullet_pro_required": "É necessário o Pushbullet Pro", 
    "url_placeholder": "URL da ligação", 
    "recipient_placeholder": "Para", 
    "retry": "Tentar novamente", 
    "option_play_sound": "Reproduzir um som quando uma notificação chegar.", 
    "sms": "SMS", 
    "option_only_show_titles": "Apenas mostrar o título das notificações.", 
    "sms_disclaimer": "O telemóvel deve estar ligado e possuir uma ligação à internet para enviar mensagens.", 
    "reply": "Responder", 
    "see_full_history": "Ver histórico completo", 
    "type_link": "Ligação", 
    "undo": "Anular", 
    "learn_more": "Saber mais", 
    "option_show_mirrors_desc": "Desmarcar isto fará com que não sejam mostradas notificações (mas ainda poderá consultar o total no ícone da barra de ferramentas).", 
    "push_label": "Enviar", 
    "option_play_sound_desc": "Isto fará com que o Pushbullet reproduza um pequeno som de alerta quando uma notificação chegar.", 
    "devices_placeholder": "Selecione um dispositivo", 
    "sending": "A enviar...", 
    "option_background_permission": "Manter o Pushbullet em execução quando o navegador for fechado", 
    "reply_limit_reached": "Alcançou o limite de mensagens gratuitas deste mês.", 
    "decryption_failed_title": "Falha na desencriptação", 
    "push_context_message": "{1} às {2}", 
    "options": "Definições", 
    "option_background_permission_desc": "Isto permitir-lhe-á ver as suas notificações sem precisar de manter uma janela do navegador aberta.", 
    "mirror_context_message": "{1} através do Pushbullet às {2}", 
    "encryption_password_needed_title": "Dados encriptados recebidos", 
    "option_automatically_attach_link_desc": "Isto torna mais rápido o envio de ligações para dispositivos.", 
    "how_to_unmute_app_answer": "Abra a aplicação para Android do Pushbullet, puxe a gaveta a partir da esquerda e toque em 'Espelhamento'. Aqui, toque em 'Apenas para algumas aplicações' e reative a aplicação.", 
    "device": "Dispositivo", 
    "done": "Concluído", 
    "cancel": "Cancelar", 
    "snoozed_until": "Adiado até às {1}.", 
    "sign_out": "Terminar sessão", 
    "from": "De {1}", 
    "panel_cant_sign_in": "Não consegue iniciar sessão? Tente desativar temporariamente o bloqueio de anúncios. Caso não funcione, o Pushbullet requer que os cookies de terceiros estejam ativos para iniciar sessão. Pode desativá-los novamente após o início de sessão.", 
    "option_allow_instant_push_desc": "Enviar o separador atual para o dispositivo escolhido através de um atalho de teclado.", 
    "option_show_notification_count": "Mostrar número de notificações no ícone da barra de ferramentas", 
    "reply_limit_warning": "Está a aproximar-se do limite de mensagens gratuitas deste mês.", 
    "option_show_context_menu_desc": "Mostrar o Pushbullet na lista de opções do menu de clique direito.", 
    "panel_third_party_cookies": "Clique aqui para saber como alterar esta definição.", 
    "option_show_mirrors": "Mostrar notificações no meu computador", 
    "notifications": "Notificações", 
    "option_use_dark_icon": "Utilizar ícone escuro", 
    "add_a_friend": "Adicionar um amigo", 
    "option_allow_instant_push": "Ativar envio instantâneo para", 
    "option_instant_push_shortcuts": "Clique aqui para definir (atualmente, {1}).", 
    "option_open_my_pushes_automatically": "Abrir automaticamente o que eu enviar para este navegador", 
    "me": "Eu", 
    "file_too_big": "O ficheiro é demasiado grande", 
    "option_clipboard_permission": "Copiar e colar universal", 
    "pushed_successfully": "Enviado com sucesso", 
    "devices": "Dispositivos", 
    "option_show_notification_count_desc": "Veja de relance quantas notificações possui na sua barra de ferramentas.", 
    "add_a_device": "Adicionar um dispositivo", 
    "end_to_end_password_desc": "Se optar por introduzir uma palavra-passe, esta terá de ser introduzida em cada um dos seus dispositivos.", 
    "general": "Geral", 
    "reply_limit_upgrade": "Atualize para o Pushbullet Pro para enviar mensagens ilimitadas.", 
    "message_placeholder_files": "Escreva uma mensagem ou largue um ficheiro", 
    "option_clipboard_permission_desc": "Copie texto num dispositivo, depois cole-o em qualquer outro que também possua esta definição ativa.", 
    "no_pushes": "Sem histórico recente", 
    "push_failed": "Pedimos desculpa, mas não conseguimos enviar isso", 
    "option_notification_duration": "Ocultar notificações automaticamente após", 
    "new_sms_thread": "Nova mensagem", 
    "dismiss": "Ignorar", 
    "decryption_failed_body": "Por favor, confirme que a sua palavra-passe corresponde em todos os seus dispositivos", 
    "sign_in": "Iniciar sessão", 
    "go_to_link": "Ir para a ligação", 
    "snooze": "Adiar 1 h", 
    "friends": "Amigos", 
    "num_new_messages": "{1} mensagens novas", 
    "remove_link_tooltip": "Remover ligação para esta página", 
    "phone": "Tlm.", 
    "mute_app": "Silenciar notificações de {1}", 
    "clear": "Limpar", 
    "end_to_end_password_label": "Palavra-passe de encriptação ponto a ponto", 
    "add_link_tooltip": "Adicionar ligação para esta página", 
    "option_only_show_titles_desc": "Isto fará com que o Pushbullet apenas mostre o título das notificações, mantendo a mensagem privada.", 
    "all_of_my_devices": "Todos os meus dispositivos", 
    "unsubscribe_from_channel": "Deixar de seguir {1}", 
    "updated_notif_title": "O Pushbullet foi atualizado!"
}; 
strings["th"] = {
    "mute": "ไม่แสดง", 
    "thanks_for_installing_message": "คลิกที่นี่เพื่อเข้าสู่ระบบ", 
    "option_open_my_pushes_automatically_desc": "ตัวเลือกนี้จะทำให้ Pushbullet เปิดทุกอย่างที่คุณส่งมายังเบราว์เซอร์นี้ในแท็บใหม่โดยอัตโนมัติ", 
    "unsubscribed_from_channel": "ไม่ติดตาม {1} อีกต่อไป", 
    "option_show_context_menu": "แสดง Pushbullet ในเมนูคลิกขวา", 
    "option_use_dark_icon_desc": "ตัวเลือกนี้จะทำให้ไอคอนบนแถบเครื่องมือเปลี่ยนเป็นสีเทาเข้ม", 
    "alert_desktop_app_notifications": "แอป Pushbullet สำหรับเดสก์ท็อปกำลังจัดการการแจ้งเตือน ปิดรับการแจ้งเตือนในหน้าตั้งค่าของแอปสำหรับเดสก์ท็อปเพื่อใช้ส่วนขยายควบคุมแทน", 
    "sms_recipient_placeholder": "ผู้ติดต่อหรือหมายเลขโทรศัพท์", 
    "message_placeholder_link": "พิมพ์ข้อความ, กด enter เพื่อส่ง", 
    "unsnooze": "ยกเลิกเลื่อน", 
    "encryption_password_needed_body": "คลิกที่นี่เพื่อใส่รหัสผ่านของคุณ", 
    "send": "ส่ง", 
    "pushbullet_pro_feature": "ต้องการ Pushbullet โปรเพื่อเปิดใช้งานคุณสมบัตินี้", 
    "save": "บันทึก", 
    "option_instant_push_shortcuts_not_set": "ไม่ได้ตั้งค่า", 
    "send_failed": "การส่งล้มเหลว", 
    "muted_app": "ไม่แสดง {1}", 
    "now": "ตอนนี้", 
    "no_notifications": "ไม่มีการแจ้งเตือนในขณะนี้", 
    "advanced": "ขั้นสูง", 
    "channels": "ช่อง", 
    "option_automatically_attach_link": "แนบลิงก์ของแท็บปัจจุบันไปกับข้อความที่ส่งไปยังอุปกรณ์โดยอัตโนมัติ", 
    "changelog_tab": "มีอะไรใหม่", 
    "snoozing_desc": "เลื่อนช่วยให้หยุดแสดงการแจ้งเตือนจาก Pushbullet เป็นเวลาหนึ่งชั่วโมง", 
    "thanks_for_installing_title": "ของคุณสำหรับการติดตั้ง Pushbullet", 
    "how_to_unmute_app": "ฉันไม่แสดงการแจ้งเตือนแอป, จะแสดงอีกครั้งได้อย่างไร?", 
    "title_placeholder": "หัวข้อ", 
    "message_placeholder": "พิมพ์ข้อความ, กด enter เพื่อส่ง", 
    "updated_notif_message": "คลิกที่นี่เพื่อดูว่ามีอะไรใหม่", 
    "unmute_app": "แสดง {1}", 
    "type_file": "ไฟล์", 
    "panel_sign_up": "ลงทะเบียนที่ Pushbullet.com →", 
    "pushbullet_pro_required": "ต้องใช้ Pushbullet โปร", 
    "url_placeholder": "URL ลิงก์", 
    "recipient_placeholder": "ถึง", 
    "retry": "ลองใหม่", 
    "option_play_sound": "ส่งเสียงเมื่อมีการแจ้งเตือน", 
    "sms": "SMS", 
    "option_only_show_titles": "แสดงเฉพาะหัวข้อการแจ้งเตือน", 
    "sms_disclaimer": "โทรศัพท์ต้องเปิดอยู่ และมีการเชื่อมต่ออินเทอร์เน็ตเพื่อส่งข้อความ", 
    "reply": "ตอบกลับ", 
    "see_full_history": "ดูประวัติทั้งหมด", 
    "type_link": "ลิงก์", 
    "undo": "ยกเลิก", 
    "learn_more": "เรียนรู้เพิ่มเติม", 
    "option_show_mirrors_desc": "ไม่เลือกสิ่งนี้จะหยุดแสดงการแจ้งเตือน (คุณยังสามารถดูจำนวนการแจ้งเตือนได้บนไอคอนในแถบเครื่องมือ)", 
    "push_label": "ส่ง", 
    "option_play_sound_desc": "ตัวเลือกนี้จะทำให้ Pushbullet ส่งเสียงสั้นๆ เมื่อมีการแจ้งเตือนมาถึง", 
    "devices_placeholder": "เลือกอุปกรณ์", 
    "sending": "กำลังส่ง...", 
    "option_background_permission": "ให้ Pushbullet ทำงานต่อไปเมื่อฉันปิดเบราว์เซอร์", 
    "reply_limit_reached": "คุณมาถึงขีดจำกัดข้อความฟรีของเดือนนี้แล้ว", 
    "decryption_failed_title": "การถอดรหัสล้มเหลว", 
    "push_context_message": "{1} เมื่อ {2}", 
    "options": "ตั้งค่า", 
    "option_background_permission_desc": "ตัวเลือกนี้จะทำให้คุณสามารถดูการแจ้งเตือนโดยไม่ต้องเปิดหน้าต่างเบราว์เซอร์ทิ้งไว้", 
    "mirror_context_message": "{1} ผ่าน Pushbullet เมื่อ {2}", 
    "encryption_password_needed_title": "ได้รับข้อมูลที่มีการเข้ารหัส", 
    "option_automatically_attach_link_desc": "ทำให้การส่งลิงก์ไปยังอุปกรณ์ต่างๆ เร็วขึ้น", 
    "how_to_unmute_app_answer": "เปิดแอป Pushbullet บนแอนดรอยด์ ดึงแถบด้านข้างออกมาจากทางซ้าย จากนั้นแตะ 'การซิงค์' แล้วแตะ 'เฉพาะบางแอป' จากนั้นเปิดใช้งานอีกครั้ง", 
    "device": "อุปกรณ์", 
    "done": "เสร็จ", 
    "cancel": "ยกเลิก", 
    "snoozed_until": "เลื่อนจนถึง {1}", 
    "sign_out": "ออกจากระบบ", 
    "from": "จาก {1}", 
    "panel_cant_sign_in": "ไม่สามารถเข้าสู่ระบบ? ลองปิดใช้ Adblock ชั่วคราว หากยังไม่ได้ Pushbullet จำเป็นต้องการคุกกี้ของบุคคลที่สามเพื่อเปิดให้เข้าสู่ระบบได้ คุณสามารถปิดมันได้อีกครั้งหลังเข้าสู่ระบบเสร็จ", 
    "option_allow_instant_push_desc": "ส่งแท็บปัจจุบันไปยังอุปกรณ์ที่เลือกไว้ด้วยคีย์ลัด", 
    "option_show_notification_count": "แสดงจำนวนการแจ้งเตือนในแถบเครื่องมือ", 
    "reply_limit_warning": "คุณกำลังเข้าใกล้ขีดจำกัดข้อความฟรีของเดือนนี้", 
    "option_show_context_menu_desc": "แสดงตัวเลือก Pushbullet ในรายการของเมนูคลิกขวา", 
    "panel_third_party_cookies": "คลิกที่นี่เพื่อดูวิธีเปลี่ยนการตั้งค่านี้", 
    "option_show_mirrors": "แสดงการแจ้งเตือนบนคอมพิวเตอร์ของฉัน", 
    "notifications": "การแจ้งเตือน", 
    "option_use_dark_icon": "ใช้ไอคอนสีเข้ม", 
    "add_a_friend": "+ เพิ่มเพื่อน", 
    "option_allow_instant_push": "เปิดใช้งานการส่งแบบทันทีไปยัง", 
    "option_instant_push_shortcuts": "คลิกที่นี่เพื่อตั้งค่า (ขณะนี้ {1})", 
    "option_open_my_pushes_automatically": "เปิดสิ่งที่ฉันส่งมายังเบราว์เซอร์นี้โดยอัตโนมัติ", 
    "me": "ฉัน", 
    "file_too_big": "ไฟล์ใหญ่เกินไป", 
    "option_clipboard_permission": "คัดลอก & วางครอบจักรวาล", 
    "pushed_successfully": "ส่งเรียบร้อย", 
    "devices": "อุปกรณ์", 
    "option_show_notification_count_desc": "ดูจำนวนการแจ้งเตือนอย่างรวดเร็วในแถบเครื่องมือของคุณ", 
    "add_a_device": "+ เพิ่มอุปกรณ์", 
    "end_to_end_password_desc": "หากคุณเลือกที่จะใส่รหัสผ่าน คุณจะต้องป้อนรหัสผ่านนี้ทุกอุปกรณ์ของคุณ", 
    "general": "ทั่วไป", 
    "reply_limit_upgrade": "อัปเกรดเป็น Pushbullet โปรเพื่อส่งข้อความได้ไม่จำกัด", 
    "message_placeholder_files": "พิมพ์ข้อความ หรือวางไฟล์", 
    "option_clipboard_permission_desc": "คัดลอกข้อความจากอุปกรณ์หนึ่ง จากนั้นวางบนอุปกรณ์อื่นๆ ที่มีการเปิดการตั้งค่านี้ไว้", 
    "no_pushes": "ไม่มีประวัติล่าสุด", 
    "push_failed": "ขออภัย, เราไม่สามารถส่งสิ่งนี้", 
    "option_notification_duration": "ซ่อนการแจ้งเตือนอัตโนมัติหลังจาก", 
    "new_sms_thread": "ข้อความใหม่", 
    "dismiss": "ปิด", 
    "decryption_failed_body": "กรุณายืนยันว่ารหัสผ่านของคุณตรงกับบนทุกอุปกรณ์", 
    "sign_in": "เข้าสู่ระบบ", 
    "go_to_link": "ไปยังลิงก์", 
    "snooze": "เลื่อน 1 ชั่วโมง", 
    "friends": "เพื่อน", 
    "num_new_messages": "{1} ข้อความใหม่", 
    "remove_link_tooltip": "ไม่ต้องลิงก์หน้าปัจจุบัน", 
    "phone": "โทรศัพท์", 
    "mute_app": "ไม่ต้องแสดงการแจ้งเตือนจาก {1}", 
    "clear": "ล้าง", 
    "end_to_end_password_label": "รหัสผ่านการเข้ารหัสปลายทางถึงปลายทาง", 
    "add_link_tooltip": "ลิงก์หน้าปัจจุบัน", 
    "option_only_show_titles_desc": "นี่จะทำให้ Pushbullet แสดงเฉพาะหัวข้อการแจ้งเตือน, เก็บข้อความไว้เป็นความลับ", 
    "all_of_my_devices": "อุปกรณ์ทั้งหมดของฉัน", 
    "unsubscribe_from_channel": "เลิกติดตาม {1}", 
    "updated_notif_title": "Pushbullet อัปเดตแล้ว!"
}; 
strings["hu"] = {
    "mute": "Némítás", 
    "thanks_for_installing_message": "Kattintson ide a bejelentkezéshez", 
    "option_open_my_pushes_automatically_desc": "Ezzel a Pushbullet egy új lapon automatikusan megnyit mindent, amit a böngészőnek küld.", 
    "unsubscribed_from_channel": "{1} többé nincs követve", 
    "option_show_context_menu": "Mutassa a Pushbullet-et a környezeti menüben", 
    "option_use_dark_icon_desc": "Ez az eszköztár ikont szürkére színezi.", 
    "alert_desktop_app_notifications": "A Pushbullet asztali alkalmazás kezeli az értesítéseket. Letiltva az értesítéseket az asztali alkalmazás beállításaiban visszaadja az irányítást a böngésző bővítménynek.", 
    "sms_recipient_placeholder": "Névjegy vagy telefonszám", 
    "message_placeholder_link": "Adjon hozzá egy üzenetet, nyomja meg az entert a küldéshez", 
    "unsnooze": "Szundi vége", 
    "encryption_password_needed_body": "Kattintson ide jelszava megadásához", 
    "send": "Küldés", 
    "pushbullet_pro_feature": "Pushbullet Pro szükséges a funkcióhoz.", 
    "save": "Mentés", 
    "option_instant_push_shortcuts_not_set": "nincs beállítva", 
    "send_failed": "Küldés sikertelen", 
    "muted_app": "{1} lenémítva", 
    "now": "Most", 
    "no_notifications": "Most nincsenek értesítések", 
    "advanced": "Speciális", 
    "channels": "Csatornák", 
    "option_automatically_attach_link": "Automatikusan csatolja a jelenlegi lapot az üzenetekhez", 
    "changelog_tab": "Mi újság", 
    "snoozing_desc": "A szundi kikapcsolja az értesítések megjelenítését egy órára.", 
    "thanks_for_installing_title": "Köszönjük, hogy telepítette a Pushbullet-et", 
    "how_to_unmute_app": "Elnémítottam egy alkalmazást, hogy vonhatom vissza?", 
    "title_placeholder": "Cím", 
    "message_placeholder": "Írjon be egy üzenetet, nyomja meg az entert a küldéshez", 
    "updated_notif_message": "Kattintson ide, hogy mi az új!", 
    "unmute_app": "{1} némítás feloldása", 
    "type_file": "Fájl", 
    "panel_sign_up": "Iratkozzon fel a Pushbullet.com-ra →", 
    "pushbullet_pro_required": "", 
    "url_placeholder": "Link URL-címe", 
    "recipient_placeholder": "Ide", 
    "retry": "Újra", 
    "option_play_sound": "Hangeffektus lejátszása, amikor értesítés érkezik", 
    "sms": "SMS", 
    "option_only_show_titles": "Csak az értesítés címeket mutassa", 
    "sms_disclaimer": "A telefonnak bekapcsolva kell lennie, és internetkapcsolattal kell rendelkeznie szöveges üzenetek küldéséhez.", 
    "reply": "Válasz", 
    "see_full_history": "Teljes előzménylista", 
    "type_link": "Link", 
    "undo": "Visszavonás", 
    "learn_more": "Tudj meg többet", 
    "option_show_mirrors_desc": "Ezzel kikapcsolja az értesítések megjelenítését (a számláló továbbra is látható lesz az eszköztár ikonon).", 
    "push_label": "Küldés", 
    "option_play_sound_desc": "A Pushbullet egy rövid hangjelzéssel figyelmeztet a bejövő értesítésre.", 
    "devices_placeholder": "Válasszon egy készüléket", 
    "sending": "Küldés...", 
    "option_background_permission": "Fusson tovább a Pushbullet a böngésző bezárása után", 
    "reply_limit_reached": "", 
    "decryption_failed_title": "Sikertelen volt a visszafejtés", 
    "push_context_message": "{1}; {2}", 
    "options": "Beállítások", 
    "option_background_permission_desc": "Ez lehetővé teszi, hogy lássa az értesítéseit anélkül, hogy egy böngészőablakot nyitva tartana.", 
    "mirror_context_message": "{1} Pushbullet-en keresztül {2}-kor", 
    "encryption_password_needed_title": "Titkosított adat fogadva", 
    "option_automatically_attach_link_desc": "Ezzel a linkek küldése gyorsabb lesz.", 
    "how_to_unmute_app_answer": "Nyissa meg a Pushbullet Android alkalmazást, nyissa meg a bal oldali fület és menjen a \"Tükrözés\"-re. Itt érintse meg a \"Csak néhány alkalmazásnak\" pontot, és engedélyezze újra az alkalmazást.", 
    "device": "Készülék", 
    "done": "Kész", 
    "cancel": "Mégse", 
    "snoozed_until": "Szundi eddig: {1}.", 
    "sign_out": "Kijelentkezés", 
    "from": "A következőtől: {1}", 
    "panel_cant_sign_in": "Nem tud bejelentkezni? Próbálja meg átmenetileg kikapcsolni az Adblock-ot. Ha ez nem segít, a Pushbullet-nek szüksége van a harmadik féltől származó sütik engedélyezésére a bejelentkezéshez. Később újra letilthatja őket, miután sikerült a bejelentkezés.", 
    "option_allow_instant_push_desc": "Küldje el a jelenlegi lapot a kiválasztott eszközre gyorsbillentyűvel.", 
    "option_show_notification_count": "Értesítés számláló mutatása az ikonon", 
    "reply_limit_warning": "", 
    "option_show_context_menu_desc": "Mutassa a Pushbullet-et a jobb-klikk menü opcióiban.", 
    "panel_third_party_cookies": "Kattintson ide, hogy hogyan kell megváltoztatni ezt a beállítást.", 
    "option_show_mirrors": "Mutassa az értesítéseket a számítógépen.", 
    "notifications": "Értesítések", 
    "option_use_dark_icon": "Sötét ikon használata", 
    "add_a_friend": "Ismerős hozzáadása", 
    "option_allow_instant_push": "Engedélyezi az azonnali küldést neki: ", 
    "option_instant_push_shortcuts": "Ide kattintva állíthatja be (jelenleg {1}).", 
    "option_open_my_pushes_automatically": "Automatikusan nyissa meg a dolgokat, amiket ennek a böngészőnek küldök.", 
    "me": "Nekem", 
    "file_too_big": "A fájl túl nagy", 
    "option_clipboard_permission": "Univerzális másolás & beillesztés", 
    "pushed_successfully": "Sikeresen elküldve", 
    "devices": "Készülékek", 
    "option_show_notification_count_desc": "Mutassa az értesítések számát az eszköztár ikonon.", 
    "add_a_device": "Eszköz hozzáadása", 
    "end_to_end_password_desc": "Ha kiválasztja hogy jelszót állít be, ez a jelszó lesz beállítva minden eszközén.", 
    "general": "Általános", 
    "reply_limit_upgrade": "", 
    "message_placeholder_files": "Írjon be egy üzenetet vagy húzzon ide egy fájlt", 
    "option_clipboard_permission_desc": "Másoljon szöveget az egyik eszközén, majd illessze be egy másikon, melyen ez a beállítás engedélyezve van.", 
    "no_pushes": "Nincs újabb előzmény", 
    "push_failed": "Sajnáljuk, nem tudjuk elküldeni ezt", 
    "option_notification_duration": "Értesítések elrejtése automatikusan", 
    "new_sms_thread": "Új szöveges üzenet", 
    "dismiss": "Elutasít", 
    "decryption_failed_body": "Győződjön meg róla, hogy a jelszavak egyeznek minden eszközén", 
    "sign_in": "Bejelentkezés", 
    "go_to_link": "Menj a linkre", 
    "snooze": "1 óra Szundi", 
    "friends": "Barátok", 
    "num_new_messages": "{1} új üzenet", 
    "remove_link_tooltip": "Link törlése", 
    "phone": "Telefon", 
    "mute_app": "Némítsd a(z) {1} értesítéseit", 
    "clear": "Törlés", 
    "end_to_end_password_label": "Végpont titkosítás jelszava", 
    "add_link_tooltip": "Jelenlegi oldal linkelése", 
    "option_only_show_titles_desc": "Ezzel a Pushbullet csak az értesítést mutatja, elrejtve az üzenet tartalmát.", 
    "all_of_my_devices": "Minden eszköz", 
    "unsubscribe_from_channel": "{1} követésének megszüntetése", 
    "updated_notif_title": "Pushbullet frissítve!"
}; 
strings["pt-BR"] = {
    "mute": "Desativar notificações", 
    "thanks_for_installing_message": "Clique aqui para iniciar sessão", 
    "option_open_my_pushes_automatically_desc": "Isto faz com que o Pushbullet abra automaticamente em uma nova aba qualquer coisa que você enviar para este navegador.", 
    "unsubscribed_from_channel": "Já não segue {1}", 
    "option_show_context_menu": "Mostrar Pushbullet no menu de contexto", 
    "option_use_dark_icon_desc": "Usa um ícone cinza escuro na barra de ferramentas.", 
    "alert_desktop_app_notifications": "O aplicativo de desktop Pushbullet está gerenciando as notificações.", 
    "sms_recipient_placeholder": "Contato ou número de telefone", 
    "message_placeholder_link": "Adicione uma mensagem, pressione enter para enviar", 
    "unsnooze": "Restaurar notificações", 
    "encryption_password_needed_body": "Clique aqui para digitar sua senha", 
    "send": "Enviar", 
    "pushbullet_pro_feature": "O Pushbullet Pro é necessário para habilitar esse recurso.", 
    "save": "Salvar", 
    "option_instant_push_shortcuts_not_set": "não definido", 
    "send_failed": "Falha no envio", 
    "muted_app": "Notificações de {1} desativadas", 
    "now": "Agora", 
    "no_notifications": "Sem notificações no momento", 
    "advanced": "Avançado", 
    "channels": "Canais", 
    "option_automatically_attach_link": "Anexar automaticamente a aba atual às mensagens enviadas para um dispositivo", 
    "changelog_tab": " O que há de novo", 
    "snoozing_desc": "Silenciar faz com que o Pushbullet pare de mostrar notificações por uma hora.", 
    "thanks_for_installing_title": "Obrigado por instalar o Pushbullet", 
    "how_to_unmute_app": "Silenciei uma aplicação. Como reativo?", 
    "title_placeholder": "Título", 
    "message_placeholder": "Digite uma mensagem, pressione enter para enviar", 
    "updated_notif_message": "Clique aqui para ver as novidades", 
    "unmute_app": "Reativar notificações de {1}", 
    "type_file": "Arquivo", 
    "panel_sign_up": "Cadastre-se em Pushbullet.com →", 
    "pushbullet_pro_required": "É necessário o Pushbullet Pro", 
    "url_placeholder": "Url do link", 
    "recipient_placeholder": "Para", 
    "retry": "Tentar novamente", 
    "option_play_sound": "Tocar um som quando chegar notificações", 
    "sms": "SMS", 
    "option_only_show_titles": "Mostrar apenas títulos das notificações", 
    "sms_disclaimer": "O telefone deve estar ligado e ter conexão à internet para enviar os textos.", 
    "reply": "Responder", 
    "see_full_history": "Ver histórico completo", 
    "type_link": "Link", 
    "undo": "Desfazer", 
    "learn_more": "Saiba mais", 
    "option_show_mirrors_desc": "Desmarcar isto fará com que as notificações não sejam mostradas (mas ainda poderá consulta-las no ícone da barra de ferramentas).", 
    "push_label": "Envio", 
    "option_play_sound_desc": "Isto faz com que o Pushbullet alerte você ao chegar uma notificação, tocando um som curto.", 
    "devices_placeholder": "Selecione um dispositivo", 
    "sending": "Enviando...", 
    "option_background_permission": "Manter o Pushbullet executando com o navegador fechado", 
    "reply_limit_reached": "Você alcançou o limite de mensagens gratuitas nesse mês.", 
    "decryption_failed_title": "Falha na descriptografia", 
    "push_context_message": "{1} às {2}", 
    "options": "Configurações", 
    "option_background_permission_desc": "Permite que você veja suas notificações sem precisar ter uma janela do navegador aberta.", 
    "mirror_context_message": "{1} via Pushbullet às {2}", 
    "encryption_password_needed_title": "Dados criptografados recebidos", 
    "option_automatically_attach_link_desc": "Isto faz o envio links para dispositivos mais rápido.", 
    "how_to_unmute_app_answer": "Abra o app do Pushbullet no Android, puxe a gaveta da esquerda e depois toque em 'Espelhamento'. Toque em, 'apenas para alguns apps' e, em seguida, re-habilite o app.", 
    "device": "Dispositivo", 
    "done": "Feito", 
    "cancel": "Cancelar", 
    "snoozed_until": "Silenciado até {1}.", 
    "sign_out": "Encerrar sessão", 
    "from": "De {1}", 
    "panel_cant_sign_in": "Não consegue logar? Tente desativar temporariamente o Adblock. Se isso não ajudar, o Pushbullet requer cookies de terceiros para habilitar o login. Você pode desativá-los novamente depois de entrar.", 
    "option_allow_instant_push_desc": "Enviar a aba atual para o dispositivo escolhido através de um atalho de teclado.", 
    "option_show_notification_count": "Mostrar número de notificações no ícone da barra de ferramentas", 
    "reply_limit_warning": "Você está se aproximando do limite de mensagens gratuitas mensais.", 
    "option_show_context_menu_desc": "Mostra o Pushbullet no menu que surge ao clicar com o botão direito do mouse.", 
    "panel_third_party_cookies": "Clique aqui aprender a alterar esta configuração.", 
    "option_show_mirrors": "Mostrar notificações no meu computador.", 
    "notifications": "Notificações", 
    "option_use_dark_icon": "Usar ícone escuro", 
    "add_a_friend": "+ Adicionar amigo", 
    "option_allow_instant_push": "Habilitar envio instantâneo para", 
    "option_instant_push_shortcuts": "Clique aqui para definir (atualmente {1}).", 
    "option_open_my_pushes_automatically": "Abrir automaticamente o que eu enviar a este navegador.", 
    "me": "Eu", 
    "file_too_big": "Arquivo muito grande", 
    "option_clipboard_permission": "Copiar e colar universal", 
    "pushed_successfully": "Enviado com sucesso", 
    "devices": "Dispositivos", 
    "option_show_notification_count_desc": "Veja de relance quantas notificações possui na sua barra de ferramentas.", 
    "add_a_device": "+ Adicionar dispositivo", 
    "end_to_end_password_desc": "Se você optar por inserir uma senha, essa senha será necessária em cada um dos seus dispositivos.", 
    "general": "Geral", 
    "reply_limit_upgrade": "Atualize para o Pushbullet Pro para enviar mensagens ilimitadas.", 
    "message_placeholder_files": "Digite uma mensagem ou solte um arquivo", 
    "option_clipboard_permission_desc": "Copie o texto em um dispositivo e, em seguida, cole em qualquer outro que também tem essa configuração habilitada.", 
    "no_pushes": "Nenhuma história recente", 
    "push_failed": "Desculpe, não conseguimos enviar isso", 
    "option_notification_duration": "Ocultar notificações automaticamente após", 
    "new_sms_thread": "Nova mensagem de texto", 
    "dismiss": "Dispensar", 
    "decryption_failed_body": "Por favor, confirme se sua senha corresponde em todos os dispositivos", 
    "sign_in": "Iniciar sessão", 
    "go_to_link": "Ir para link", 
    "snooze": "Adiar 1 h", 
    "friends": "Amigos", 
    "num_new_messages": "{1} mensagens novas", 
    "remove_link_tooltip": "Remover ligação para esta página", 
    "phone": "Telefone", 
    "mute_app": "Desativar notificações de {1}", 
    "clear": "Limpar", 
    "end_to_end_password_label": "Senha criptografada de ponta a ponta", 
    "add_link_tooltip": "Link da página atual", 
    "option_only_show_titles_desc": "Isto fará o Pushbullet mostrar apenas o título das notificações, mantendo a mensagem privada.", 
    "all_of_my_devices": "Todos os meus dispositivos", 
    "unsubscribe_from_channel": "Deixar de seguir {1}", 
    "updated_notif_title": "O Pushbullet atualizou!"
}; 
strings["gl"] = {
    "mute": "Silenciar", 
    "thanks_for_installing_message": "Toca aquí para conectarte", 
    "option_open_my_pushes_automatically_desc": "Isto fará que Pushbullet abra automaticamente nunha nova lapela do navegador calquera cousa que se envíe.", 
    "unsubscribed_from_channel": "Xa non sigo a {1}", 
    "option_show_context_menu": "Mostrar Pushbullet no menú contextual", 
    "option_use_dark_icon_desc": "Isto converte a nosa icona na barra de ferramentas a un gris escuro.", 
    "alert_desktop_app_notifications": "O aplicativo de escritorio de Pushbullet está xestionando as notificacións. Se deshabilitas as notificacións en Axustes, devolverás o control á extensión.", 
    "sms_recipient_placeholder": "Contacto ou número de teléfono", 
    "message_placeholder_link": "Engade unha mensaxe, toca Intro para enviar", 
    "unsnooze": "Anular suspensión", 
    "encryption_password_needed_body": "Preme aquí para inserir o teu contrasinal", 
    "send": "Enviar", 
    "pushbullet_pro_feature": "É necesario Pushbullet Pro para activar esta funcionalidade.", 
    "save": "Gardar", 
    "option_instant_push_shortcuts_not_set": "sen definir", 
    "send_failed": "Erro ao enviar", 
    "muted_app": "Silenciadas {1}", 
    "now": "Agora", 
    "no_notifications": "Ningunha notificación de momento", 
    "advanced": "Avanzado", 
    "channels": "Canles", 
    "option_automatically_attach_link": "Anexar automaticamente a lapela actual ás mensaxes para un dispositivo", 
    "changelog_tab": "Novidades", 
    "snoozing_desc": "Suspender as notificacións evita que Pushbullet as mostre durante unha hora.", 
    "thanks_for_installing_title": "Grazas por instalares Pushbullet", 
    "how_to_unmute_app": "Silenciei un aplicativo, como o volvo activar?", 
    "title_placeholder": "Título", 
    "message_placeholder": "Escribe unha mensaxe e preme Intro para enviar", 
    "updated_notif_message": "Toca aquí para ver as novidades", 
    "unmute_app": "Desactivar silencio {1}", 
    "type_file": "Ficheiro", 
    "panel_sign_up": "Acceder a Pushbullet.com →", 
    "pushbullet_pro_required": "Requírese Pushbullet Pro", 
    "url_placeholder": "URL da ligazón", 
    "recipient_placeholder": "Para", 
    "retry": "Volver tentar", 
    "option_play_sound": "Reproducir un son cando chegue unha notificación", 
    "sms": "SMS", 
    "option_only_show_titles": "Mostrar só o título das notificacións", 
    "sms_disclaimer": "O teléfono debe estar aceso e ter conexión a internet para poder enviar os textos.", 
    "reply": "Responder", 
    "see_full_history": "Ver historial completo", 
    "type_link": "Ligazón", 
    "undo": "Desfacer", 
    "learn_more": "Saber máis", 
    "option_show_mirrors_desc": "Ao desmarcar isto provocará que non che mostremos notificacións (aínda así verás un contador na barra de ferramentas).", 
    "push_label": "Envío", 
    "option_play_sound_desc": "Isto fai que Pushbullet reproduza un son breve de aviso cando chega unha notificación.", 
    "devices_placeholder": "Selecciona un dispositivo", 
    "sending": "Enviando...", 
    "option_background_permission": "Manter Pushbullet executándose ao pechar o navegador", 
    "reply_limit_reached": "Alcanzaches o máximo mensual de mensaxes gratuítas.", 
    "decryption_failed_title": "Erro na descifraxe", 
    "push_context_message": "{1} ás {2}", 
    "options": "Axustes", 
    "option_background_permission_desc": "Isto permitirache ver as notificacións sen ter que manter unha xanela do navegador aberta.", 
    "mirror_context_message": "{1} vía Pushbullet ás {2}", 
    "encryption_password_needed_title": "Datos cifrados recibidos", 
    "option_automatically_attach_link_desc": "Isto acelera os envíos de ligazóns a dispositivos.", 
    "how_to_unmute_app_answer": "Abre Pushbullet en Android, arrastra o caixón desde a esquerda, toca \"Sincronizando\". Aquí, toca en \"Só para algúns aplicativos\" e despois reactiva a app.", 
    "device": "Dispositivo", 
    "done": "Feito", 
    "cancel": "Cancelar", 
    "snoozed_until": "Suspensión ata {1}.", 
    "sign_out": "Desconectarse", 
    "from": "De {1}", 
    "panel_cant_sign_in": "Non podes acceder? Proba a deshabilitar Adblock temporalmente. Se isto non funciona, Pushbullet necesita que estean habilitadas as cookies de terceiros para poder acceder. Podes volver a deshabilitalas unha vez que accedas.", 
    "option_allow_instant_push_desc": "Enviar a lapela actual ao dispositivo elixido mediante un atallo de teclado.", 
    "option_show_notification_count": "Mostrar o número de notificacións na icona da barra de ferramentas", 
    "reply_limit_warning": "Estás a piques de chegar ao máximo mensual de mensaxes gratis.", 
    "option_show_context_menu_desc": "Mostrar Pushbullet na listaxe de opcións do menú do botón dereito do rato.", 
    "panel_third_party_cookies": "Toca aquí para ver como cambia este axuste.", 
    "option_show_mirrors": "Mostrar notificacións no meu ordenador.", 
    "notifications": "Notificacións", 
    "option_use_dark_icon": "Utilizar icona escura", 
    "add_a_friend": "+ Engadir unha amizade", 
    "option_allow_instant_push": "Activar os envíos instantáneos", 
    "option_instant_push_shortcuts": "Toca aquí para definir (actualmente {1}).", 
    "option_open_my_pushes_automatically": "Abrir automaticamente todo o que se envie a este navegador.", 
    "me": "Eu", 
    "file_too_big": "Ficheiro demasiado grande", 
    "option_clipboard_permission": "Copiar e pegar universal", 
    "pushed_successfully": "Enviado satisfactoriamente", 
    "devices": "Dispositivos", 
    "option_show_notification_count_desc": "Ver o número de notificacións dunha ollada á barra de ferramentas.", 
    "add_a_device": "+ Engadir un dispositivo", 
    "end_to_end_password_desc": "Se elixes inserir un contrasinal, haberá que introducilo en cada un dos dispositivos.", 
    "general": "Xeral", 
    "reply_limit_upgrade": "Actualizar a Pushbullet Pro para enviar mensaxes ilimitadas.", 
    "message_placeholder_files": "Escribe unha mensaxe ou arrastra un ficheiro", 
    "option_clipboard_permission_desc": "Copia texto nun dispositivo, logo pégao en calquera outro que tamén teña esta opción activada.", 
    "no_pushes": "Sen historial recente", 
    "push_failed": "Sentímolo, non puidemos enviar iso", 
    "option_notification_duration": "Agochar automaticamente as notificacións despois de", 
    "new_sms_thread": "Nova mensaxe de texto", 
    "dismiss": "Descartar", 
    "decryption_failed_body": "Por favor, confirma que o contrasinal coincide en todos os dispositivos", 
    "sign_in": "Conectarse", 
    "go_to_link": "Ir á ligazón", 
    "snooze": "Atrasar 1 hora", 
    "friends": "Amizades", 
    "num_new_messages": "{1} mensaxes novas", 
    "remove_link_tooltip": "Desligar páxina actual", 
    "phone": "Teléfono", 
    "mute_app": "Silenciar {1} notificacións", 
    "clear": "Limpar", 
    "end_to_end_password_label": "Cifraxe do contrasinal completa", 
    "add_link_tooltip": "Ligazón da páxina actual", 
    "option_only_show_titles_desc": "Isto fará que Pushbullet mostre unicamente o título das notificacións mantendo a mensaxe en privado.", 
    "all_of_my_devices": "Todos os meus dispositivos", 
    "unsubscribe_from_channel": "Deixar de seguir a {1}", 
    "updated_notif_title": "Actualizouse Pushbullet!"
}